
(****************************************************************************)
(* Box-Aufrumunit fr MCUT.                                                *)
(*                                                                          *)
(* Die Unit sollte als Overlay deklariert werden.                           *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(* IAD, mai 96                                                              *)
(****************************************************************************)

{         BOXGARB.PAS
Garbage-Routine. Erledigt bis jetzt folgendes:

  - MYBBS-Angaben aus Rubrik M 'rauslesen und in USER.BOX abspeichern
  - Gelschte Mails entgltig gelscht
  - Bei Rubriken, in denen alle Mails gelscht sind, wird das Index-File
    gelscht
}
UNIT BOXGARB;

INTERFACE

(* Wenn MELDUNG=TRUE, dann wird auf Kanal ch eine Meldung ausgegeben
*)


PROCEDURE Garbage(ch: BYTE; Meldung: BOOLEAN);


IMPLEMENTATION

USES BOXVARS,DOS,IADVAR,BOXUTIL,TOOLBOX,BOXSTART,BOXHUSER,CRT;

VAR data:TBidHashRec;
    stat_M:WORD;
    stat_Erase:LONGINT;
    stat_Hold:LONGINT;
    stat_user:LONGINT;
    stat_info:LONGINT;
    stat_gesamt:LONGINT;
    stat_hash_collisions:WORD;
    stat_lt_abgel:LONGINT;
    stat_lt_bytes:LONGINT;
    stat_erase_bytes:LONGINT;
    stat_fwd_sent:LONGINT;
    stat_fwd_tosend:LONGINT;
    stat_fwd_send_bytes:LONGINT;
    stat_fwd_tosend_bytes:LONGINT;
    stat_fwd_sent_einzeln:ARRAY[0..32] OF LONGINT;
    stat_fwd_tosend_einzeln:ARRAY[0..32] OF LONGINT;
    stat_fwd_sent_einzeln_bytes:ARRAY[0..32] OF LONGINT;
    stat_fwd_tosend_einzeln_bytes:ARRAY[0..32] OF LONGINT;

    start:LONGINT;
    biguserboards:STRING;


{M-Files aus Rubrik M auslesen, in USER.BOX abspeichern und in Rubrik M
 lschen}

PROCEDURE SaveM_Files(ch: BYTE; Meldung: BOOLEAN);
TYPE New_DT = RECORD
       Year, Month, Day, Hour, Min, Sec: BYTE;
     END;
VAR M_File: FILE OF Verwalt_Rec;
    M: Verwalt_Rec;
    U: R_UserFile;
    Time,TimeRead: LONGINT;             {Datum, das inner Mail im Titel
                                         steht, in Unix-Time}
    BoxCall: str6;                      {Rufzeichen der Mailbox}
    aword,code: WORD;
    Found: BOOLEAN;
    DT: DateTime;
    N_DT: New_DT;
BEGIN
   ASSIGN(M_File,BoxPath+'index'+PATH_SEP+'m.idx');
  {$I-}
  RESET(M_File);
  IF IOResult>0 THEN BEGIN
    ProfileBOX('IOFail: BOXGARB RESET M_FILE',PBOX_IOERROR);
    Exit;
  END;
  WHILE NOT EOF(M_File) DO BEGIN
    READ(M_File,M);
       {ungelscht}
    IF IORESULT>0 THEN
      ProfileBOX('IOFail: BOXGARB READ M_FILE',PBOX_IOERROR);
    IF (M.Flags AND VERWALT_DEL=0) AND (POS(' ',M.Titel)>0) THEN BEGIN
      VAL(COPY(M.Titel,POS(' ',M.Titel)+1,255),Time,code);
      IF code=0 THEN BEGIN
        BoxCall := COPY(M.Titel,1,POS(' ',M.Titel)-1);
        IF Pack2Unix(GetLastMybbs(m.absender))<time THEN
        BEGIN
          inc(stat_m);
          Set_LastMybbs(m.absender,Unix2Pack(time));
          Set_MyBBS(m.absender,boxcall);
        END;
      END;
    END;
  END;
  CLOSE(M_File);
  IF IORESULT>0 THEN
    ProfileBOX('IOFail: BOXGARB CLOSE M_FILE',PBOX_IOERROR);
  ERASE(M_File);
  IF IORESULT>0 THEN
    ProfileBOX('IOFail: BOXGARB ERASE M_FILE',PBOX_IOERROR);
END;


{Als gelscht markierte Files wirklich lschen und das Index-File aufrumen}
PROCEDURE Del_Marked_Files(ch: BYTE; Meldung: BOOLEAN);
VAR IdxFile: FILE OF Verwalt_Rec;
    Idx: Verwalt_Rec;
    f: Text;
    SR: SearchRec;
    DeleteIdxFile: BOOLEAN;
    SI,DI: LONGINT; fehler:BOOLEAN;
BEGIN
  FindFirst(BoxPath+'index'+PATH_SEP+'*.idx',$3F-$10-$08,SR);
  FreeDirInfo;
  WHILE doserror=0 DO BEGIN
    INC(AnzRub);
    New(DirInfo[anzrub]);
    DirInfo[AnzRub]^.Rubrik := COPY(SR.Name,1,POS('.',SR.Name)-1);
    DirInfo[AnzRub]^.Mails := 0;
    ASSIGN(IdxFile,BoxPath+'index'+PATH_SEP+SR.Name);
    {$I-}
    RESET(IdxFile);

    IF IOResult=0 THEN BEGIN
      SI := 0;
      DI := 0;
      data.rubrik:=copy(sr.name,1,length(sr.name)-4);
      data.check_file_pos:=0;
      WHILE NOT EOF(IdxFile) DO BEGIN
        SEEK(IdxFile,SI);
        IF IORESULT>0 THEN
          ProfileBOX('IOFail: BOXGARB SEEK IDX_FILE',PBOX_IOERROR);
        IF NOT EOF(IdxFile) THEN BEGIN
          READ(IdxFile,Idx);
          IF IORESULT>0 THEN
            ProfileBOX('IOFail: BOXGARB READ IDX_FILE',PBOX_IOERROR);
          INC(SI);
          ASSIGN(f,BoxPath+Idx.FileName);
          {$I-}
          SetFAttr(F,archive);

          FEHLER:=(IORESULT <> 0);
          IF FEHLER THEN
            ProfileBOX('IOFail: BOXGARB SetFAttr MAIL_FILE',PBOX_IOERROR);
          Reset(f);
          IF IORESULT<>0 THEN FEHLER:=TRUE ELSE
          BEGIN
            FEHLER:=FALSE; close(f);
          END;
          IF ((Idx.Flags AND VERWALT_DEL)<>0) OR Fehler THEN BEGIN
            Data.idx_file_pos:=0;
              IF NOT BidHash^.SetData(idx.bid,data) THEN
               BidHash^.InsertData(idx.bid,data);
            inc(stat_erase);
            inc(stat_erase_bytes,idx.groesse);
            {$I-}
            ERASE(f);
            IF IORESULT>0 THEN
              ProfileBOX('IOFail: BOXGARB ERASE MAIL_FILE',PBOX_IOERROR);

            IF IOResult=0 THEN BEGIN END;
          END
          ELSE BEGIN
            IF idx.flags and VERWALT_HOLD>0 THEN
              inc(stat_hold);
            SEEK(IdxFile,DI);
            (* Hier wird nun die Lifetime kontrolliert:
             * ein tag hat 86400 sekunden, schon gewusst?
             *)
            IF (round((currixtime-(pack2unix(idx.rx_datum)))/86400)>idx.lifetime) THEN
            BEGIN
              idx.flags:=idx.flags OR verwalt_del;
              stat_lt_bytes:=stat_lt_bytes + idx.groesse;
              inc(stat_lt_abgel);
            END;
            INC(DirInfo[AnzRub]^.Mails);
            WRITE(IdxFile,Idx);
            INC(DI);
            Data.idx_file_pos:=DI;
              IF NOT BidHash^.SetData(idx.bid,data) THEN
                BidHash^.InsertData(idx.bid,data);
          END;
        END;
      END;

      SEEK(IdxFile,DI);
      IF IORESULT>0 THEN
        ProfileBOX('IOFail: BOXGARB SEEK IDX_FILE',PBOX_IOERROR);

      TRUNCATE(IdxFile);
      IF IORESULT>0 THEN
        ProfileBOX('IOFail: BOXGARB TRUNCATE IDX_FILE',PBOX_IOERROR);

      IF FILESIZE(IdxFile)=0 THEN DeleteIdxFile := TRUE
                             ELSE DeleteIdxFile := FALSE;
      CLOSE(IdxFile);
      IF IORESULT>0 THEN
        ProfileBOX('IOFail: BOXGARB CLOSE IDX_FILE',PBOX_IOERROR);

      IF DeleteIdxFile THEN ERASE(IdxFile);
      IF IORESULT>0 THEN
        ProfileBOX('IOFail: BOXGARB ERASE IDX_FILE',PBOX_IOERROR);

      IF Rufz(DirInfo[AnzRub]^.Rubrik) THEN DirInfo[AnzRub]^.Art := 'U'
                                       ELSE DirInfo[AnzRub]^.Art := 'I';

      IF DirInfo[AnzRub]^.Mails = 0 THEN BEGIN
        DISPOSE(DirInfo[AnzRub]);
        AnzRub := AnzRub - 1;
      END;
    END ELSE
      ProfileBOX('IOFail: BOXGARB RESET IDX_FILE',PBOX_IOERROR);
    FindNext(SR);
  END;
END;



PROCEDURE SortInfo_stn;
VAR InfoFile: FILE OF Stn_Rec;
    Info: Stn_Rec;
BEGIN
   ASSIGN(InfoFile,BoxPath+'info.stn');
  {$I-}
  RESET(InfoFile);

  IF IOResult<>0 THEN
  BEGIN
    ProfileBOX('IOFail: BOXGARB RESET INFOSTN_FILE',PBOX_IOERROR);
    Exit;
  END;
  CLOSE(InfoFile);
END;


PROCEDURE DelEmptyFilesInCHECKFile;
VAR Checkfile: FILE OF CheckRec;
    Check: CheckRec;
    SI,DI: LONGINT;
BEGIN
   ASSIGN(CheckFile,BoxPath+'check.box');
  {$I-}
  RESET(CheckFile);

  IF IOResult<>0 THEN
  BEGIN
    IF IORESULT>0 THEN
      ProfileBOX('IOFail: BOXGARB RESET CHECK_FILE',PBOX_IOERROR);
    Exit;
  END;
  SI := 0;
  DI := 0;

  WHILE NOT EOF(CheckFile) DO BEGIN
    SEEK(CheckFile,SI);
    IF IORESULT>0 THEN
      ProfileBOX('IOFail: BOXGARB SEEK CHECK_FILE',PBOX_IOERROR);

    IF NOT EOF(CheckFile) THEN BEGIN
      READ(CheckFile,Check);
      IF IORESULT>0 THEN
        ProfileBOX('IOFail: BOXGARB READ CHECK_FILE',PBOX_IOERROR);

      inc(SI);
      BidHash^.GetData(check.bid,@data);
      Check.nr:=data.idx_file_pos;
         {ungelscht}
      IF (Check.Flags AND CHECK_DEL=0) AND (data.idx_file_pos>0) THEN BEGIN
        data.check_file_pos:=DI+1;
        IF NOT BidHash^.SetData(check.bid,data) THEN
          BidHash^.InsertData(check.bid,data);
        SEEK(CheckFile,DI);
        WRITE(CheckFile,Check);
        IF IORESULT>0 THEN
          ProfileBOX('IOFail: BOXGARB SEEK/WRITE CHECK_FILE',PBOX_IOERROR);

        inc(DI);
      END;
    END;
  END;

  SEEK(CheckFile,DI);
  TRUNCATE(CheckFile);
  IF IORESULT>0 THEN
    ProfileBOX('IOFail: BOXGARB SEEK/TRUNCATE CHECK_FILE',PBOX_IOERROR);

  CLOSE(CheckFile);
  IF IORESULT>0 THEN
    ProfileBOX('IOFail: BOXGARB CLOSE CHECK_FILE',PBOX_IOERROR);

END;



PROCEDURE DelDeletedSFLIST;
VAR SFFile: FILE OF SF_File_Rec;
    SFDS: SF_File_Rec;
    SI,DI: LONGINT;
    sfptr:pBoxSF;
    sfnr:BYTE;
BEGIN
  ASSIGN(SFFile,BoxPath+'sfliste');
  {$I-}
  RESET(SFFile);

  IF IOResult<>0 THEN
  BEGIN
    IF IORESULT>0 THEN
      ProfileBOX('IOFail: BOXGARB RESET SFLISTE',PBOX_IOERROR);
    Exit;
  END;
  SI := 0;
  DI := 0;

  WHILE NOT EOF(SFFile) DO BEGIN
    SEEK(SFFile,SI);
    IF IORESULT>0 THEN
      ProfileBOX('IOFail: BOXGARB SEEK SFLISTE',PBOX_IOERROR);
    IF NOT EOF(SFFile) THEN BEGIN
      READ(SFFile,SFDS);
      IF IORESULT>0 THEN
        ProfileBOX('IOFail: BOXGARB READ SFLISTE',PBOX_IOERROR);
      inc(SI);
      (* hier berprfe ich, ob das file durch abgelaufene lifetime
         bereits verschwunden ist
      *)
      BidHash^.GetData(SFDS.BID,@data);
         {ungelscht}
      IF (SFDS.Flags AND SFLISTE_DEL=0) AND (data.idx_file_pos>0) THEN BEGIN
        sfptr:=BoxSFroot;
        sfnr:=0;
        WHILE (SFptr<>NIL) and (sfptr^.call<>sfds.sf_partner) DO
        BEGIN
          inc(sfnr);
          sfptr:=sfptr^.next;
        END;
        IF sfptr<>NIL THEN
        BEGIN
          inc(stat_fwd_tosend_einzeln[sfnr]);
          inc(stat_fwd_tosend_einzeln_bytes[sfnr],sfds.groesse);
        END;
        SEEK(SFFile,DI);
        WRITE(SFFile,SFDS);
        inc(DI);
      END ELSE
      BEGIN
        sfptr:=BoxSFroot;
        sfnr:=0;
        WHILE (SFptr<>NIL) and (sfptr^.call<>sfds.sf_partner) DO
        BEGIN
          inc(sfnr);
          sfptr:=sfptr^.next;
        END;
        IF sfptr<>NIL THEN
        BEGIN
          inc(stat_fwd_sent_einzeln[sfnr]);
          inc(stat_fwd_sent_einzeln_bytes[sfnr],sfds.groesse);
        END;

      END;
    END;
  END;

  SEEK(SFFile,DI);
  TRUNCATE(SFFile);
  IF IORESULT>0 THEN
    ProfileBOX('IOFail: BOXGARB SEEK/TRUNCATE SFLISTE',PBOX_IOERROR);
  CLOSE(SFFile);
  IF IORESULT>0 THEN
    ProfileBOX('IOFail: BOXGARB CLOSE SFLISTE',PBOX_IOERROR);
END;



{Schreibt eine Mailbox-Statistik in die Rubrik X (Systemmeldungen)}
PROCEDURE MakeSystemStatistics;
VAR f,f2: Text;
    DT: DateTime;
    aword: WORD;
    lint: LONGINT;
    Bytes,BytesGes,Mails,MailsGes: LONGINT;
    SR,SR_Dir: SearchRec;
    S,Hlp: STRING;
    erasedir:file;
    dummy:byte;
    sfptr:pBoxSF;
    sfnr:BYTE;
    af:FILE; attr:WORD;
BEGIN
  Lint:=Unix2Pack(CurrIxTime);

  ASSIGN(f,BoxPath+'import'+PATH_SEP+FindUniqueImportFilename);
  {$I-}
  REWRITE(f);

  IF IOResult<>0 THEN
  BEGIN
    IF IORESULT>0 THEN
     ProfileBOX('IOFail: BOXGARB REWRITE SYSTEM_STAT_FILE',PBOX_IOERROR);
    Exit;
  END;
  {Kopf der Mail schreiben}
  WRITELN(f,'S '+OwnboXdata^.system_msg_to+' < '+CutSSID(BoxCall));
  WRITELN(f,'Board Statistics '+Pack2STRDate(lint)+' '+Pack2STRTime(lint));
  WRITELN(f);
  WRITELN(f);
  WRITELN(f);
  WRITELN(f,'   INFO-Files');
  WRITELN(f);
  WRITELN(f,'   Area     Mails      Bytes');
  WRITELN(f,'========================================================');

    IF IORESULT>0 THEN
     ProfileBOX('IOFail: BOXGARB WRITE SYSTEM_STAT_FILE',PBOX_IOERROR);

  BytesGes := 0;
  MailsGes := 0;

  FindFirst(BoxPath+'info'+PATH_SEP+'*.*',$10,SR_Dir);
  WHILE Doserror=0 DO BEGIN
    Bytes := 0;
    Mails := 0;
    {$IFNDEF LINUX} 
    FindFirst(BoxPath+'info'+PATH_SEP+SR_Dir.Name+PATH_SEP+'*.*',$3F-$10-$8,SR);
    WHILE doserror=0 DO BEGIN
      IF (SR_Dir.Name[1]<>'.') AND ((SR.ATTR AND directory)=0) THEN BEGIN
        Bytes := Bytes + SR.Size;
        (*
         * Oben in "Marked_Files" werden bei allen Dateien, auf die in
         * Index-Files verwiesen wird, das archive-bit gesetzt.
         * Deswegen knnen jetzt alle Dateien, die kein archive-bit
         * haben, gelscht werden. Damit entferne ich Dateileichen.
         *
         * iad, feb 96
         *)
        ASSIGN(af,BoxPath+'info'+PATH_SEP+SR_Dir.Name+PATH_SEP+SR.name);
        GetFATTR(af,attr);
        IF (attr and archive)=0 THEN
          Erase(af);
        SetFATTR(af,0);
        inc(Mails);
      END;
      FindNext(SR);
    END;
    {$ENDIF}
    (* so jetzt kommt quick+dirty, einfach mal ein ein rmdir auf
       die rubrik loslassen, wenn sie leer war, ist sie wech, ansonsten
       wirds DOS schon abfangen.... *)
    {$I-}
    rmdir(boxpath+'info'+PATH_SEP+SR_Dir.name);
    dummy:=ioresult;
    {So, diese Rubrik wurde durchgescannt - Zeile schreiben}
    IF SR_Dir.Name[1]<>'.' THEN BEGIN
      S := ' ' + SR_Dir.Name;
      FOR aword := 0 TO 10 DO IF LENGTH(S)=aword THEN S := S + ' ';
      STR(Mails,Hlp);
      FOR aword := 0 TO 4 DO IF LENGTH(Hlp)=aword THEN Hlp := ' ' + Hlp;
      S := S + Hlp + '  ';
      STR(Bytes,Hlp);
      FOR aword := 0 TO 7 DO IF LENGTH(Hlp)=aword THEN Hlp := ' ' + Hlp;
      S := S + Hlp;
      WRITELN(f,S);

      BytesGes := BytesGes + Bytes;
      MailsGes := MailsGes + Mails;
    END;
    FindNext(SR_Dir);
  END;

  WRITELN(f);
  STR(BytesGes,Hlp);
  FOR aword := 0 TO 8 DO IF LENGTH(Hlp)=aword THEN Hlp := ' ' + Hlp;
  WRITELN(f,'Bytes: '+Hlp);
  STR(MailsGes,Hlp);
  FOR aword := 0 TO 6 DO IF LENGTH(Hlp)=aword THEN Hlp := ' ' + Hlp;
  WRITELN(f,'Mails: '+Hlp);

  WRITELN(f); WRITELN(f); WRITELN(f);


  WRITELN(f,'   USER-Files');
  WRITELN(f);
  WRITELN(f,'   Call     Mails      Bytes');
  WRITELN(f,'========================================================');

  BytesGes := 0;
  MailsGes := 0;
  FindFirst(BoxPath+'user'+PATH_SEP+'*.*',$10,SR_Dir);
  WHILE Doserror=0 DO BEGIN
    Bytes := 0;
    Mails := 0;
     {$IFNDEF linux}
    FindFirst(BoxPath+'user'+PATH_SEP+SR_Dir.Name+PATH_SEP+'*.*',$3F-$10-$8,SR);
    WHILE doserror=0 DO BEGIN
      IF (SR_Dir.Name[1]<>'.')  AND ((SR.ATTR AND directory)=0) THEN BEGIN
        Bytes := Bytes + SR.Size;
        inc(Mails);
        (*
         * Oben in "Marked_Files" werden bei allen Dateien, auf die in
         * Index-Files verwiesen wird, das archive-bit gesetzt.
         * Deswegen knnen jetzt alle Dateien, die kein archive-bit
         * haben, gelscht werden. Damit entferne ich Dateileichen.
         *
         * iad, feb 96
         *)
        ASSIGN(af,BoxPath+'user'+PATH_SEP+SR_Dir.Name+PATH_SEP+SR.name);
        GetFATTR(af,attr);
        IF (attr and archive)=0 THEN
          Erase(af);
        SetFATTR(af,0);
      END;
        FindNext(SR);
    END;
{$ENDIF}
    (* so jetzt kommt quick+dirty, einfach mal ein ein rmdir auf
       die rubrik loslassen, wenn sie leer war, ist sie wech, ansonsten
       wirds DOS schon abfangen.... *)
    {$I-}
    rmdir(boxpath+'user'+PATH_SEP+SR_Dir.name);
    dummy:=ioresult;

    {So, diese Rubrik wurde durchgescannt - Zeile schreiben}
    IF SR_Dir.Name[1]<>'.' THEN BEGIN
      S := ' ' + SR_Dir.Name;
      FOR aword := 0 TO 10 DO IF LENGTH(S)=aword THEN S := S + ' ';
      STR(Mails,Hlp);
      FOR aword := 0 TO 4 DO IF LENGTH(Hlp)=aword THEN Hlp := ' ' + Hlp;
      S := S + Hlp + '  ';
      STR(Bytes,Hlp);
      FOR aword := 0 TO 7 DO IF LENGTH(Hlp)=aword THEN Hlp := ' ' + Hlp;
      S := S + Hlp;
      WRITELN(f,S);

      BytesGes := BytesGes + Bytes;
      MailsGes := MailsGes + Mails;
      IF Bytes>250000 THEN
        biguserboards:=biguserboards+sr_dir.name+' ';
    END;
    FindNext(SR_Dir);
  END;

  WRITELN(f);
  STR(BytesGes,Hlp);
  FOR aword := 0 TO 8 DO IF LENGTH(Hlp)=aword THEN Hlp := ' ' + Hlp;
  WRITELN(f,'Bytes: '+Hlp);
  STR(MailsGes,Hlp);
  FOR aword := 0 TO 6 DO IF LENGTH(Hlp)=aword THEN Hlp := ' ' + Hlp;
  WRITELN(f,'Mails: '+Hlp);
  WriteLn(f,'---------------------------------------------------');
  WriteLn(f,'MCuTBox (c) 1993-1998 DG6VJ&DG4IAD');
  CLOSE(f);
  ASSIGN(f,BoxPath+'import'+PATH_SEP+FindUniqueImportFilename);
  {$I-}
  REWRITE(f);
  IF IOResult<>0 THEN
  BEGIN
    ProfileBOX('IOFail: BOXGARB WRITE SYSTEM_STAT_FILE',PBOX_IOERROR);
    Exit;
  END;

   FindFirst(boxpath+'stats.box',anyfile,sr);
  WRITELN(f,'S '+OwnboXdata^.system_msg_to+' < '+CutSSID(BoxCall));
  WRITELN(f,'Forward Statistics '+Pack2STRDate(lint)+' '+Pack2STRTime(lint));
  WRITELN(f);
  sfptr:=BoxSFroot;
  sfnr:=0;
  WriteLn(f,'BBS           geforwardet       noch zu forwarden');
  WriteLn(f,'           Anzahl     KBytes     Anzahl    KBytes');
  WriteLn(f,'-------------------------------------------------');
  WHILE (SFptr<>NIL) DO
  BEGIN
    Write(f,SFptr^.Call,' ':(10-length(sfptr^.call)));
    Write(f,stat_fwd_sent_einzeln[sfnr]:5,' ':5);
    Write(f,stat_fwd_sent_einzeln_bytes[sfnr] DIV 1024:7,' ':3);
    Write(f,stat_fwd_tosend_einzeln[sfnr]:5,' ':5);
    Write(f,stat_fwd_tosend_einzeln_bytes[sfnr] DIV 1024:7,' ':3);
    WriteLn(f);
    inc(sfnr);
    sfptr:=sfptr^.next;
  END;
  WriteLn(f,'---------------------------------------------------');
  WriteLn(f,'MCuTBox (c) 1993-1998 DG6VJ&DG4IAD');
  CLOSE(f);

  ASSIGN(f,BoxPath+'import'+PATH_SEP+FindUniqueImportFilename);
  {$I-}
  REWRITE(f);
  IF IOResult<>0 THEN
  BEGIN
     ProfileBOX('IOFail: BOXGARB REWRITE SYSTEM_STAT_FILE',PBOX_IOERROR);
    Exit;
  END;
  FindFirst(boxpath+'STATS.BOX',anyfile,sr);
  WRITELN(f,'S '+OwnboXdata^.system_msg_to+' < '+CutSSID(BoxCall));
  WRITELN(f,'Mailbox Statistics '+Pack2STRDate(lint)+' '+Pack2STRTime(lint));
  WRITELN(f);
  WRITELN(f,'Das Garbage dauerte ',currixtime-start,' Sekunden');
  WRITELN(f,'Die Mailbox luft seit ',DTDateStr(Unix2Pack(starttime)),' um ',dttimestr(Unix2Pack(starttime)),'.');
  WRITELN(f,'Das letzte Garbage wurde durchgefhrt am ',dtdatestr(sr.time),' um ',dttimestr(sr.time));
  WRITELN(f,'M-Mails augewertet               : ',stat_m);
  WRITELN(f,'Mails mit abgelaufener Lifetime  : ',stat_lt_abgel,' (',round(stat_lt_bytes/1024),' KB)');
  WRITELN(f,'Mails phys. gelscht             : ',stat_erase,' (',round(stat_erase_bytes/1024),' KB)');
  WRITELN(f,'Mails die noch im HOLD verweilen : ',stat_hold);
  findfirst(boxpath+'CHECK.BOX',anyfile,sr);
  WRITELN(f,'die Check-Liste umfasst derzeit ',sr.size DIV sizeof(checkRec),' Eintrge (',sr.size,' Bytes)');
  WRITELN(f,'In folgenden Userboards befinden sich mehr als 250KB:');
  WRITELN(f,biguserboards);
  WRITELN(f);
  WRITELN(f,'MCuTBox (c) 1993-1998 DG6VJ&DG4IAD');
  CLOSE(f);
   ASSIGN(f2,boxpath+'profile.box');
  {$I-}
  RESET(f2);
  IF IORESULT=0 THEN
  BEGIN
    ASSIGN(f,BoxPath+'import'+PATH_SEP+FindUniqueImportFilename);
    REWRITE(f);
    WRITELN(f,'S '+OwnboXdata^.system_msg_to+' < '+CutSSID(BoxCall));
    WRITELN(f,'PROFILE.BOX '+Pack2STRDate(lint)+' '+Pack2STRTime(lint));
    WRITELN(f);
    WHILE not EOF(f2) DO
    BEGIN
      READLN(f2,s);
      WRITELN(f,s);
    END;
    CLOSE(f2);
    erase(f2);
    CLOSE(f);
  END;
  ASSIGN(f,boxpath+'stats.box');
  REWRITE(f);CLOSE(f);
END;






{Haupt-Routine - Ruft alle Unterroutinen auf}
PROCEDURE Garbage(ch: BYTE; Meldung: BOOLEAN);
VAR B:BYTE;
BEGIN
  IF IORESULT>0 THEN
    ProfileBOX('IOFail: BOXGARB Garbage (Unknown reason)',PBOX_IOERROR);
  IF Meldung THEN PutData(ch,#13+'GARBAGE'+#13#13);
  start:=currixtime;
  biguserboards:='';
  stat_M:=0;
  stat_Erase:=0;
  stat_Hold:=0;
  stat_user:=0;
  stat_info:=0;
  stat_gesamt:=0;
  stat_hash_collisions:=0;
  stat_lt_abgel:=0;
  stat_lt_bytes:=0;
  stat_erase_bytes:=0;
  for B:=0 to 32 DO
  BEGIN
    stat_fwd_sent_einzeln[b]:=0;
    stat_fwd_tosend_einzeln[b]:=0;
    stat_fwd_sent_einzeln_bytes[b]:=0;
    stat_fwd_tosend_einzeln_bytes[b]:=0;
  END;
  SaveM_Files(ch,Meldung);
  Del_Marked_Files(ch,Meldung);
  DelEmptyFilesInCHECKFile;
  DelDeletedSFLIST;
  MakeSystemStatistics;
 {IF Meldung THEN PutData(ch,#13+BoxPrompt(ch));}
END;

END.
