(***************************************************************************)
(**                            UNIT BOXOCMD.PAS                           **)
(***************************************************************************)
(**  Seltener bentigte Mailbox-Befehle, die deshalb als Overlay          **)
(**  deklariert werden knnen.                                            **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
{Box-Befehle, die als Overlay deklariert werden knnen}
UNIT BOXOCMD;

INTERFACE

USES BOXVARS;

PROCEDURE Name(ch: BYTE; S: STRING);
PROCEDURE MSG(c: BYTE; S: STRING);
PROCEDURE BBS_CMD(ch: BYTE; S: STRING);
PROCEDURE MYBBS_CMD(ch: BYTE; S: STRING);
PROCEDURE NewLISTSF(ch: BYTE);
PROCEDURE SF_Poll(ch: BYTE; S: STRING; Meldungen: BOOLEAN);
PROCEDURE BBS_Help(ch: BYTE; S: STRING);
PROCEDURE BOX_INFO(ch: BYTE);
PROCEDURE Spk_CMD(ch: BYTE; S: STRING);
PROCEDURE LT_CMD(ch: BYTE; S: STRING);
PROCEDURE BID_CMD(ch: BYTE; S: STRING);
PROCEDURE DefLT_CMD(ch: BYTE);
PROCEDURE SET_CMD(ch: BYTE; S: STRING);
PROCEDURE KnownUser(ch: BYTE; S: STRING);
PROCEDURE ListSF(ch: BYTE);
PROCEDURE Activity(ch: BYTE);
PROCEDURE Transfer(ch: BYTE; S: STRING);
PROCEDURE Forward_Cmd(ch: BYTE; S: STRING);
PROCEDURE Aktuell(ch: BYTE);
PROCEDURE ListReject(ch: BYTE);
PROCEDURE NotHold_Cmd(ch: BYTE; S: STRING);
PROCEDURE Undelete(ch: BYTE; S: STRING);
PROCEDURE Reload_CMD(ch: BYTE; S:STRING);
PROCEDURE Route_CMD(ch:BYTE; S:STRING);
PROCEDURE Reply_CMD(ch: BYTE);
PROCEDURE Comment_CMD(ch: BYTE);
{$IFDEF EDITOR}
PROCEDURE XReply_CMD(ch: BYTE);
{$ENDIF}
PROCEDURE CONFIG_CMD(ch: BYTE);

IMPLEMENTATION

USES
     BOXHUSER,IADVAR,BOXUTIL,TOOLBOX,DOS,MCUTLIB2,
     BOXSF,BOXHOLD,BOXMAIN,BOXSTART,MYSTRING,BOXSEND
     {$IFDEF EDITOR}
     ,EDITOR
     {$ENDIF}
     ,TERMUSER
     ;


PROCEDURE Name(ch: BYTE; S: STRING);
VAR Nam: STRING;
    Call: STRING[6];
    OK: BOOLEAN;
BEGIN

  IF S[LENGTH(S)]=#13 THEN S := COPY(S,1,LENGTH(S)-1);

  IF POS(' ',S)=0 THEN S := ''
                  ELSE S := COPY(S,POS(' ',S)+1,255);

  IF S='' THEN BEGIN
    Nam := GetName(OK,ch);
    IF OK THEN BEGIN
      IF Nam='' THEN PutData(ch,SysText(ch,9)+#13#13)
                ELSE PutData(ch,SysText(ch,10)+' '+Nam+#13#13);
    END
    ELSE PutData(ch,SysText(ch,16)+#13#13);
    Exit;
  END;

  IF KS[ch]^.Lev < 10 THEN BEGIN
    Nam := S;
    Call := Gross(CutSSID(KS[ch]^.Call));
  END
  ELSE BEGIN
    IF POS(' ',S)>0 THEN BEGIN
      Call := Gross(COPY(S,1,POS(' ',S)-1));
      Nam := COPY(S,POS(' ',S)+1,255);
    END
    ELSE BEGIN
      Nam := S;
      Call := Gross(CutSSID(KS[ch]^.Call));
    END;
  END;
  Set_Name(Call,Nam);
  IF Call <> CutSSID(KS[ch]^.Call) THEN PutData(ch,'OK, '+Nam+' als Name von '+Call+' eingetragen.'+#13#13)
                                   ELSE PutData(ch,'OK, '+Nam+' '+SysText(ch,11)+#13#13);
END;


{MSG-Befehl - Nachricht an einen User schicken}
PROCEDURE MSG(c: BYTE; S: STRING);
VAR Call: STRING[6];
    CallOK: BOOLEAN;
    CallPort: BYTE;
    b: BYTE;
BEGIN
  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                    ELSE S := '';

  IF (S='') OR (POS(' ',S)=0) THEN BEGIN
    PutData(c,'Syntax:'+#13+'MSG <Call> <Text>'+#13#13);
    Exit;
  END;

  Call := Gross(CutSSID(COPY(S,1,POS(' ',S)-1)));
  S := COPY(S,POS(' ',S)+1,255);

  {Gucken, ob CALL eingeloggt ist}
  CallOK := FALSE;
  FOR b := 0 TO 255 DO BEGIN
    IF KS[b] <> NIL THEN BEGIN
      IF (KS[b]^.status=50) AND (c<>b) THEN BEGIN
        IF Call = CutSSID(KS[b]^.Call) THEN BEGIN
          CallOK := TRUE;
          CallPort := b;
        END;
      END;
    END;
  END;

  IF NOT CallOK THEN BEGIN
    PutData(c,'MSG: '+Call+' '+SysText(c,38)+#13#13);
    Exit;
  END;

  IF KS[CallPort]^.BoxData^.status <> 0 THEN BEGIN
    PutData(c,'MSG: '+Call+' is busy - pse try later again'+#13#13);
    Exit;
  END;

  PutData(CallPort,#13+'*'+CutSSID(KS[c]^.Call)+'*:'+S+#13#13+BoxPrompt(CallPort));
  PutData(c,'MSG sent to '+Call+#13#13);

END;



PROCEDURE GivePath(Call: str6;c:BYTE);
LABEL Schleife;
VAR Rufzeich: ARRAY[1..100] OF STRING[6];
    AktRufz: STRING[6];
    Info: Stn_Rec;
    InfoFile: FILE OF Stn_Rec;
    Akt,i,k: INTEGER;
    STRG: STRING;
BEGIN
   ASSIGN(InfoFile,BOXPATH+'info.stn');
  {$I-}
  RESET(InfoFile);
  {$I+}
  IF IOResult <> 0 THEN Exit;
  FOR i := 1 TO 100 DO Rufzeich[i] := '';
  Akt := 2;
  Info.Call := '';
  WHILE NOT EOF(InfoFile) AND NOT (Info.Call=Call) DO READ(InfoFile,Info);
  IF EOF(InfoFile) AND NOT (Info.Call=Call) THEN BEGIN
    CLOSE(InfoFile);
    Exit;
  END;
  AktRufz := Info.RXFrom;
  Rufzeich[1] := Info.Call;

  WHILE AktRufz<>CutSSID(BoxCall) DO BEGIN
    SEEK(InfoFile,0);
    WHILE NOT EOF(InfoFile) AND NOT (Info.Call=AktRufz) DO BEGIN
      READ(InfoFile,Info);
    END;
    IF EOF(InfoFile) THEN BEGIN
      AktRufz := CutSSID(BoxCall);
      Rufzeich[Akt] := '?????';
      Akt := Akt + 1;
    END
    ELSE BEGIN
      AktRufz := Info.RXFrom;
      Rufzeich[Akt] := Info.Call;
      FOR i := 1 TO Akt-1 DO BEGIN
        IF Info.Call=Rufzeich[i] THEN BEGIN
          Rufzeich[Akt] := '?????';
          Akt := Akt + 1;
          GOTO Schleife;
        END;
      END;
      Akt := Akt + 1;
    END;
  END;
  Schleife:
  Rufzeich[Akt] := CutSSID(BoxCall);
  STRG := '';
  k := 0;
  PutData(c,'Path      : ');
  FOR i := 1 TO Akt DO BEGIN
    STRG := STRG + Rufzeich[i]+' ';
    k := k + 1;
    IF k = 8 THEN BEGIN
      PutData(c,STRG+#13);
      STRG := '            ';
      k := 0;
    END;
  END;
  CLOSE(InfoFile);
  PutData(c,STRG+#13);
END;


PROCEDURE BBS_CMD(ch: BYTE; S: STRING);
VAR Info: Stn_Rec;
    InfoFile: FILE OF Stn_Rec;
    k,i,Anz,Anzahl: WORD;
    hlp: STRING;
    FullCall, Found: BOOLEAN;
    lint: LONGINT;
BEGIN
  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF POS(' ',S) > 0 THEN S := Gross(COPY(S,POS(' ',S)+1,255))
                    ELSE S := '';

   ASSIGN(InfoFile,BoxPath+'info.stn');
  {$I-}
  RESET(InfoFile);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    PutData(ch,#13+SysText(ch,45)+#13#13);
    Exit;
  END;

  Anz := 0;
  Anzahl := 0;
  FullCall := FALSE;
  Found := FALSE;
  Hlp := '';
  WHILE NOT EOF(InfoFile) AND NOT FullCall DO BEGIN
    READ(InfoFile,Info);
    IF (COPY(Info.Call,1,LENGTH(S)) = S) THEN BEGIN
      IF (Info.Call <> S) OR (S='') THEN BEGIN
        inc(Anz);
        inc(Anzahl);
        FOR i := 0 TO 5 DO IF LENGTH(Info.Call) = i THEN Info.Call := Info.Call + ' ';
        hlp := hlp + Info.Call + ' ';
        IF Anzahl=10 THEN BEGIN
          PutData(ch,hlp+#13);
          hlp := '';
          Anzahl := 0;
        END;
        Found := TRUE;
      END
      ELSE BEGIN
        FullCall := TRUE;
        IF KS[ch]^.Lev > 10 THEN BEGIN
          {SysOp}
          PutData(ch,#13+'Call      : '+Info.Call);
          IF LENGTH(Info.HPATH) > 0 THEN PutData(ch,Info.HPATH);
          {Zeitpunkt des letzten Empfangs}
          PutData(ch,#13+'Last-TX   : '+Pack2STRDate(Info.LastTX)+' - '+Pack2STRTime(Info.LastTX)+#13);
          PutData(ch,'Info      : '+Info.Desc+#13);
          STR(Info.MSGCt,Hlp);
          PutData(ch,'MSG-Count : '+hlp+#13);
          FOR k := 1 TO 3 DO  FOR i := 0 TO 5 DO IF LENGTH(Info.Best[k].From) = i THEN Info.Best[k].From := Info.Best[k].From
              + ' ';
          PutData(ch,'Best      : '+Info.Best[1].From+'  '+TimeLong(Info.Best[1].Time)+#13);
          PutData(ch,'2nd       : '+Info.Best[2].From+'  '+TimeLong(Info.Best[2].Time)+#13);
          PutData(ch,'3rd       : '+Info.Best[3].From+'  '+TimeLong(Info.Best[3].Time)+#13#13);
        END
        ELSE BEGIN
          {kein SysOp}
          PutData(ch,#13+'Call      : '+Info.Call);
          IF LENGTH(Info.HPATH) > 0 THEN PutData(ch,Info.HPATH);
          {Zeitpunkt des letzten Empfangs}
          PutData(ch,#13+'Last-TX   : '+Pack2STRDate(Info.LastTX)+' - '+Pack2STRTime(Info.LastTX)+#13);
          PutData(ch,'Info      : '+Info.Desc+#13);
          STR(Info.MSGCt,Hlp);
          PutData(ch,'MSG-Count : '+hlp+#13);
          PutData(ch,'Neighbour : '+Info.Best[1].From+#13);
          PutData(ch,'Best Time : '+TimeLong(Info.Best[1].Time)+#13#13);

          Found := TRUE;

        END;
        CLOSE(InfoFile);
        GivePath(Info.Call,ch);  {Kompletten Pfad 'raussuchen}

        PutData(ch,#13);
        Exit;
      END;
    END;
  END;
  CLOSE(InfoFile);
  IF Anzahl>0 THEN PutData(ch,hlp+#13);
  IF anz = 0 THEN PutData(ch,#13+SysText(ch,46)+#13)
  ELSE BEGIN
    STR(Anz,S);
    PutData(ch,#13+'Gesamt: '+S+#13#13);
  END;
END;


PROCEDURE MYBBS_CMD(ch: BYTE; S: STRING);
VAR Rufz: STRING;
    Call: STRING[6];
    OK: BOOLEAN;
    Weiterleiten: BOOLEAN;
BEGIN
  S := Gross(S);

  IF S[LENGTH(S)]=#13 THEN S := COPY(S,1,LENGTH(S)-1);

  IF POS(' ',S)=0 THEN S := ''
                  ELSE S := COPY(S,POS(' ',S)+1,255);

  Weiterleiten := TRUE;
  IF POS('+',S)>0 THEN BEGIN
    Weiterleiten := FALSE;
    DELETE(S,POS('+',S),1);
    S := LTRIM(RTRIM(S));
  END;

  IF S='' THEN BEGIN
    Rufz := GetMYBBS(CutSSID(KS[ch]^.Call));
    IF Rufz='' THEN PutData(ch,SysText(ch,59)+#13#13)
               ELSE PutData(ch,SysText(ch,60)+' '+Rufz+#13#13);
    Exit;
  END;

  IF KS[ch]^.Lev < 10 THEN BEGIN
    Rufz := S;
    Call := Gross(CutSSID(KS[ch]^.Call));
  END
  ELSE BEGIN
    IF POS(' ',S)>0 THEN BEGIN
      Call := Gross(COPY(S,1,POS(' ',S)-1));
      Rufz := COPY(S,POS(' ',S)+1,255);
    END
    ELSE BEGIN
      Rufz := S;
      Call := Gross(CutSSID(KS[ch]^.Call));
    END;
  END;
  IF POS('.',Call) > 0 THEN Call := COPY(Call,1,POS('.',Call)-1);
  IF POS('.',Rufz) > 0 THEN Rufz := COPY(Rufz,1,POS('.',Rufz)-1);

  IF ((Gross(COPY(Rufz,1,3))='DB0') OR (Gross(COPY(Rufz,1,3))='DK0'))AND NOT OwnBoxData^.DB0_MYBBS AND Weiterleiten THEN BEGIN
    PutData(ch,#13);
     SendTextFile(ch,BoxPath+'msg'+PATH_SEP+'nodb0');
    PutData(ch,#13);
    WeiterLeiten:=FALSE;
  END;

  Set_MYBBS(Call,Rufz);
  IF Call <> CutSSID(KS[ch]^.Call) THEN PutData(ch,'OK, '+Rufz+' als MYBBS von '+Call+' eingetragen.'+#13)
                                   ELSE PutData(ch,'OK, '+Rufz+' '+SysText(ch,61)+#13);
  IF (OwnBoxData^.M_E_Use) AND Weiterleiten THEN BEGIN
    PutData(ch,SysText(ch,15));
    SendM_Mail(Call,Rufz);
  END;
  PutData(ch,#13);
END;



PROCEDURE ListSFFile(ch: BYTE);
VAR SF: SF_File_Rec;
    SFFile: FILE OF SF_File_Rec;
    anz: WORD;
    Hlp,S: STRING;
    i: WORD;
BEGIN
  ASSIGN(SFFile,BoxPath+'sfliste');
  {$I-}
  RESET(SFFile);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    PutData(ch,#13+SysText(ch,66)+#13#13);
    Exit;
  END;

  anz := 0;
  PutData(ch,#13);
  WHILE NOT EOF(SFFile) DO BEGIN
    READ(SFFile,SF);
       {ungelscht}
    IF SF.Flags AND SFLISTE_DEL=0 THEN BEGIN
      anz := anz + 1;
      STR(FILEPOS(SFFile)+1,S);
      FOR i := 0 TO 4 DO IF LENGTH(S) = i THEN S := ' ' + S;
      FOR i := 0 TO 5 DO IF LENGTH(SF.SF_Partner) = i THEN SF.SF_Partner := SF.SF_Partner + ' ';
      FOR i := 0 TO 5 DO IF LENGTH(SF.Von) = i THEN SF.Von := SF.Von + ' ';
      FOR i := 0 TO 7 DO IF LENGTH(SF.An) = i THEN SF.An := SF.An + ' ';
      FOR i := 0 TO 7 DO IF LENGTH(SF.Via) = i THEN SF.Via := SF.Via + ' ';
      FOR i := 0 TO 30 DO IF LENGTH(SF.Hierachie) = i THEN SF.Hierachie := SF.Hierachie + ' ';
      S := S + ' ' + SF.SF_Partner + ' ' + SF.Von + ' ' + SF.An + ' @ ' + SF.Via + ' ' + SF.Hierachie;
      PutData(ch,S+' '+SF.Art);
      IF SF.Flags AND SFLISTE_HOLD>0 THEN PutData(ch,' HOLD');
      PutData(ch,#13);
    END;
  END;
  CLOSE(SFFile);
  IF anz = 0 THEN PutData(ch,SysText(ch,66)+#13);
  PutData(ch,#13);

END;


{Neues LISTSF -> gibt die Liste anhand der ins RAM gelesenen Daten aus}
PROCEDURE NewLISTSF(ch: BYTE);
VAR OP: BOOLEAN;
    tmp: pBoxSF;
    S,S2,Hlp: STRING;
    line: BYTE;
BEGIN
  {Gucken, ob der User als SysOp eingeloggt ist -> erweiterte Infos}
  OP := KS[ch]^.Lev > 10;

  tmp := BoxSFRoot;
  PutData(ch,#13+'S&F-Partner:'+#13#13);
  WHILE tmp<>NIL DO BEGIN
    S := FillStr(6,tmp^.Call)+' ';
    IF LENGTH(tmp^.WhatToForward)>70 THEN BEGIN
      line := 0;
      S2 := tmp^.WhatToForward;
      REPEAT
        inc(line);
        Hlp := COPY(S2,1,70);
        Hlp := COPY(Hlp,1,Last(' ',Hlp)-1);
        S2 := LTRIM(COPY(S2,LENGTH(Hlp)+1,255));
        IF Line=1 THEN PutData(ch,S+Hlp+#13)
                  ELSE PutData(ch,StringD(' ',7)+Hlp+#13);
      UNTIL LENGTH(S2)=0;
    END
    ELSE BEGIN
      S := S + tmp^.WhatToForward;
      PutData(ch,S+#13);
    END;
    IF OP THEN BEGIN
      PutData(ch,StringD(' ',7)+'Path: '+tmp^.Pfad+#13);
      STR(tmp^.SID,S);
      PutData(ch,StringD(' ',7)+'Times: '+tmp^.Times+'  SID: '+S+#13);
    END;
    tmp := tmp^.next;
  END;
  PutData(ch,#13);
END;



PROCEDURE DelSFEntry(ch: BYTE;S: STRING);
VAR SF: SF_File_Rec;
    SFFile: FILE OF SF_File_Rec;
    Nr,code: WORD;
BEGIN
  S := LTRIM(RTRIM(S));
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  IF S='' THEN BEGIN
    PutData(ch,#13+'Syntax: SF DEL <Nr>'+#13#13);
    Exit;
  END;
  ASSIGN(SFFile,BoxPath+'sfliste');
  {$I-}
  RESET(SFFile);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    PutData(ch,#13+SysText(ch,66)+#13#13);
    Exit;
  END;

  VAL(S,Nr,code);
  SEEK(SFFile,Nr-2);
  IF EOF(SFFile) THEN BEGIN
    PutData(ch,#13+'File Nr '+S+' ist nicht vorhanden.'+#13#13);
    CLOSE(SFFile);
    Exit;
  END;

  READ(SFFile,SF);
  SF.Flags := SF.Flags OR SFLISTE_DEL;  {Delete-Flag setzen}
  SEEK(SFFile,Nr-2);
  WRITE(SFFile,SF);
  CLOSE(SFFile);
  PutData(ch,#13+'File Nr '+S+' wurde aus der S&F-Liste gelscht.'+#13#13);

END;


PROCEDURE DelHoldEntry(ch: BYTE; S: STRING);
VAR SF: SF_File_Rec;
    SFFile: FILE OF SF_File_Rec;
    Nr,code: WORD;
BEGIN
  S := LTRIM(RTRIM(S));
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  IF S='' THEN BEGIN
    PutData(ch,#13+'Syntax: SF NOHOLD <Nr>'+#13#13);
    Exit;
  END;

  ASSIGN(SFFile,BoxPath+'sfliste');
  {$I-}
  RESET(SFFile);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    PutData(ch,#13+SysText(ch,66)+#13#13);
    Exit;
  END;

  VAL(S,Nr,code);
  SEEK(SFFile,Nr-2);
  IF EOF(SFFile) THEN BEGIN
    PutData(ch,#13+'File Nr '+S+' ist nicht vorhanden.'+#13#13);
    CLOSE(SFFile);
    Exit;
  END;

  READ(SFFile,SF);
  SF.Flags := SF.Flags AND $FFFF - SFLISTE_HOLD;        {Hold-Flag lschen}
  SEEK(SFFile,Nr-2);
  WRITE(SFFile,SF);
  CLOSE(SFFile);
  PutData(ch,#13+'Bei File Nr '+S+' wurde das Hold-Flag in der SF-Listegelscht.'+#13#13);

END;



PROCEDURE SF_Poll(ch: BYTE; S: STRING; Meldungen: BOOLEAN);
VAR f: Text;
    S1,Pfad: STRING;
    Found: BOOLEAN;
    i: WORD;
    tmp: pBoxSF;
    Call,Einstieg,Netzwerk: STRING[10];
    Fertig: BOOLEAN;
BEGIN
  S := Gross(S);

  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                    ELSE S := '';

  IF S = '' THEN BEGIN
    IF Meldungen THEN PutData(ch,'Syntax:'+#13+'SF <Call>'+#13#13);
    Exit;
  END;


  IF S = 'LIST' THEN BEGIN
    ListSFFile(ch);
    Exit;
  END
  ELSE BEGIN
    IF (COPY(S,1,3) = 'DEL') THEN BEGIN
      DelSFEntry(ch,S);
      Exit;
    END
    ELSE BEGIN
      IF S = 'ALL' THEN BEGIN
        Auto_SF_Poll;
        PutData(ch,#13+'OK'+#13#13);
        Exit;
      END
      ELSE IF COPY(S,1,6)='NOHOLD' THEN BEGIN
        DelHoldEntry(ch,S);
        Exit;
      END;
    END;
  END;


  {Schon eine S&F-Verbindung mit der Station?}
  FOR i := 0 TO 255 DO BEGIN
    IF KS[i] <> NIL THEN BEGIN
      IF CutSSID(KS[i]^.Call) = S THEN BEGIN
        IF (KS[i]^.DBSFData <> NIL) OR (KS[i]^.FBBSFData <> NIL) THEN BEGIN
          IF Meldungen THEN PutData(ch,#13+SysText(ch,48)+#13#13);
          Exit;
        END;
      END;
    END;
  END;

  tmp := BoxSFRoot;
  IF tmp=NIL THEN BEGIN
    IF Meldungen THEN PutData(ch,#13+SysText(ch,47)+#13#13);
    Exit;
  END;

  found := FALSE;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Call=S THEN Found := TRUE
                   ELSE tmp := tmp^.next;
  END;

  IF NOT Found THEN BEGIN
    IF Meldungen THEN PutData(ch,#13+S+' '+SysText(ch,49)+#13#13);
    Exit;
  END;

  MakeConnect(OwnBoxData^.SF_Call,tmp^.Pfad,60);
  IF Meldungen THEN PutData(ch,#13+SysText(ch,51)+' '+S+#13#13);

END;



PROCEDURE BBS_Help(ch: BYTE; S: STRING);
BEGIN

  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                    ELSE S := '';

  IF s = '' THEN s:='ALLG';
  {help(ch, s, 'BOX');}

END;


PROCEDURE BOX_INFO(ch: BYTE);
BEGIN
  SendMacroFile(ch,BoxPath+'msg'+PATH_SEP+'info.'+klein(KS[ch]^.BoxData^.Spk));
END;



PROCEDURE Spk_CMD(ch: BYTE; S: STRING);
TYPE string80 = STRING[80];
VAR f: FILE OF string80;
    S80: string80;
    Spk: STRING[3];
    SR: SearchRec;
    OK,Found: BOOLEAN;
    tmp: WORD;
BEGIN
  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                    ELSE S := '';

  Spk := Gross(S);

  ASSIGN(f,BoxPath+'msg'+PATH_SEP+'messages.'+klein(Spk));
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    {Angegebenes Sprachfile ist nicht vorhanden}
    PutData(ch,#13+SysText(ch,67)+#13+SysText(ch,69)+#13#13);
    Found := FALSE;
    FindFirst(BoxPath+'msg'+PATH_SEP+'messages.*',$3F,SR);
    WHILE doserror = 0 DO BEGIN
      S := SR.Name;
      S := COPY(S,POS('.',S)+1,255);
      S80 := SysTextWithSpk(S,0);
      FOR tmp := 0 TO 2 DO IF LENGTH(S) = tmp THEN S := ' ' + S;
      PutData(ch,' ' + S + ' (' + S80 + ')'+#13);

      Found := TRUE;
      FindNext(SR);
    END;
    PutData(ch,#13);
    Exit;
  END;
  CLOSE(f);
  Set_SPK(CutSSID(KS[ch]^.Call),Spk);
  KS[ch]^.BoxData^.Spk := Spk;
  PutData(ch,SysText(ch,70)+#13#13);
END;


PROCEDURE LT_CMD(ch: BYTE; S: STRING);
VAR i,Start,Stop: WORD;
    Rubrik: STRING[8];
    IsZahl: BOOLEAN;
    VerFile: FILE OF Verwalt_Rec;
    CheckFile: FILE OF CheckRec;
    Chk: CheckRec;
    Ver: Verwalt_Rec;
    anz,code,LT: WORD;
    Hlp: STRING;
    bidi:TBidHashRec;
BEGIN
  {Evtl. RETURN abschneiden}
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(#10,S)>0 THEN DELETE(S,POS(#10,S),1);

  IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                    ELSE S := '';

  IF POS('#',S) > 0 THEN BEGIN
    Hlp := LTRIM(RTRIM(COPY(S,POS('#',S)+1,255)));
    S := LTRIM(RTRIM(COPY(S,1,POS('#',S)-1)));
    IF Hlp='' THEN BEGIN
      PutData(ch,#13+SysText(ch,72)+#13#13);
      Exit;
    END;
    VAL(Hlp,LT,code);
    IF code <> 0 THEN BEGIN
      PutData(ch,#13+SysText(ch,72)+#13#13);
      Exit;
    END;
  END
  ELSE BEGIN
    PutData(ch,SysText(ch,73)+#13#13);
    Exit;
  END;

  IF LENGTH(S) = 0 THEN BEGIN
    PutData(ch,SysText(ch,73)+#13#13);
    Exit;
  END
  ELSE BEGIN
    IF POS(' ',S) > 0 THEN BEGIN        {Leerzeichen vorhanden -> es kommt
                                         noch was (Zahlen)}
      Rubrik := COPY(S,1,POS(' ',S)-1);
      S := COPY(S,POS(' ',S)+1,255);

      {Leerzeichen aus dem String 'raus}
      FOR i := LENGTH(S) DOWNTO 1 DO IF S[i] = #32 THEN DELETE(S,i,1);

      IF POS('-',S) > 0 THEN BEGIN
        VAL(COPY(S,1,POS('-',S)-1),Start,i);
        IF i <> 0 THEN Start := 1;
        VAL(COPY(S,POS('-',S)+1,255),Stop,i);
        IF i <> 0 THEN Stop := 65535;
      END
      ELSE BEGIN
        VAL(S,Start,i);
        Stop := Start;
      END;
    END
    ELSE BEGIN
      PutData(ch,SysText(ch,73)+#13#13);
      Exit;
    END;
  END;

  ASSIGN(VerFile,BOXPATH+'index'+PATH_SEP+klein(Rubrik)+'.idx');
  {$I-}
  RESET(VerFile);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    PutData(ch,#13+SysText(ch,37)+' '+Rubrik+#13#13);
    Exit;
  END;
  IF FILESIZE(VerFile) = 0 THEN BEGIN
    PutData(ch,#13+SysText(ch,37)+' '+Rubrik+#13#13);
    CLOSE(VerFile);
    Exit;
  END;

  i := Start - 1;
  anz := 0;
  WHILE NOT EOF(VerFile) AND (i < Stop) DO BEGIN
    SEEK(VerFile,i);
    IF NOT EOF(VerFile) THEN BEGIN
      READ(VerFile,Ver);
      IF Ver.Flags AND VERWALT_DEL>0 THEN BEGIN
        STR(i+1,Hlp);
        PutData(ch,SysText(ch,42)+' '+Hlp+' '+SysText(ch,62)+#13);
      END
      ELSE BEGIN
        anz := anz + 1;
        SEEK(VerFile,FILEPOS(VerFile)-1);
        Ver.LifeTime := LT;
        WRITE(VerFile,Ver);
        IF BidHash^.GetData(ver.bid,@bidi) THEN
          IF bidi.check_file_pos>0 THEN
          BEGIN
	     assign(checkfile,Boxpath+'check.box');
            {$i-}
            reset(checkfile);
            seek(checkfile,bidi.check_file_pos-1);
            read(checkfile,chk);
            chk.lt:=LT;
            seek(checkfile,bidi.check_file_pos-1);
            write(checkfile,chk);
            close(checkfile);
         END;
      END;
    END;
    i := i + 1;
  END;
  CLOSE(VerFile);
  STR(anz,Hlp);
  STR(LT,S);
  PutData(ch,Hlp+' Mails, new LifeTime: '+S+#13#13);

END;





{Befehl fr die Verwaltung des BID-Files (BID.DAT)}
PROCEDURE BID_CMD(ch: BYTE; S: STRING);
BEGIN
END;



{Zeigt das File LIFETIME an. (somit alle definierten Lifetimes)}
PROCEDURE DefLT_CMD(ch: BYTE);
VAR f: Text;
    S: STRING;
BEGIN
  ASSIGN(f,BoxPath+'lifetime');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    PutData(ch,#13+'File ''LIFETIME'' ist nicht vorhanden'+#13#13);
    Exit;
  END;

  PutData(ch,#13);
  WHILE NOT EOF(f) DO BEGIN
    READLN(f,S);
    PutData(ch,S+#13);
  END;
  CLOSE(f);
  PutData(ch,#13);
END;


{Erweiterte User-Info senden}
PROCEDURE SendUserInfo(Call: str6; ch: BYTE);
VAR Da,OK: BOOLEAN;
    U: R_UserFile;
    SetInfo: BYTE;
    Hlp,Hlp1: STRING;
BEGIN
  Da := GetUser(OK,U,Call);
  IF NOT Da THEN BEGIN
    PutData(ch,#13+CutSSID(Call)+': '+SysText(ch,17)+#13#13);
    Exit;
  END;

  {Fileformat von USER.BOX ist falsch (alt oder sonstiges)}
  IF NOT OK THEN BEGIN
    PutData(ch,#13+SysText(ch,16)+#13#13);
    Exit;
  END;

  PutData(ch,#13+SysText(ch,18)+' '+CutSSID(Call)+':'+#13);
  PutData(ch,SysText(ch,19)+' '+U.MYBBS+Hierachie(U.MYBBS)+#13);     {MYBBS}
  PutData(ch,SysText(ch,20)+' '+U.Name+#13);       {Name}
  STR(U.Prompt,Hlp);
  PutData(ch,SysText(ch,109)+' '+U.PromptStr+#13);{Prompt-String}
  PutData(ch,SysText(ch,110)+' '+Hlp);            {Prompt}
  PutData(ch,StringD(' ',26-LENGTH(Hlp))+SysText(ch,26)+' ');
  STR(U.HelpLevel,Hlp);
  PutData(ch,Hlp+#13); {Help-Level}

  PutData(ch,SysText(ch,23)+' ');
  GetSetInfos(CutSSID(Call),SetInfo);
  Hlp := '';
  IF SetInfo AND SET_Bytes>0 THEN Hlp := Hlp + 'B'
                             ELSE Hlp := Hlp + '.';
  IF SetInfo AND SET_Datum>0 THEN Hlp := Hlp + 'D'
                             ELSE Hlp := Hlp + '.';
  IF SetInfo AND SET_R_Vollst>0 THEN Hlp := Hlp + 'H'
                                ELSE Hlp := Hlp + '.';
  IF SetInfo AND SET_Lifetime>0 THEN Hlp := Hlp + 'L'
                                ELSE Hlp := Hlp + '.';
  IF SetInfo AND SET_R_Kurz>0 THEN Hlp := Hlp + 'P'
                              ELSE Hlp := Hlp + '.';
  IF SetInfo AND SET_Read>0 THEN Hlp := Hlp + 'R'
                            ELSE Hlp := Hlp + '.';
  IF SetInfo AND SET_Sender>0 THEN Hlp := Hlp + 'S'
                              ELSE Hlp := Hlp + '.';
  IF SetInfo AND SET_Uhrzeit>0 THEN Hlp := Hlp + 'T'
                               ELSE Hlp := Hlp + '.';
  PutData(ch,Hlp+StringD(' ',18)+SysText(ch,68)+' '+U.Spk+#13); {systemsprache}
  Str(U.Level,hlp);
  IF KS[ch]^.Lev>=10 THEN
    PutData(ch,'Level: '+hlp+#13);
  IF (Gross(CutSSID(Call)) = Gross(CutSSID(KS[ch]^.Call))) OR (KS[ch]^.Lev > 10) THEN BEGIN
    Hlp := SysText(ch,24)+' ';
    STR(U.ReadLock,Hlp1);
    Hlp := Hlp + Hlp1 + StringD(' ',25) + SysText(ch,25)+' ';
    Da := IsPasswd(Call);
    IF Da THEN Hlp := Hlp + SysText(ch,3)
          ELSE Hlp := Hlp + SysText(ch,4);
    PutData(ch,Hlp+#13);
  END;

  {Letztes QUIT}
  UnpackTime(U.LastQuit,DT);
  STR(DT.Day,hlp);
  STR(DT.Month,hlp1);
  IF DT.Day < 10 THEN hlp := '0' + Hlp;
  IF DT.Month < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + '.' + hlp1 + '.';
  STR(DT.Year,hlp1);
  hlp := Hlp + hlp1 + ' ';
  STR(DT.Hour,hlp1);
  IF DT.Hour < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + hlp1 + ':';
  STR(DT.Min,hlp1);
  IF DT.Min < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + hlp1;
  PutData(ch,SysText(ch,21)+' '+hlp+#13);

  {Lastlogin}
  UnpackTime(U.LastLogin,DT);
  STR(DT.Day,hlp);
  STR(DT.Month,hlp1);
  IF DT.Day < 10 THEN hlp := '0' + Hlp;
  IF DT.Month < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + '.' + hlp1 + '.';
  STR(DT.Year,hlp1);
  hlp := Hlp + hlp1 + ' ';
  STR(DT.Hour,hlp1);
  IF DT.Hour < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + hlp1 + ':';
  STR(DT.Min,hlp1);
  IF DT.Min < 10 THEN hlp1 := '0' + hlp1;
  hlp := hlp + hlp1;
  PutData(ch,SysText(ch,22)+' '+hlp+#13);

  {Zeile mit der Anzahl gesendeter, empfangener etc mails}
  hlp := SysText(ch,28) + ' ';
  STR(U.Anz_Logins,hlp1);
  hlp := hlp + hlp1 + ', '+SysText(ch,29) + ' ';
  STR(U.Anz_Rec,hlp1);
  hlp := hlp + hlp1 + ', '+SysText(ch,30) + ' ';
  STR(U.Anz_Read,hlp1);
  hlp := hlp + hlp1 + ', '+SysText(ch,31) + ' ';
  STR(U.Anz_Send,hlp1);
  hlp := hlp + hlp1;
  PutData(ch,hlp+#13#13);
END;



PROCEDURE SET_CMD(ch: BYTE; S: STRING);
VAR Hlp,Passwd: STRING;
    Call: STRING[8];
    SetInfo: BYTE;
    RL: BYTE;
    code: WORD;
    OK: BOOLEAN;
    nr,b: byte;
BEGIN
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
  ELSE BEGIN
    SendUserInfo(CutSSID(KS[ch]^.Call),ch);
    Exit;
  END;

  IF POS(' ',S)>0 THEN BEGIN
    Hlp := Gross(COPY(S,1,POS(' ',S)-1));
    S := COPY(S,POS(' ',S)+1,255);
  END
  ELSE BEGIN
    Hlp := Gross(S);
    S := '';
  END;

  IF KS[ch]^.Lev < 10 THEN Call := Gross(CutSSID(KS[ch]^.Call))
  ELSE BEGIN
    {SysOp kann auch fr andere User level setzen}
    IF Rufz(Hlp) THEN BEGIN
      Call := Gross(CutSSID(Hlp));
      IF POS(' ',S)>0 THEN BEGIN
        Hlp := Gross(COPY(S,1,POS(' ',S)-1));
        S := COPY(S,POS(' ',S)+1,255);
      END
      ELSE BEGIN
        Hlp := Gross(S);
        S := '';
      END;
    END
    ELSE Call := Gross(CutSSID(KS[ch]^.Call));
  END;
  IF (Hlp='PASSW') OR (Hlp='PW') THEN BEGIN
    IF S='' THEN BEGIN
      OK := GetPasswd(Call,Passwd);
      IF OK THEN PutData(ch,#13+'Es ist ein Passwort gesetzt.')
            ELSE PutData(ch,#13+'Es ist kein Passwort gesetzt.');
      PutData(ch,#13+'"SET PW -" deletes the passwort. ');
      PutData(ch,#13#13);
      Exit;
    END;

    IF S='-' THEN BEGIN
      DelPasswd(Call);
      PutData(ch,#13+'OK, Passwort gelscht.');
      PutData(ch,#13#13);
      Exit;
    END;

    {IF LENGTH(S)<20 THEN BEGIN
      PutData(ch,#13+'Das Passwort mu mindestens 20 Zeichen lang sein!');
      PutData(ch,#13#13);
      Exit;
    END; }
    OK := GetPasswd(Call,Passwd);
    SetPasswd(Call,Passwd+S);
    IF PassWd='' THEN
      PutData(ch,#13+'OK, Passwort wurde gesetzt.')
    ELSE
    BEGIN
      Str(length(passwd+s),s);
      PutData(ch,#13+'OK, Passwort wurde erweitert, jetzt '+s+' Stellen lang'+#13);
    END;
    PutData(ch,#13#13);
    Exit;
  END;


  IF (hlp[1]='H') THEN BEGIN
    IF S='' THEN BEGIN
      nr := GetHelpLevel(Call);
      STR(nr,Passwd);
      IF Call<>CutSSID(KS[ch]^.Call) THEN PutData(ch,#13+'('+Call+')'+#13)
                                     ELSE PutData(ch,#13);
      PutData(ch,SysText(ch,111)+' '+Passwd+#13#13);
       {Eingestellter Helplevel:}
      Exit;
    END;
    VAL(S,Nr,code);
    IF code=0 THEN BEGIN
      IF Nr<3 THEN BEGIN
        {OK, Level ist zwischen 0 und 2 -> speichern}
        SetHelpLevel(Call,Nr);
        KS[ch]^.BoxData^.HelpLevel := Nr;
        PutData(ch,#13+SysText(ch,112)+#13#13);
      END
      ELSE BEGIN
        {Level ist zu gro -> fehlermeldung}
        PutData(ch,#13+SysText(ch,113)+#13#13);
      END;
    END;
    Exit;
  END;


  {Aussehen des Prompts verstellen}
  IF (Hlp[1]='P') THEN BEGIN
    IF LENGTH(S)=0 THEN BEGIN
      PutData(ch,#13+SysText(ch,126)+#13#13);
      Exit;
    END;

    VAL(S,nr,code);
    S := (LTRIM(RTRIM(S)));
    IF Nr=255 THEN Nr := 1;
    IF code=0 THEN BEGIN
      {Die Prompt-Nummer ist eingegeben worden}
      SetPromptNr(Call,nr);
      FOR b := 0 TO 255 DO IF KS[b] <> NIL THEN BEGIN
        IF (KS[b]^.status = 50) AND (CutSSID(KS[ch]^.Call)=Call) THEN KS[b]^.BoxData^.Prompt := Nr;
      END;
      IF CutSSID(KS[ch]^.Call)=Call THEN PutData(ch,#13+SysText(ch,127))   {OK, Prompt eingestellt}
                                    ELSE PutData(ch,#13+SysText(ch,128)+' '+Call+' '+SysText(ch,129))
                                                             {OK, Prompt fr .... eingestellt}

    END
    ELSE BEGIN
      {Ein User-Prompt-String ist eingegeben worden}
      SetPromptStr(Call,S);
      SetPromptNr(call,255);
      FOR b := 0 TO 255 DO IF KS[b] <> NIL THEN BEGIN
        IF (KS[b]^.status = 50) AND (CutSSID(KS[ch]^.Call)=Call) THEN BEGIN
          KS[b]^.BoxData^.Prompt := 255;
          NEW(KS[b]^.BoxData^.Prompt_Str);
          KS[b]^.BoxData^.Prompt_Str^ := S;
        END;
      END;
      IF CutSSID(KS[ch]^.Call)=Call THEN PutData(ch,#13+SysText(ch,127))   {OK, Prompt eingestellt}
                                    ELSE PutData(ch,#13+SysText(ch,128)+' '+Call+' '+SysText(ch,129))
                                                            {OK, Prompt fr .... eingestellt}

    END;

    PutData(ch,#13#13);
    Exit;
  END;


  IF (Hlp[1]='R') THEN BEGIN
    GetSetInfos(Call,SetInfo);
    WHILE LENGTH(S)>0 DO BEGIN
      IF POS(' ',S)>0 THEN BEGIN
        Hlp := Gross(COPY(S,1,POS(' ',S)-1));
        S := COPY(S,POS(' ',S)+1,255);
      END
      ELSE BEGIN
        Hlp := Gross(S);
        S := '';
      END;

      IF LENGTH(Hlp)=2 THEN BEGIN
        CASE Hlp[1] OF
          '+': CASE Hlp[2] OF
                 'B': SetInfo := SetInfo OR SET_Bytes;
                 'D': SetInfo := SetInfo OR SET_Datum;
                 'H': BEGIN
                        SetInfo := SetInfo OR SET_R_Vollst;
                        SetInfo := SetInfo AND $FF-SET_R_Kurz;
                      END;
                 'L': SetInfo := SetInfo OR SET_Lifetime;
                 'P': BEGIN
                        SetInfo := SetInfo OR SET_R_Kurz;
                        SetInfo := SetInfo AND $FF-SET_R_Vollst;
                      END;
                 'R': SetInfo := SetInfo OR SET_Read;
                 'S': SetInfo := SetInfo OR SET_Sender;
                 'T': SetInfo := SetInfo OR SET_Uhrzeit;
               END;
          '-': CASE Hlp[2] OF
                 'B': SetInfo := SetInfo AND $FF-SET_Bytes;
                 'D': SetInfo := SetInfo AND $FF-SET_Datum;
                 'H': SetInfo := SetInfo AND $FF-SET_R_Vollst;
                 'L': SetInfo := SetInfo AND $FF-SET_Lifetime;
                 'P': SetInfo := SetInfo AND $FF-SET_R_Kurz;
                 'R': SetInfo := SetInfo AND $FF-SET_Read;
                 'S': SetInfo := SetInfo AND $FF-SET_Sender;
                 'T': SetInfo := SetInfo AND $FF-SET_Uhrzeit;
               END;
        END;
      END;
    END;
    PutSetInfos(Call,SetInfo);
    PutData(ch,#13+SysText(ch,76)+' '+Call+' '+SysText(ch,77)+#13#13);
    Exit;
  END;


  IF (Hlp='RL') OR (copy(Hlp,1,5)='READL') THEN BEGIN
    IF LENGTH(S)>0 THEN BEGIN
      VAL(S,RL,code);
      IF code=0 THEN BEGIN
        IF RL>2 THEN BEGIN
          PutData(ch,#13+'Wrong Parameter! Only 0..2 permitted'+#13#13);
        END
        ELSE BEGIN
          SetReadLock(CutSSID(KS[ch]^.Call),RL);
          PutData(ch,#13+'ReadLock auf '+S+' gestellt.'+#13#13);
        END;
      END
      ELSE PutData(ch,#13+'''S'' -> falscher Parameter'+#13#13);
    END
    ELSE PutData(ch,#13+'Parameter fehlt!'+#13'siehe HELP SET'+#13#13);
    Exit;
  END;

  IF (Hlp[1]='O') THEN BEGIN
    GetSetInfos(Call,SetInfo);
    AktSetAusgeb(ch,SetInfo);
    PutData(ch,#13+'(B,D,H,L,P,R,S,T,0,1,2,Q=Quit) =>');
    KS[ch]^.BoxData^.status := 4;
    Exit;
  END;

  {Passwort einstellen}

  IF (copy(Hlp,1,2)='FR') THEN BEGIN
    IF S='' THEN BEGIN
      PutData(ch,+#13+'SYNTAX: SET FRIEND [+|-] CALL'#13#13);
      exit;
    END;
    S:=GROSS(S);
    IF S[1]='+' THEN BEGIN
      S:=CUTSSID(LTRIM(COPY(S,2,255)));
      IF rufz(S) THEN
      BEGIN
        AddFriend(Call,S);
        PutData(ch,#13+'OK, '+S+' darf jetzt Usermail von '+call+' lesen'#13#13);
      END ELSE PutData(ch,#13+S+' ist kein gltiges Rufzeichen'#13#13);
      Exit;
    END;
    IF S[1]='-' THEN BEGIN
      S:=CUTSSID(LTRIM(COPY(S,2,255)));
      IF Rufz(S) THEN
      BEGIN
        IF Not IS_Friend(call,S) THEN
        BEGIN
          PutData(ch,#13+S+' war bisher nicht in der Liste...'+#13#13);
          exit;
        END;
        DelFriend(Call,S);
        PutData(ch,#13+'OK, '+S+' darf Usermail von '+call+' nicht mehr lesen'#13#13);
      END ELSE PutData(ch,#13+S+' ist kein gltiges Rufzeichen'#13#13);
      Exit;
    END;
    S:=LTRIM(CUTSSID(S));
    IF Rufz(S) THEN
    BEGIN
      PutData(ch,#13+s+' darf Usermail von '+call+' ');
      IF NOT IS_Friend(Call,S) THEN
        PutData(ch,'nicht ');
      PutData(ch,'lesen, wenn ReadLock gesetzt ist.'#13#13);
    END ELSE PutData(ch,#13+S+' ist kein gltiges Rufzeichen'#13#13);
    Exit;
  END;
  IF (upcase(hlp[1])='N') THEN
  BEGIN
    IF CutSSID(KS[ch]^.call)=call THEN
    NAME(ch,s) ELSE
    NAME(ch,call+' '+s);
    EXIT;
  END;
  IF (upcase(hlp[1])='F') THEN
  BEGIN
    IF CutSSID(KS[ch]^.call)=call THEN
    MYBBS_CMD(ch,s) ELSE
    MYBBS_CMD(ch,call+' '+s);
    EXIT;
  END;
  IF (upcase(hlp[1])='L') AND (KS[ch]^.Lev>=10) THEN
  BEGIN
    IF LENGTH(S)>0 THEN BEGIN
      VAL(S,RL,code);
      IF code=0 THEN BEGIN
        IF RL>9 THEN BEGIN
          PutData(ch,#13+'Wrong Parameter! Only 0..9 permitted'+#13#13);
        END
        ELSE BEGIN
          SetLevel(CutSSID(KS[ch]^.Call),RL);
          PutData(ch,#13+'Level auf '+S+' gestellt.'+#13#13);
          IF RL>4 THEN
            PutData(ch,'Vorsicht, der User kann jetzt Sysop werden'+#13);
        END;
      END
      ELSE PutData(ch,#13+'''S'' -> falscher Parameter'+#13#13);
    END
    ELSE PutData(ch,#13+'Parameter fehlt!'+#13'siehe HELP SET'+#13#13);
    EXIT;
  END;
{Kein parameter/bekannter Parameter angegeben -> erweiterte User-Info
 ausgeben}
  SendUserInfo(Call,ch);

END;



PROCEDURE KnownUser(ch: BYTE; S: STRING);
VAR UserFile: FILE OF R_UserFile;
    User: R_UserFile;
    Anz: LONGINT;
    i: BYTE;
BEGIN
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);

  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  ASSIGN(UserFile,BoxPath+'usrdat');
  {$I-}
  RESET(UserFile);
  {$I+}
  IF IOResult<>0 THEN Exit;

  IF S='' THEN BEGIN
    STR(FILESIZE(UserFile),S);
    PutData(ch,#13+S+' '+SysText(ch,94)+#13#13);
    {78 = bekannte User}
    CLOSE(UserFile);
    Exit;
  END;

  S := '';
  Anz := 0;
  IF NOT EOF(UserFile) THEN READ(UserFile,User);
  WHILE NOT EOF(UserFile) DO BEGIN
    READ(UserFile,User);

    FOR i := 0 TO 5 DO IF LENGTH(User.Call) = i THEN User.Call := User.Call + ' ';
    inc(Anz);
    IF LENGTH(S)>0 THEN S := S + ' ' + User.Call
                   ELSE S := User.Call;

    IF Anz=11 THEN BEGIN
      Anz := 0;
      PutData(ch,S+#13);
      S := '';
    END;
  END;

  IF Anz > 0 THEN PutData(ch,S+#13);

  PutData(ch,#13);
  CLOSE(UserFile);
END;



PROCEDURE Proto_CMD(ch: BYTE; S: STRING);
BEGIN

END;



PROCEDURE ListSF(ch: BYTE);
VAR f: Text;
    S: STRING;
BEGIN
   ASSIGN(f,BoxPath+'box.sf');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    PutData(ch,#13+'No S&F-Configurations available'+#13#13);
    Exit;
  END;

  S := '';
  IF KS[ch]^.Lev <= 10 THEN WHILE NOT EOF(f) AND (Gross(S)<>':WHAT_TO_FORWARD') DO READLN(f,S);

  PutData(ch,#13);
  WHILE NOT EOF(f) DO BEGIN
    READLN(f,S);
    S := LTRIM(RTRIM(S));
    IF (LENGTH(S)>0) AND (S[1]<>'#') THEN PutData(ch,S+#13);
  END;
  CLOSE(f);

  PutData(ch,#13);
END;



PROCEDURE Activity(ch: BYTE);
VAR b,i: BYTE;
    S,Hlp: STRING;
    OK: BOOLEAN;
BEGIN

  PutData(ch,#13+'Mailbox-Activity:'+#13);
  S := '';

  FOR b := 0 TO 255 DO BEGIN
    IF KS[b] <> NIL THEN BEGIN
      IF (KS[b]^.status IN [50..59]) THEN BEGIN
        S := CutSSID(KS[b]^.Call);
        FOR i := 0 TO 6 DO IF LENGTH(S)=i THEN S := S + ' ';

        CASE KS[b]^.status OF
          50: CASE KS[b]^.BoxData^.status OF
                   0: IF KS[b]^.TxW > 0 THEN Hlp := 'read'
                                        ELSE Hlp := 'idle';
                1..3: Hlp := 'send';
                   4: Hlp := 'set';
              END;
          51: Hlp := 'RLI-S&F';
          52: Hlp := 'FBB-S&F';
        END;

        FOR i := 0 TO 9 DO IF LENGTH(Hlp) = i THEN Hlp := Hlp + ' ';
        S := S + Hlp;
        PutData(ch,S+#13);
      END;
    END;
  END;

  PutData(ch,#13);

END;





{Festgelegte Syntax:
  TRANSFER [-D] [<Rubrik>] <Nr> [-<Nr>] > <Neu_Rubrik>
}
PROCEDURE Transfer(ch: BYTE; S: STRING);
VAR Rubrik: STRING[20];
    Hlp,Call,Verteiler: STRING;
    code,Von,Bis,i: WORD;
    Source,Desti: File;
    IdxFile: FILE OF Verwalt_Rec;
    Idx: Verwalt_Rec;
    OK: BOOLEAN;
    Lock,Len,Anz: BYTE;
    akttime: LONGINT;
    Arr255: tArr255;
    Result,SrcHeadLen: WORD;
    f: Text;
BEGIN
  Anz := 0;

  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  S := Gross(LTRIM(RTRIM(S)));
  S := OnlyOneSpace(S);

  IF POS('>',S)=0 THEN BEGIN
    {Fehler - '>' MUSS vorhanden sein}
    PutData(ch,#13+'Syntax error'+#13+SysText(ch,5)+#13#13);
    Exit;
  END;

  IF POS(' ',S)>0 THEN BEGIN
    S := LTRIM(RTRIM(COPY(S,POS(' ',S)+1,255)));
  END;

  Rubrik := COPY(S,1,POS(' ',S)-1);
  S := COPY(S,POS(' ',S)+1,255);

  Call := LTRIM(COPY(S,POS('>',S)+1,255));
  S := LTRIM(RTRIM(COPY(S,1,POS('>',S)-1)));

  {Eventuell einen Verteiler 'raus suchen}
  DelSpaces(Call);
  IF POS('@',Call)>0 THEN BEGIN
    Verteiler := COPY(Call,POS('@',Call)+1,255);
    Call := COPY(Call,1,POS('@',Call)-1);
  END
  ELSE Verteiler := '';

  IF POS('-',S)=0 THEN BEGIN
    IF NOT IsZahl(S) THEN BEGIN
      PutData(ch,#13+'Syntax error'+#13+SysText(ch,5)+#13#13);
      Exit;
    END;
    VAL(S,Von,code);
    Bis := Von;
  END
  ELSE BEGIN
    DelSpaces(S);
    Hlp := COPY(S,1,POS('-',S)-1);
    S := COPY(S,POS('-',S)+1,255);

    IF NOT IsZahl(Hlp) OR NOT IsZahl(S) THEN BEGIN
      PutData(ch,#13+'Syntax error'+#13+SysText(ch,5)+#13#13);
      Exit;
    END;
    VAL(Hlp,Von,code);
    VAL(S,Bis,code);
  END;

  Lock := GetReadLockInfo(Rubrik);

  ASSIGN(IdxFile,BoxPath+'index'+PATH_SEP+klein(Rubrik)+'.idx');
  {$I-}
  RESET(IdxFile);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    PutData(ch,#13+SysText(ch,37)+' '+Rubrik+#13#13);
    Exit;
  END;

  PutData(ch,#13);
  FOR i := Von TO Bis DO BEGIN
    SEEK(IdxFile,i-1);
    IF EOF(IdxFile) THEN BEGIN
      STR(i,Hlp);
      PutData(ch,'File Nr '+Hlp+' '+SysText(ch,43)+#13);
    END
    ELSE BEGIN
      READ(IdxFile,Idx);


      OK := FALSE;
      IF CutSSID(KS[ch]^.Call)=Idx.Absender THEN OK := TRUE;
      IF CutSSID(KS[ch]^.Call)=Gross(Rubrik) THEN OK := TRUE;

                   {Ungelesen - Flags siehe BOXVARS.PAS}
      IF (Lock=1) AND (Idx.Flags AND VERWALT_READ=0) THEN OK := FALSE;
      IF NOT Rufz(Call) AND Rufz(Rubrik) THEN OK := FALSE;
      IF KS[ch]^.Lev>10 THEN OK := TRUE;
      IF Idx.Flags AND VERWALT_DEL>0 THEN OK := FALSE;


      IF OK THEN BEGIN
        ASSIGN(Source,BoxPath+Idx.FileName);
        {$I-}
        RESET(Source,1);
        {$I+}
        IF IOResult<>0 THEN BEGIN
          STR(i,Hlp);
          PutData(ch,'File Nr '+Hlp+' '+SysText(ch,43)+#13);
        END
        ELSE BEGIN
          ASSIGN(Desti,BoxPath+'import'+PATH_SEP+FindUniqueImportFilename);
          ASSIGN(f,BoxPath+Idx.FileName);
          REWRITE(Desti,1);

          {Hier wird alles mit untypisierten Files gemacht, weil BIN-Files
           auch transferiert werden knnen}
          Len := 0;
          IF LENGTH(Verteiler)>0 THEN Strg2Arr255(Arr255,'S '+Call+'@'+Verteiler+' < '+Idx.Absender,Len)
                                 ELSE Strg2Arr255(Arr255,'S '+Call+' < '+Idx.Absender,Len);
          AddCRLF(Arr255,Len);
          BLOCKWRITE(Desti,Arr255,Len);

          Len := 0;
          STrg2Arr255(Arr255,Idx.Titel,Len);
          AddCRLF(Arr255,Len);
          BLOCKWRITE(Desti,Arr255,Len);

          akttime := AktLongTime;  {Aktuelle Zeit mit Packtime}

          Len := 0;
          Strg2Arr255(Arr255,SFHeaderText(AktLongTime,FALSE,Idx.BID,FALSE),Len);
          AddCRLF(Arr255,Len);
          BLOCKWRITE(Desti,Arr255,Len);

          Len := 0;
          Strg2Arr255(Arr255,'Transfer: '+CutSSID(KS[ch]^.Call)+' @ '+CutSSID(BoxCall)+' '+Pack2STRDate(akttime)+' '+
                      Pack2STRTime(akttime),Len);
          AddCRLF(Arr255,Len);
          BLOCKWRITE(Desti,Arr255,Len);

          CLOSE(Source);

          RESET(f);
          SrcHeadLen := 0;  {Lnge mitzhlen}
          WHILE (S<>'NNNN') AND NOT EOF(f) DO BEGIN
            READLN(f,S);
            SrcHeadLen := SrcHeadLen + LENGTH(S) + 2;
          END;
          CLOSE(f);
          RESET(Source,1);
          SEEK(Source,SrcHeadLen);

          REPEAT
            BLOCKREAD(Source,Arr255,255,Result);
            BLOCKWRITE(Desti,Arr255,Result);
          UNTIL Result<255;
          CLOSE(Source);
          CLOSE(Desti);

          inc(Anz);    {Anzahl transferierter Mails hochzhlen}
        END;
      END;
    END;
  END;
  CLOSE(IdxFile);

  CASE Anz OF
    0: PutData(ch,#13+'Keine Mails transferiert.'+#13#13);
    1: PutData(ch,#13+'1 Mail transferiert.'+#13#13);
    ELSE BEGIN
      STR(Anz,S);
      PutData(ch,#13+S+' Mails transferiert.'+#13#13);
    END;
  END;
END;




{Festgelegte Syntax:
  FORWARD [<Rubrik>] <Nr> [-<Nr>] > <Neu_Rubrik> [@ <Neu_Verteiler>]

  Wird die Rubrik nicht mit angegeben, wird die originale genommen.
}
PROCEDURE Forward_Cmd(ch: BYTE; S: STRING);
VAR Rubrik,SF_Partner: STRING[20];
    Hlp,Call,Verteiler: STRING;
    code,Von,Bis,i: WORD;
    IdxFile: FILE OF Verwalt_Rec;
    Idx: Verwalt_Rec;
    OK,dummy: BOOLEAN;
    Lock,Len,Anz: BYTE;
    akttime: LONGINT;
    Arr255: tArr255;
    SFFile: FILE OF SF_File_Rec;
    SF: SF_File_Rec;
    Typ: CHAR;
    Hold: BOOLEAN;
LABEL feddich;
BEGIN
  Anz := 0;

  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  S := Gross(LTRIM(RTRIM(OnlyOneSpace(S))));
  S := OnlyOneSpace(S);
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  IF POS('@',S)=0 THEN BEGIN
    PutData(ch,#13+'Syntax: FORWARD [<Board>] <Nr> [-<Nr>] @ <MBX>'+#13#13);
    Exit;
  END;


  {Verteiler 'raus}
  Verteiler := LTRIM(RTRIM(COPY(S,POS('@',S)+1,255)));
  S := LTRIM(RTRIM(COPY(S,1,POS('@',S)-1)));


  IF GetFileParams(S,KS[ch]^.BoxData^.Rubrik,Von,Bis,Rubrik) <> 0 THEN BEGIN
    PutData(ch,#13+'Syntax: FORWARD [<Board>] <Nr> [- <Nr>] @ <MBX>'+#13#13);
    Exit;
  END
  ELSE PutData(ch,#13);



  {Kontrolle, ob der angegebene Verteiler bekannt ist.}
  SF_Partner := SendToSFPartner(Verteiler);


  IF SF_Partner='' THEN BEGIN
    PutData(ch,#13+'S&F-Partner fr Mails an '+Verteiler+' ist nicht bekannt!'+#13#13);
    Exit;
  END;



  PutData(ch,#13);
  Lock := GetReadLockInfo(Rubrik);

  ASSIGN(IdxFile,BoxPath+'index'+PATH_SEP+klein(Rubrik)+'.idx');
  {$I-}
  RESET(IdxFile);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    PutData(ch,#13+SysText(ch,37)+' '+Rubrik+#13#13);
    Exit;
  END;

  PutData(ch,#13);
  IF von=0 THEN von:=1;
  IF bis>von THEN goto feddich;
  FOR i := Von TO Bis DO BEGIN
    SEEK(IdxFile,i-1);
    IF EOF(IdxFile) OR (IORESULt<>0) THEN BEGIN
      STR(i,Hlp);
      PutData(ch,'File Nr '+Hlp+' '+SysText(ch,43)+#13);
      Goto Feddich;
    END
    ELSE BEGIN
      READ(IdxFile,Idx);

      {Es darf nur derjenige eine Mail zum Forward eintragen, der entweder
       die Mail geschrieben hat, oder an den die Mail (original) geht.}
      OK := FALSE;
      IF (CutSSID(KS[ch]^.Call)=Idx.Absender) AND (Idx.Rubrik=Call) THEN OK := TRUE;
      IF (CutSSID(KS[ch]^.Call)=Gross(Rubrik)) AND (Idx.Rubrik=Call) THEN OK := TRUE;
      IF KS[ch]^.Lev>10 THEN OK := TRUE;
      IF Idx.Flags AND VERWALT_DEL>0 THEN OK := FALSE;

      IF OK THEN BEGIN
        {Test, ob das File schon an den angegebenen S&F-Partner in
         SFLISTE steht}
        ASSIGN(SFFile,BoxPath+'sfliste');
        {$I-}
        RESET(SFFile);
        {$I+}
        IF IOResult=0 THEN BEGIN
          dummy := FALSE;
          WHILE NOT EOF(SFFile) AND NOT dummy DO BEGIN
            READ(SFFile,SF);
            IF (SF.BID=Idx.BID) AND (SF.SF_Partner=SF_Partner) THEN dummy := TRUE;
          END;
          IF dummy THEN BEGIN
            STR(i,Hlp);
            PutData(ch,'File Nr '+Hlp+' (BID:'+Idx.BID+') ist schon bei '+SF_Partner+' eingetragen.'+#13);
          END
          ELSE BEGIN
            Idx.MBX := Verteiler;
            IF Idx.FileName[1]='U' THEN Typ := 'U'
                                   ELSE Typ := 'B';
            S := Hierachie(Idx.MBX);

            {Evtl. Hold}
            Hold := HoldThisMail(FALSE,KS[ch]^.BoxData^. PW,Typ='U',Idx,Typ);

            MakeEintrag(Idx,Hlp,SF_Partner,Typ,TRUE,dummy,S,Hold);
          END;
          CLOSE(SFFile);
        END
        ELSE BEGIN
          Idx.MBX := Verteiler;
          IF Idx.FileName[1]='U' THEN Typ := 'U'
                                 ELSE Typ := 'B';
          S := Hierachie(Idx.MBX);

          {Evtl. Hold}
          Hold := HoldThisMail(FALSE,KS[ch]^.BoxData^. PW,Typ='U',Idx,Typ);

          MakeEintrag(Idx,Hlp,SF_Partner,Typ,TRUE,dummy,S,Hold);
        END;

        inc(Anz);    {Anzahl geforwardeten Mails hochzhlen}
      END;
    END;
  END;
 Feddich:
  CLOSE(IdxFile);

  CASE Anz OF
    0: PutData(ch,#13+'Keine Mails ');
    1: PutData(ch,#13+'1 Mail ');
    ELSE BEGIN
      STR(Anz,S);
      PutData(ch,#13+S+' Mails ');
    END;
  END;
  PutData(ch,'aus Rubrik '+Rubrik+' geforwardet.'+#13#13);
END;



{Sendet den Aktuell-Text}
PROCEDURE Aktuell(ch: BYTE);
BEGIN
  SendMacroFile(ch,BoxPath+'msg'+PATH_SEP+'news.'+klein(KS[ch]^.BoxData^.Spk));
  PutData(ch,#13);
END;


{Anzeigen des Reject-Files im Speicher}
PROCEDURE ListReject(ch: BYTE);
VAR tmp: pReject_Box;
    anz: WORD;
    S: STRING;
BEGIN
  tmp := Reject_Box_Root;
  anz := 0;
  WHILE tmp<>NIL DO BEGIN
    inc(anz);
    CASE tmp^.Was OF
      1: S := 'R ';
      2: S := 'H ';
      3: S := 'L ';
    END;
    S := S + tmp^.Typ + ' ' + tmp^.Absender + ' ' + tmp^.Rubrik + ' ' + tmp^.MBX + ' ' + tmp^.BID + ' ';
    IF tmp^.Not_Hold AND 1>0 THEN S := S + 'P';
    IF tmp^.Not_Hold AND 2>0 THEN S := S + 'U';
    IF anz=1 THEN PutData(ch,#13);
    PutData(ch,S+#13);
    tmp := tmp^.next;
  END;

  CASE anz OF
    0: PutData(ch,#13+SysText(ch,116){'Keine Eintrge in REJECT.BOX gefunden.'}+#13#13);
    1: PutData(ch,#13+SysText(ch,117){'Einen Eintrag in REJECT.BOX gefunden.'}+#13#13);
    ELSE BEGIN
    STR(anz,S);
    PutData(ch,#13+S+' '+SysText(ch,118){'Eintrge in REJECT.BOX gefunden.'}+#13#13);
    END;
  END;
END;



{Lscht HOLD-Bits}
PROCEDURE NotHold_Cmd(ch: BYTE; S: STRING);
VAR Von,Bis,i,Anz: WORD;
    Rubrik: STRING[6];
    tmp: BYTE;
    IdxFile: FILE OF Verwalt_Rec;
    Idx: Verwalt_Rec;
BEGIN
  IF POS(#13,S)>0 THEN DELETE(S,POS(#13,S),1);
  S := OnlyOneSpace(Gross(LTRIM(RTRIM(S))));
  IF POS(' ',S)>0 THEN S := COPY(S,POS(' ',S)+1,255)
                  ELSE S := '';

  {Kommandozeile auswerten}
  tmp := GetFileParams(S,KS[ch]^.BoxData^.Rubrik,Von,Bis,Rubrik);

  IF (tmp>0) OR (Von > Bis) OR (S='') THEN BEGIN
    PutData(ch,#13+'Syntax: NOTHOLD [<Board>] <Nr> [- [<Nr>]]'+#13#13);
    Exit;
  END;

  {Index-File ffnen}
  ASSIGN(IdxFile,BoxPath+'index'+PATH_SEP+klein(Rubrik)+'.idx');
  {$I-}
  RESET(IdxFile);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    {Index-File nicht vorhanden -> keine Mail in dieser Rubrik da}
    PutData(ch,#13+SysText(ch,122)+' '+Rubrik+' '+SysText(ch,123)+#13#13);
    Exit;
  END;


  PutData(ch,#13);              {Leerzeile}
  Anz := 0;
  i := Von;
  WHILE i<= Bis DO BEGIN        {Bis zum bitteren Ende.}
    SEEK(IdxFile,i-1);
    IF EOF(IdxFile) THEN BEGIN
      IF i<Bis THEN BEGIN
        {Text: Nr x ist die letzte Mail in dieser Rubrik.}
        STR(i,S);
        PutData(ch,SysText(ch,42)+' '+S+' '+SysText(ch,124)+#13);
      END;
      IF Anz>1 THEN BEGIN
        STR(Anz,S);
        PutData(ch,'Bei '+S+' Mails wurde das Hold-Flag gelscht'+#13#13);
      END
      ELSE BEGIN
        CASE Anz OF
          0: PutData(ch,'Bei keinen Mails das Hold-Flag gelscht!'+#13#13);
          1: PutData(ch,'Bei einer Mail das Hold-Flag gelscht'+#13#13);
        END;
      END;
      CLOSE(IdxFile);
      Exit;
    END;
    READ(IdxFile,Idx);
    IF Idx.Flags AND VERWALT_HOLD=0 THEN BEGIN
      {Text: Nr x ist nicht zum Hold markiert.}
      STR(i,S);
      PutData(ch,SysText(ch,42)+' '+S+' '+SysText(ch,125)+' (Board '+Rubrik+')'+#13);
    END
    ELSE BEGIN
      inc(Anz);
      SEEK(IdxFile,i);
      {Hold-Flag im Verwaltungsfile lschen}
      Idx.Flags := Idx.Flags AND $FFFF - VERWALT_HOLD;
      WRITE(IdxFile,Idx);
      {Hold-Flag im Checkfile lschen}
      DelHoldFlag_CheckFile(Idx.BID);
      {Hold-Flag in der SFLISTE lschen}
      DelHoldFlag_SFLISTE(Idx.BID);
    END;
    inc(i);
  END;
  CLOSE(IdxFile);
  IF Anz>1 THEN BEGIN
    STR(Anz,S);
    PutData(ch,'Bei '+S+' Mails wurde das Hold-Flag gelscht'+#13#13);
  END
  ELSE BEGIN
    CASE Anz OF
      0: PutData(ch,'Bei keinen Mails das Hold-Flag gelscht!'+#13#13);
      1: PutData(ch,'Bei einer Mail das Hold-Flag gelscht'+#13#13);
    END;
  END;
END;


{Delete-Flags in Index-Files, CHECK.BOX und SFLISTE lschen}
PROCEDURE Undelete(ch: BYTE; S: STRING);
VAR Von,Bis: WORD;
    Rubrik: STRING[8];
    IdxF: FILE OF Verwalt_Rec;
    Idx: Verwalt_Rec;
    CheckF: FILE OF CheckRec;
    Check: CheckRec;
    i,anz: WORD;
    Found: BOOLEAN;
BEGIN
  IF POS(#13,S) > 0 THEN DELETE(S,POS(#13,S),1);
  IF POS(' ',S) > 0 THEN S := COPY(S,POS(' ',S)+1,255)
                    ELSE S := '';

  IF GetFileParams(S,KS[ch]^.BoxData^.Rubrik,Von,Bis,Rubrik) <> 0 THEN BEGIN
    PutData(ch,#13+'Syntax: UNDELETE [<Board>] <nr> [- [<nr>]]'+#13#13);
    PutData(ch,BoxPrompt(ch));
    Exit;
  END;

  IF Von>Bis THEN BEGIN
    PutData(ch,#13+'Syntax: UNDELETE [<Board>] <nr> [- [<nr>]]'+#13#13);
    Exit;
  END;

  ASSIGN(IdxF,BoxPath+'index'+PATH_SEP+klein(Rubrik)+'.idx');
  {$I-}
  RESET(IdxF);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    {Keine Mails vorhanden fr}
    PutData(ch,#13+SysText(ch,37)+' '+Rubrik+#13#13);
    Exit;
  END;

  i := Von;
  anz := 0;
  WHILE (i<=Bis) DO BEGIN
    SEEK(IdxF,i-1);
    IF EOF(IdxF) THEN BEGIN
      IF anz=0 THEN PutData(ch,#13+'0 Files undeleted.'+#13#13)
               ELSE IF Anz=1 THEN PutData(ch,#13+'1 File undeleted.'+#13#13)
                             ELSE BEGIN
                                    STR(anz,S);
                                    PutData(ch,#13+S+' Files undeleted.'+#13#13);
                                  END;
      CLOSE(IdxF);
      Exit;
    END;

    READ(IdxF,Idx);
    SEEK(IdxF,FILEPOS(IdxF)-1);
    Idx.Flags := Idx.Flags AND $FFFF-VERWALT_DEL;
    WRITE(IdxF,Idx);

    {Del-Flag in CHECK.BOX lschen}
     ASSIGN(CheckF,BoxPath+'check.box');
    {$I-}
    RESET(CheckF);
    {$I+}
    IF IOResult=0 THEN BEGIN
      Found := FALSE;
      WHILE NOT EOF(CheckF) AND NOT Found DO BEGIN
        READ(CheckF,Check);
        IF Check.BID=Idx.BID THEN BEGIN
          Found := TRUE;
          SEEK(CheckF,FILEPOS(CheckF)-1);
          Check.Flags := Check.Flags AND $FFFF - CHECK_DEL;
          WRITE(CheckF,Check);
        END;
      END;
      CLOSE(CheckF);
    END;
    inc(i);
    inc(anz);
  END;
  CLOSE(IdxF);
  IF anz=0 THEN PutData(ch,#13+'0 Files undeleted.'+#13#13)
           ELSE IF Anz=1 THEN PutData(ch,#13+'1 File undeleted.'+#13#13)
                         ELSE BEGIN
                                STR(anz,S);
                                PutData(ch,#13+S+' Files undeleted.'+#13#13);
                              END;
END;


(*****************************************************************************)
(*   Reload, ldt diverse Configurations-Dateien neu. RELOAD INIT ist noch   *)
(*   zu machen                                                               *)
(*   (iad, dez 95)                                                           *)
(*****************************************************************************)

PROCEDURE Reload_CMD(ch: BYTE; S:STRING);
BEGIN
  WHILE ((S[0]>#0) AND ((S[length(s)]=#13) OR (S[length(s)]=#10))) DO DEC(byte(S[0]));
  IF (POS(' ',s)=0) THEN
  BEGIN
    PutData(ch,'RELOAD SF|REJECT|SERVER|DIR|INIT|ALL'+#13);
    exit;
  END;
  S:=COPY(s,pos(' ',s)+1,255);
  S:=LTRIM(GROSS(s));
  S:=RTRIM(S);
  PutData(ch,s+#13);
  IF (s='') THEN
  BEGIN
    PutData(ch,'RELOAD SF|REJECT|SERVER|DIR|INIT|ALL'+#13);
    exit;
  END;
  IF (S='SF') THEN
  BEGIN
    FreeBoxSF;
    ReadBoxSF(ch,FALSE);
  END ELSE
  IF (S='REJECT') THEN
  BEGIN
    FreeRejectBox;
    ReadRejectBox(ch,FALSE);
  END ELSE
  IF (S='SERVER') THEN
  BEGIN
    FreeServerBox;
    ReadServerBox(ch,FALSE);
  END ELSE
  IF (S='DIR') THEN
  BEGIN
    FreeDirInfo;
    ReadDirData(ch,FALSE);
  END ELSE
  IF (S='INIT') THEN
  BEGIN
    PutData(ch,'Noch nicht eingebaut'#13);
  END ELSE
  IF (S='ALL') THEN
  BEGIN
    FreeBoxSF;
    ReadBoxSF(ch,FALSE);
    FreeRejectBox;
    ReadRejectBox(ch,FALSE);
    FreeServerBox;
    ReadServerBox(ch,FALSE);
    FreeDirInfo;
    ReadDirData(ch,FALSE);
  END ELSE
    PutData(ch,'RELOAD SF|REJECT|SERVER|DIR|INIT|ALL'+#13);
END;

(***************************************************************************)
(*      Der ROUTE Befehl, ruft BOXSF.AddSFListe mit nurtest=TRUE auf       *)
(*      (iad, dez 95)                                                      *)
(***************************************************************************)


PROCEDURE Route_CMD(ch:BYTE; S:STRING);
VAR l,r:STRING;
    info:Verwalt_REC;
BEGIN
  WHILE ((S[0]>#0) AND ((S[length(s)]=#13) OR (S[length(s)]=#10))) DO DEC(byte(S[0]));
  S:=COPY(s,pos(' ',s)+1,255);
  S:=LTRIM(GROSS(s));
  S:=RTRIM(S);
  PutData(ch,s+#13);
  IF (s='') THEN
  BEGIN
    PutData(ch,'ROUTE <verteiler/bbs>'+#13);
    exit;
  END;
  info.rubrik:='TEST';
  IF find(s,'.',l,r) THEN
    s:=l
  ELSE
    r:='';
  info.mbx:=s;
  ADDSFLISTE(cutssid(boxcall),info,'B',FALSE,r,FALSE,TRUE);
  IF RoutingTo='' THEN
    PutData(ch,'no route to: '+s+#13) ELSE
    PutData(ch,'forwarding '+s+' to :'+routingto+#13);
END;


(****************************************************************************)
(*      Der neue List-Befehl. Wertet die Befehlszeile aus, reserviert       *)
(*    Speicher fr KS[ch]^.BoxData^.ListData^, weist die entsprechenden     *)
(*    Variablen zu, setzt KS[ch]^.BoxData^.Status auf 6                     *)
(*    (iad, dez 95)                                                         *)
(****************************************************************************)


PROCEDURE ListInit(ch: BYTE; S: STRING);
BEGIN
END;



(*
 *  PROCEDURE Reply_CMD
 * Schickt eine persnliche Mail als Antwort auf die zuletzt gelesene
 * Mail. Als Titel wird der zuletzt eingegebene mit 'RE:' davor genommen.
 *)
PROCEDURE Reply_CMD(ch: BYTE);
BEGIN

  IF KS[ch]^.BoxData^.M_Sender='' THEN BEGIN
    PutData(ch,#13+'You did not read any message. You must read one before using this command.'+#13#13);
    Exit;
  END;

  {Speicher fr die Send-Informationen reservieren}
  new(KS[ch]^.BoxData^.SendData);

  {Variablen in diesem Record setzen}
  WITH KS[ch]^.BoxData^.SendData^ DO BEGIN
    BID := Neu_BID;
    LTOK := FALSE;
    An := KS[ch]^.BoxData^.M_Sender;    {Absender der zuletzt gelesenen Mail}
    An_Trans := An;
    Verteiler := GetMYBBS(An);
    IF Verteiler = '' THEN Verteiler := Gross(CutSSID(BoxCall));
    UserMail := TRUE;
    Titel := 'RE:' + KS[ch]^.BoxData^.M_Titel;
    Hierach := Hierachie(Verteiler);
    BIN := FALSE;
  END;

  {Datei ffnen und Fileheader dazu}
  AddFileHeader(ch);

  {Text an den User senden, da er jetzt die Mail eingeben kann}
  PutData(ch,#13+SysText(ch,34)+' '+KS[ch]^.BoxData^.SendData^.An+' @ '+KS[ch]^.BoxData^.SendData^.Verteiler
         +Hierachie(KS[ch]^.BoxData^.SendData^.Verteiler)+#13);
  PutData(ch,SysText(ch,35)+#13#13);

  {Status neu setzen}
  KS[ch]^.BoxData^.status := 3;
END;



(*
 *  PROCEDURE Comment_CMD
 * Schickt eine Antwort in die Rubrik mit dem Verteiler, aus der die
 * letzte Mail gelesen wurde.
 *)
PROCEDURE Comment_CMD(ch: BYTE);
BEGIN

  IF Rufz(KS[ch]^.BoxData^.Rubrik) THEN BEGIN
    PutData(ch,#13+'Die letzte Mail war eine Usermail. Zum Beantworten von Usermails'+#13
                  +'bitte den REPLY-Befehl benutzen.'+#13#13);
    Exit;
  END;

  {Speicher fr die Send-Informationen reservieren}
  new(KS[ch]^.BoxData^.SendData);

  {Variablen in diesem Record setzen}
  WITH KS[ch]^.BoxData^.SendData^ DO BEGIN
    BID := Neu_BID;
    LTOK := FALSE;
    An := KS[ch]^.BoxData^.Rubrik;   {Rubrik der zuletzt gelesenen Mail}
    An_Trans := An;
    Verteiler := KS[ch]^.BoxData^.M_Verteil;
    UserMail := TRUE;
    Titel := 'RE:' + KS[ch]^.BoxData^.M_Titel;
    Hierach := '';
    BIN := FALSE;
  END;

  {Datei ffnen und Fileheader dazu}
  AddFileHeader(ch);

  {Text an den User senden, da er jetzt die Mail eingeben kann}
  PutData(ch,#13+SysText(ch,34)+' '+KS[ch]^.BoxData^.SendData^.An+' @ '+KS[ch]^.BoxData^.SendData^.Verteiler
         +Hierachie(KS[ch]^.BoxData^.SendData^.Verteiler)+#13);
  PutData(ch,SysText(ch,35)+#13#13);

  {Status neu setzen}
  KS[ch]^.BoxData^.status := 3;

END;


{$IFDEF EDITOR}

(*
 *  PROCEDURE XReply_CMD
 * Wie Reply_CMD, nur fr User an der Konsole (eingebauter Editor)
 *)
PROCEDURE XReply_CMD(ch: BYTE);
VAR f,f2: Text;
    S,Filename: STRING;
BEGIN

  IF KS[ch]^.Loop=0 THEN BEGIN
    PutData(ch,#13+'You must login on a loop-channel!'+#13);
    Exit;
  END;
  IF editor.aktiv THEN BEGIN
    PutData(ch,#13+'Editor already in use!'+#13);
    Exit;
  END;

  IF KS[ch]^.BoxData^.M_Sender='' THEN BEGIN
    PutData(ch,#13+'You did not read any message. You must read one before using this command.'+#13#13);
    Exit;
  END;

  Editor.Title := 'RE:'+KS[ch]^.BoxData^.M_Titel;
  Editor.Absender := CutSSID(KS[ch]^.Call);
  Editor.Empfaenger := KS[ch]^.BoxData^.M_Sender;
  Editor.Verteiler := GetMYBBS(Editor.Empfaenger);
  IF Editor.Empfaenger = '' THEN Editor.Empfaenger := Gross(CutSSID(BoxCall));

  {File erzeugen und Text 'reinkopieren.}
   Filename := BoxPath+'temp'+PATH_SEP+'xreply.txt';
  ASSIGN(f,Filename);
  {$I-}
  REWRITE(F);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    PutData(ch,#13+'Fehler beim Erstellen des temporren Files'+#13#13);
    Exit;
  END;
  ASSIGN(f2,BoxPath+KS[ch]^.BoxData^.M_FileName);
  {$I-}
  RESET(f2);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    PutData(ch,#13+'Dieser Fehler sollte eigentlich nie auftreten... irgendwas ist'+#13+
                   'total falsch gelaufen. Sri, kein XREPLY'+#13#13);
    Exit;
  END;
  S := '';
  WHILE NOT EOF(f2) AND (S<>'NNNN') DO READLN(f2,S);
  WriteLN(f);
  WriteLn(f,editor.empfaenger+' wrote :');
  WHILE NOT EOF(f2) DO BEGIN
    READLN(f2,S);
    WRITELN(f,'> '+S);
  END;
  CLOSE(f2);
  CLOSE(f);

  Editor.Load(Filename,'');
END;
{$ENDIF}


(*
 *  PROCEDURE CONFIG_CMD
 * Zeigt eine Konfigurations-Information der Mailbox an.
 *)
PROCEDURE CONFIG_CMD(ch: BYTE);
VAR S: STRING;
BEGIN
  PutData(ch,#13'Mailbox-Configuration'#13#13);
  PutData(ch,'  Boxcall:    '+BoxCall+#13);
  PutData(ch,'  Hierarch:    '+OwnBoxData^.Hierach+#13);
  PutData(ch,'  SFInfo:     '+OwnBoxData^.SFInfo+#13);
  STR(OwnBoxData^.User_LT,S);
  PutData(ch,'  UserLT:     '+S+#13);
  PutData(ch,'  M/E-MBX:    '+OwnBoxData^.M_E_MBX+#13);
  PutData(ch,'  DB0_MYBBS:  ');
  IF OwnBoxData^.DB0_MYBBS THEN PutData(ch,'YES'#13)
                           ELSE PutData(ch,'NO'#13);
  PutData(ch,'  SF_all:     ');
  IF OwnBoxData^.SF_mit_jedem THEN PutData(ch,'YES'#13)
                              ELSE PutData(ch,'NO'#13);
  PutData(ch,'  ThirdParty: ');
  IF OwnBoxData^.Third_Party THEN PutData(ch,'YES'#13)
                             ELSE PutData(ch,'NO'#13);
  PutData(ch,#13);
END;

END.

