(***************************************************************************)
(**                            UNIT BOXUTIL.PAS                           **)
(***************************************************************************)
(**  Viele Utilities und andere Hilfsroutinen fr die Mailbox.            **)
(**                                                                       **)
(** Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei      **)
(** DG4IAD und DG6VJ                                                      **)
(**                                                                       **)
(** dg6vj, mar 96                                                         **)
(***************************************************************************)
UNIT BOXUTIL;

INTERFACE


USES BOXVARS;

{Konstanten fr Funktion AbisZ (BID)}
CONST Buchst: ARRAY[0..35] OF CHAR =
        ('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F','G',
         'H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X',
         'Y','Z');
TYPE str3 = STRING[3];
     str4 = STRING[4];
     str5 = STRING[5];
     str6 = STRING[6];
     str8 = STRING[8];
     str10 = STRING[10];
     str12 = STRING[12];
     str15 = STRING[15];
     str40 = STRING[40];
     str127 = STRING[127];


PROCEDURE ProfileBox(S:STRING;Flag:LONGINT);
PROCEDURE SendMacroFile(ch:byte;name:string);
FUNCTION ExpandMacros(ch:byte;var tmpstr:string):STRING;
FUNCTION DateInt(Date: STRING): LONGINT;
FUNCTION PackTime2Int(PackedTime: LONGINT): LONGINT;
FUNCTION BoxPrompt(ch: BYTE): STRING;
FUNCTION Neu_BID: str12;
FUNCTION LifeTime(Rubrik: str8): WORD;
FUNCTION Rufz(Call: str8): BOOLEAN;
PROCEDURE MakeDir(Dir:STRING);
PROCEDURE CheckLT(VAR LT: WORD; Rubrik: str8);
PROCEDURE StandardLT(VAR LT: WORD; Rubrik: str8);
PROCEDURE CheckDBLT(VAR LT: INTEGER; Rubrik: str8);
PROCEDURE StandardDBLT(VAR LT: INTEGER; Rubrik: str8);
FUNCTION Verwalt2ListLine(Info: Verwalt_Rec; Nr: WORD): STRING;
PROCEDURE SortDirInfo;
FUNCTION BuildHeader(ch: BYTE; Idx: Verwalt_Rec): STRING;
PROCEDURE AddBIDFile(BID: str12;rubrik:str8;pi:word;pc:longint);
FUNCTION FastSFPartner(Call: str6): str6;
FUNCTION SF_User(Call: str6): BOOLEAN;
FUNCTION Hierachie(Call: str6): STRING;
FUNCTION SFHeaderText(RX_Date: LONGINT; SendInfo: BOOLEAN; BID: str12; PW: BOOLEAN): STRING;
(* FUNCTION Unix2Pack(Unix: LONGINT): LONGINT;
FUNCTION Pack2Unix(Pack: LONGINT): LONGINT; *)
PROCEDURE CheckForAutorouter(ch: BYTE; S: STRING;VAR Auswert: BOOLEAN; VAR SFPartner,RXFrom: str6;VAR DeleteIt:BOOLEAN);
FUNCTION Pack2STRDate(Pack: LONGINT): STRING;
FUNCTION Pack2STRTime(Pack: LONGINT): STRING;
FUNCTION TimeLong(sec: LONGINT): STRING;
FUNCTION IsInBadCalls(Call: str6): BOOLEAN;
FUNCTION CheckSum(S: STRING; Sum: BYTE): BYTE;
PROCEDURE AddCheckFile(Verwalt: Verwalt_Rec; Nr: WORD; Hold, SysOp_only: BOOLEAN;var pos_in_check:LONGINT);
PROCEDURE DelCheckFile(BID: str12);
FUNCTION AktLongTime: LONGINT;
PROCEDURE SendM_Mail(Call, BBS: str6);
FUNCTION TCPIP_BOX(Call: str6; VAR Strg: STRING): BOOLEAN;
PROCEDURE BenachrichtigeUser(Call: str6;ch: BYTE);
PROCEDURE ProtoEingabe(c: BYTE; S: STRING);
PROCEDURE AktSetAusgeb(ch: BYTE; SetInfo: BYTE);
PROCEDURE SetOptionsDialog(ch: BYTE; S: STRING);
FUNCTION SizeHeader(FileName: STRING): WORD;
{FUNCTION FileDa(DateiName: STRING): BOOLEAN;}
FUNCTION FindUniqueImportFilename: STRING;
FUNCTION IsZahl(S: STRING): BOOLEAN;
PROCEDURE DelSpaces(VAR S: STRING);
FUNCTION TransferMail(RubName: str8): str8;
PROCEDURE SendTextFile(ch: BYTE; FileName: STRING);
PROCEDURE PutCallToReadLine(ch: BYTE; FileName: STRING; Call: STRING);
PROCEDURE SendReadLine(ch: BYTE; VAR LEN: LONGINT; FileName: STRING);

{Umbauen eines Pascal-Strings in ein Array (fr BLOCKWRITE)}
PROCEDURE Strg2Arr255(VAR Arr255: tArr255; S: STRING; VAR Len: BYTE);

{CRLF (return) an ein Array hngen}
PROCEDURE AddCRLF(VAR Arr255: tArr255; VAR Len: BYTE);

FUNCTION SysText(ch: BYTE; TextNr: BYTE): STRING;
FUNCTION SysTextWithSpk(lan: str3; TextNr: BYTE): STRING;

FUNCTION BID_Da(BID: str12): BOOLEAN;

{Routinen fr passwort-geschtztes Forward}
FUNCTION SF_Passwort(Call: str6): BOOLEAN;
FUNCTION PasswdTime_CalcPW(ch: BYTE): STRING;
FUNCTION CalcPassword_SF(ch: BYTE; Time: STRING): STRING;

{Zerflckt eine bergebene Parameter-Zeile (Rubrik, Von, Bis)}
FUNCTION GetFileParams(S: STRING; AktRub: str8; VAR Von,Bis: WORD; VAR Rubrik: str8): BYTE;

{Lscht bei der Mail mit der bergebenen BID das Holdflag}
PROCEDURE DelHoldFlag_CheckFile(BID: str12);

{Lscht das Hold-Flag bei allen Mails mit der angegebenen BID in SFLISTE}
PROCEDURE DelHoldFlag_SFLISTE(BID: str12);

FUNCTION SendToSFPartner(Boxcall: str8): str8;

{Fllt den String mit leerzeichen bis zur lnge count auf}
FUNCTION FillStr(count: BYTE; S: STRING): STRING;

{Sucht das letzte Vorkommen von Zeichen im String}
FUNCTION Last(Zeichen: CHAR; S: STRING): BYTE;
FUNCTION What_SID(Call: str6): BYTE;


IMPLEMENTATION

USES BOXSF,TOOLBOX,BOXCMD,WGTCRC,DOS,BOXHUSER,MYSTRING,IADVAR;

PROCEDURE ProfileBox(S:STRING;FLAG:LONGINT);
VAR f:text; dt:longint;
BEGIN
  IF (WHAT_TO_LOG AND FLAG)=0 THEN exit;
   assign(f,boxpath+'profile.box');
  {$I-}
  append(f);
  IF ioresult<>0 THEN
  BEGIN
    rewrite(f);
    If IORESULT<>0 THEN
     exit;
    WRITELN(f,'This file contains information about routing-errors, protocol-errors and');
    WriteLn(f,'other stuff that might be helpful while searching the source of problems');
    WriteLn(f,'File created ',dtdatestr(unix2pack(currixtime)),'-',dttimestr(unix2pack(currixtime)));
    WriteLn(f,'----------------------------------------',
              '----------------------------------------');
  END;
  Getftime(f,dt);
  IF (currixtime-pack2unix(dt))>86000 THEN
    WriteLn(f,'--- ',dtdatestr(unix2pack(currixtime)));
  WriteLN(f,copy(dttimestr(unix2pack(currixtime)),1,5),':',s);
  close(f);
END;

FUNCTION DateInt(Date: STRING): LONGINT;
Const DayMonth : Array [1..12] of Byte =
      (0,31,28,31,30,31,30,31,30,31,30,31);
VAR n: LONGINT;
    i: INTEGER;
    Schaltjahr: BOOLEAN;
    code, T, M, J: INTEGER;
    Lauf: BYTE;
BEGIN
  n := 0;
  VAL(COPY(Date,1,2),T,code);
  VAL(COPY(Date,4,2),M,code);
  VAL(COPY(Date,7,2),J,code);
  FOR i := 70 TO J DO BEGIN
    Schaltjahr := ((i+1900) MOD 4=0) AND ((i+1900) MOD 100<>0) OR ((i+1900) MOD 400=0);
    IF Schaltjahr THEN n := n + 1;
    n := n + 365;
  END;
  n := n + T;
  Inc(n,T);
  Schaltjahr := ((i+1900) MOD 4=0) AND ((i+1900) MOD 100<>0) OR ((i+1900) MOD 400=0);
  For Lauf := 1 to 12 do Begin
   If (Lauf <= M) then Inc(N,DayMonth[Lauf]);
   If Schaltjahr then Inc(N);
  End;
  DateInt := n;
END;


{Zeit in Tagen ab 1.1.1970}
FUNCTION PackTime2Int(PackedTime: LONGINT): LONGINT;
Const DayMonth : Array [1..12] of Byte =
      (0,31,28,31,30,31,30,31,30,31,30,31);
VAR n: LONGINT;
    i: INTEGER;
    Schaltjahr: BOOLEAN;
    code: INTEGER;
    Lauf: Byte;
    T,M,J: WORD;
BEGIN
 n := 0;
  UnpackTime(PackedTime,DT);
  T := DT.Day;
  M := DT.Month;
  J := DT.Year;
 FOR i := 1970 TO J DO BEGIN
  Schaltjahr := ((i+1900) MOD 4=0) AND ((i+1900) MOD 100<>0) OR ((i+1900) MOD 400=0);
  IF Schaltjahr THEN Inc(N);
  Inc(N,365);
 END;
 Inc(n,T);
 Schaltjahr := ((i+1900) MOD 4=0) AND ((i+1900) MOD 100<>0) OR ((i+1900) MOD 400=0);
 For Lauf := 1 to 12 do Begin
  If (Lauf <= M) then Inc(N,DayMonth[Lauf]);
  If Schaltjahr then Inc(N);
 End;
 PackTime2Int := n;
END;

FUNCTION ExpandMacros(ch:byte;var tmpstr:string):STRING;
VAR s:STRING;
    s1:STRING[10];
    i:integer;
    anz,b:BYTE;
    OK:BOOLEAN;
    lint,ti:LONGINT;
BEGIN
   s:='';
   i:=1;
   WHILE i <= LENGTH(tmpstr) DO BEGIN
     IF tmpstr[i]='%' THEN BEGIN
       inc(i);
       CASE UpCase(tmpstr[i]) OF

         '%': S := S + '%';                   {%-Zeichen}
         'M': S := S + CutSSID(BoxCall);      {Mailbox-Rufzeichen}
         'U': BEGIN
                anz := 0;
                FOR b := 0 TO 255 DO BEGIN
                  IF KS[b] <> NIL THEN BEGIN
                    IF KS[b]^.status=50 THEN Anz := Anz + 1;
                  END;
                END;
                STR(anz,S1);
                S := S + S1;
              END;
         'C': S := S + CutSSID(KS[ch]^.Call); {User-Call}
         'B': S := S + KS[ch]^.BoxData^.Rubrik;  {Board-Name}
         'V': S := S + Version;                  {Versions-Nummer}
         '1': BEGIN                              {System-Load}
                STR(SysLoad,S1);
                S := S + S1;
              END;

         'T': BEGIN {Zeit}
                S := S + DtTimeStr(unix2pack(currixtime));
              END;
         'D': BEGIN {Zeit}
                S := S + DtDateStr(unix2pack(currixtime));
              END;
         'L': BEGIN {Lastlogin}
               lint := GetLastQuit(OK,Gross(CutSSID(KS[ch]^.Call)));
               IF OK THEN BEGIN
                 S:= S + DtDateStr(lint)+' - '+DtTimeStr(lint);
               END;
              END;
         'N': IF KS[ch]^.Name='' THEN S:=S + GetName(OK,ch)
                                 ELSE S:=S +KS[ch]^.Name;

         'H': BEGIN    {Helplevel}
                STR(KS[ch]^.BoxData^.HelpLevel,S1);
                S:=S + S1
              END;
         'S': BEGIN    {Helplevel}
                S:=S + KS[ch]^.BoxData^.Spk;
              END;
         '2':S:=S+MkTStr(currixtime-starttime);
       END;
     END
     ELSE S := S + tmpstr[i];
     inc(i);
   END;
   expandmacros:=s;
END;

PROCEDURE SendMacroFile(ch:byte;name:string);
VAR f:text;s:string;
BEGIN
  ASSIGN(f,name);
  RESET(f);
  IF IORESULT>0 THEN exit;
  WHILE NOT EOF(f) DO
  BEGIN
    ReadLn(f,s);
    s:=expandMacros(ch,s);
    PutData(ch,s+#13);
  END;
  CLOSE(f);
END;
{Mailbox-Prompt ausgeben (vorsicht: Kann beliebig gesetzt werden!)}
FUNCTION BoxPrompt(ch: BYTE): STRING;
VAR S,S1: STRING;
    i,b,anz: BYTE;
BEGIN
  S := '';
  IF KS[ch]^.BoxData^.HelpLevel>0 THEN S := S + SysText(ch,114)+#13;
  CASE KS[ch]^.BoxData^.Prompt OF
         {DieBox-Prompt}
      1: S := S + '('+KS[ch]^.BoxData^.Rubrik+') '+CutSSID(KS[ch]^.Call)+' de '+CutSSID(BoxCall)+'>';
    255: BEGIN          {selbst einzustellender Prompt}
           s:=expandmacros(ch,KS[ch]^.BoxData^.Prompt_str^);
         END;
    ELSE S := S + '('+KS[ch]^.BoxData^.Rubrik+') '+CutSSID(KS[ch]^.Call)+' de '+CutSSID(BoxCall)+'>';
  END;
  BoxPrompt := S;
END;


FUNCTION AbisZ(Zahl: WORD): STRING;
VAR Help: WORD;
BEGIN
  Help := Zahl DIV 36;
  Zahl := Zahl MOD 36;
  AbisZ := Buchst[Help]+Buchst[Zahl];
END;

FUNCTION Datum: STRING;
VAR J,M,T,TdW: WORD;
    Monat,Tag: STRING[2];
    Jahr: STRING[4];
BEGIN
  GetDate(J,M,T,TdW);
  STR(J,Jahr);
  STR(M,Monat);
  STR(T,Tag);
  IF LENGTH(Monat)=1 THEN Monat := '0' + Monat;
  IF LENGTH(Tag)=1 THEN Tag := '0' + Tag;
  Datum := Tag + '.' + Monat + '.' + Jahr;
END;


FUNCTION Hex(b:byte):str2;
CONST Table:ARRAY[0..$F] OF CHAR=('0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F');

VAR S: str2; b4,b5,b6:BYTE;
BEGIN
  s:='00';
  s[1]:=Table[b DIV 16];
  s[2]:=Table[(b MOD 16)];
  Hex:=s;
END;


{WAndelt das Jahr in Zahlen von 00 bis ZZ um - 00 = 1994}
FUNCTION PackJahr(S_Jahr: str4): str2;
VAR Jahr,code: WORD;
BEGIN
  VAL(S_Jahr,Jahr,Code);
  Jahr := Jahr - 1994;
  PackJahr := AbisZ(Jahr);
END;


FUNCTION Neu_BID: str12;
VAR f: Text;
    Dat: STRING[10];
    aword,code: WORD;
    S: STRING[10];
    BID: STRING[6];
    Hlp: STRING[2];
BEGIN
  ASSIGN(f,BoxPath+'bid');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    REWRITE(f);
    Dat := Datum;
    WRITELN(f,Dat);
    WRITELN(f,'1');
    CLOSE(f);
    Hlp := COPY(Dat,1,2);
    VAL(Hlp,aword,code);
    Hlp := AbisZ(aword);
    VAL(COPY(Dat,4,2),aword,code);
    Neu_BID := Hlp[2] + COPY(Hex(aword),2,1) + '00'+ CutSSID(BoxCall) + PackJahr(COPY(Dat,7,4));
    Exit;
  END
  ELSE BEGIN
    READLN(f,S);
    IF S=Datum THEN BEGIN
      Dat := Datum;
      VAL(COPY(Dat,4,2),aword,code);
      Hlp := COPY(Dat,1,2);
      VAL(Hlp,aword,code);
      Hlp := AbisZ(aword);
      VAL(COPY(Dat,4,2),aword,code);
      BID := Hlp[2] + COPY(Hex(aword),2,1);
      READLN(f,S);
      IF S='' THEN BEGIN
        aword := 0;
        S := '0';
      END;
      VAL(S,aword,code);
      S := AbisZ(aword);
      BID := BID + S;
      aword := aword + 1;
      STR(aword,S);
      CLOSE(f);
      ERASE(f);
      REWRITE(f);
      WRITELN(f,Dat);
      WRITELN(f,S);
      CLOSE(f);
      Neu_BID := BID + CutSSID(BoxCall) + PackJahr(COPY(Dat,7,4));
      Exit;
    END
    ELSE BEGIN
      {$I-}ERASE(f);{$I+}
      IF IORESULT<0 THEN;
      REWRITE(f);
      Dat := Datum;
      WRITELN(f,Dat);
      WRITELN(f,'1');
      CLOSE(f);
      VAL(COPY(Dat,4,2),aword,code);
      Hlp := COPY(Dat,1,2);
      VAL(Hlp,aword,code);
      Hlp := AbisZ(aword);
      VAL(COPY(Dat,4,2),aword,code);
      Neu_BID := Hlp[2] + COPY(Hex(aword),2,1) + '00' + CutSSID(BoxCall) + PackJahr(COPY(Dat,7,4));
      Exit;
    END;
  END;
END;



{Sucht die Lifetime fr Rubrik aus LIFETIME 'raus}
FUNCTION LifeTime(Rubrik: str8): WORD;
VAR f: Text;
    S: STRING;
    OK: BOOLEAN;
    LT,code: WORD;
BEGIN
  Rubrik := CutSSID(Rubrik);
  Rubrik := LTRIM(Rubrik);
  Rubrik := RTRIM(Rubrik);
  OK := FALSE;

  ASSIGN(f,BoxPath+'lifetime');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult=0 THEN BEGIN
    WHILE NOT EOF(f) AND NOT OK DO BEGIN
      READLN(f,S);
      IF S[1]='*' THEN BEGIN
        VAL(COPY(S,POS(' ',S)+1,255),LT,code);
        IF code <> 0 THEN LifeTime := 30
                     ELSE LifeTime := LT;
      END
      ELSE BEGIN
        IF GROSS(COPY(S,1,POS(' ',S)-1)) = Rubrik THEN BEGIN
          OK := TRUE;
          VAL(COPY(S,POS(' ',S)+1,255),LT,code);
          IF code=0 THEN LifeTime := LT;
        END;
      END;
    END;
    CLOSE(f);
  END
  ELSE LifeTime := 30;          {Standardlifetime, wenn LIFETIME. nicht
                                 vorhanden ist}
END;



{Wenn das zu berprfende Rufzeichen wirklich ein Rufzeichen ist, dann wird
 Rufz zu TRUE}
FUNCTION Rufz(Call: str8): BOOLEAN;
VAR hlp,i: BYTE;
    status: STRING[6];
    err: WORD;
BEGIN
  Rufz := FALSE;
  Call := LTRIM(RTRIM(Call));
  status := '';

  IF LENGTH(Call)>6 THEN Call := COPY(Call,1,6);
  FOR i := 1 TO LENGTH(Call) DO BEGIN
    VAL(Call[i],hlp,err);
    IF err = 0 THEN status := status + 'Z'
               ELSE status := status + 'B';
  END;
  IF (status='BBZBBB') OR (status='BBZBB') OR (status='BBZB') OR (status='BZBBB') OR (status='BZBB') OR (status='ZBZBB') OR
  (status='ZBZBBB') OR (status='BZZBBB') OR (status='BZZBB') THEN BEGIN
    Rufz := TRUE;
  END;
END;

{Verzeichnis mit mehreren Unterverzeichnissen auf einmal erstellen
 (macht MKDIR von Pascal NICHT}
PROCEDURE MakeDir(Dir:STRING);
VAR S: STRING;
BEGIN
  S := COPY(Dir,1,3);
  Dir := COPY(Dir,4,255);
  REPEAT
    S := S + COPY(Dir,1,POS(PATH_SEP,Dir));
    Dir := COPY(Dir,POS(PATH_SEP,Dir)+1,255);
    {$I-}
    MKDIR(COPY(S,1,LENGTH(S)-1));
    {$I+}
    IF IOResult=0 THEN BEGIN END;
  UNTIL Dir = '';
END;


{ Berechnung der Unix-Zeit (Sekunden ab 1.1.1970). Joachim Schurig, DL8HBS }
{ time_t ist longint                                                       }
TYPE time_t = LONGINT;


const
    ix_ytable   :   array[70..137] of time_t=
                   ( 0,  31536000,  63072000,  94694400, 126230400, 157766400,
             189302400, 220924800, 252460800, 283996800, 315532800, 347155200,
             378691200, 410227200, 441763200, 473385600, 504921600, 536457600,
             567993600, 599616000, 631152000, 662688000, 694224000, 725846400,
             757382400, 788918400, 820454400, 852076800, 883612800, 915148800,
             946684800, 978220800,1009756800,1041292800,1072828800,1104451200,
            1135987200,1167523200,1199059200,1230681600,1262217600,1293753600,
            1325289600,1356912000,1388448000,1419984000,1451520000,1483142400,
            1514678400,1546214400,1577750400,1609372800,1640908800,1672444800,
            1703980800,1735603200,1767139200,1798675200,1830211200,1861833600,
            1893369600,1924905600,1956441600,1988064000,2019600000,2051136000,
            2082672000,2114294400   );

    ix_mtable   :   array[1..12] of time_t=
                            (   0, 2678400, 5097600, 7776000, 10368000,
                                13046400, 15638400, 18316800, 20995200,
                                23587200, 26265600, 28857600   );           




{Kontrolliert LT - wenn LT zu hoch angegeben wurde, wird sie "gestutzt"}
PROCEDURE CheckLT(VAR LT: WORD; Rubrik: str8);
VAR f: Text;
    Time: WORD;
    S: STRING;
    aword,code: WORD;
BEGIN
  Rubrik := Gross(Rubrik);

  ASSIGN(f,BoxPath+'lifetime');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    IF LT > 30 THEN LT := 30;
    Exit;
  END;

  Time := 30;
  WHILE NOT EOF(F) DO BEGIN
    READLN(f,S);
    IF S[1] = '*' THEN BEGIN
      VAL(LTRIM(RTRIM(COPY(S,2,255))),aword,code);
      IF code <> 0 THEN Time := aword;
    END
    ELSE BEGIN
      IF Rubrik=Gross(COPY(S,1,POS(' ',S)-1)) THEN BEGIN
        VAL(LTRIM(RTRIM(COPY(S,POS(' ',S)+1,255))),aword,code);
        IF code <> 0 THEN Time := aword;
      END;
    END;
  END;
  IF LT > Time THEN LT := Time;

  CLOSE(f);
END;


PROCEDURE StandardLT(VAR LT: WORD; Rubrik: str8);
VAR f: Text;
    S: STRING;
    code,Time,aword: WORD;
BEGIN
  ASSIGN(f,BoxPath+'lifetime');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    LT := 30;
    Exit;
  END;

  Time := 30;
  WHILE NOT EOF(F) DO BEGIN
    READLN(f,S);
    IF S[1] = '*' THEN BEGIN
      VAL(LTRIM(RTRIM(COPY(S,2,255))),aword,code);
      IF code = 0 THEN Time := aword;
    END
    ELSE BEGIN
      IF Rubrik=Gross(COPY(S,1,POS(' ',S)-1)) THEN BEGIN
        VAL(LTRIM(RTRIM(COPY(S,POS(' ',S)+1,255))),aword,code);
        IF code = 0 THEN Time := aword;
      END;
    END;
  END;
  LT := Time;
  CLOSE(f);
END;



{Kontrolliert LT - wenn LT zu hoch angegeben wurde, wird sie "gestutzt"}
PROCEDURE CheckDBLT(VAR LT: INTEGER; Rubrik: str8);
VAR f: Text;
    Time: WORD;
    S: STRING;
    aword,code: WORD;
BEGIN
  Rubrik := Gross(Rubrik);

  ASSIGN(f,BoxPath+'lifetime');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    IF LT > 30 THEN LT := 30;
    Exit;
  END;

  Time := 30;
  WHILE NOT EOF(F) DO BEGIN
    READLN(f,S);
    IF S[1] = '*' THEN BEGIN
      VAL(LTRIM(RTRIM(COPY(S,2,255))),aword,code);
      IF code <> 0 THEN Time := aword;
    END
    ELSE BEGIN
      IF Rubrik=Gross(COPY(S,1,POS(' ',S)-1)) THEN BEGIN
        VAL(LTRIM(RTRIM(COPY(S,POS(' ',S)+1,255))),aword,code);
        IF code <> 0 THEN Time := aword;
      END;
    END;
  END;
  IF LT > Time THEN LT := Time;

  CLOSE(f);
END;


PROCEDURE StandardDBLT(VAR LT: INTEGER; Rubrik: str8);
VAR f: Text;
    S: STRING;
    code,Time,aword: WORD;
BEGIN
  ASSIGN(f,BoxPath+'lifetime');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    LT := 30;
    Exit;
  END;

  Time := 30;
  WHILE NOT EOF(F) DO BEGIN
    READLN(f,S);
    IF S[1] = '*' THEN BEGIN
      VAL(LTRIM(RTRIM(COPY(S,2,255))),aword,code);
      IF code <> 0 THEN Time := aword;
    END
    ELSE BEGIN
      IF Rubrik=Gross(COPY(S,1,POS(' ',S)-1)) THEN BEGIN
        VAL(LTRIM(RTRIM(COPY(S,POS(' ',S)+1,255))),aword,code);
        IF code <> 0 THEN Time := aword;
      END;
    END;
  END;
  LT := Time;
  CLOSE(f);
END;




FUNCTION Verwalt2ListLine(Info: Verwalt_Rec; Nr: WORD): STRING;
VAR S,Hlp: STRING;
    i: WORD;
    DT: DateTime;
BEGIN
  STR(Nr,S);
  FOR i := 0 TO 5 DO IF LENGTH(Info.Absender) = i THEN Info.Absender := Info.Absender + ' ';
  FOR i := 0 TO 3 DO IF LENGTH(S) = i THEN S := ' ' + S;
  S := S + ' ' + Info.Absender + ' ';
  UnpackTime(Info.RX_Datum,DT);
  STR(DT.Day,Hlp);
  IF DT.Day < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp + '.';
  STR(DT.Month,Hlp);
  IF DT.Month < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp + '.';
  STR(DT.Year,Hlp);
  S := S + COPY(Hlp,3,2) + ' ';
  STR(DT.Hour,Hlp);
  IF DT.Hour < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp + ':';
  STR(DT.Min,Hlp);
  IF DT.Min < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp + ' ';
  STR(Info.Groesse,Hlp);
  FOR i := 0 TO 5 DO IF LENGTH(Hlp) = i THEN Hlp := ' ' + Hlp;
  S := S + Hlp + '  ' + COPY(Info.Titel,1,40);
  Verwalt2ListLine := S;
END;


PROCEDURE SortDirInfo;
VAR i,k: WORD;
    help: R_DirInfo;
BEGIN
  IF AnzRub=0 THEN Exit;
  FOR i := 1 TO AnzRub-1 DO BEGIN
    FOR k := i+1 TO AnzRub DO BEGIN
      IF DirInfo[i]^.Rubrik > DirInfo[k]^.Rubrik THEN BEGIN
        help := DirInfo[i]^;
        DirInfo[i]^ := DirInfo[k]^;
        DirInfo[k]^ := help;
      END;
    END;
  END;
END;




FUNCTION BuildHeader(ch: BYTE; Idx: Verwalt_Rec): STRING;
VAR S,Hlp: STRING;
    i: WORD;
    DT: DateTime;
BEGIN
  S := Idx.Rubrik + ' @' + Idx.MBX;
  FOR i := 0 TO 17 DO IF LENGTH(S) = i THEN S := S + ' ';
  S := S + 'de:';
  FOR i := 0 TO 6 DO IF LENGTH(Idx.Absender) = i THEN Idx.Absender := Idx.Absender + ' ';
  S := S + Idx.Absender + ' ';
  UnpackTime(Idx.Rx_Datum,DT);

  STR(DT.Day,Hlp);
  IF DT.Day < 10 THEN Hlp := '0' + Hlp;
  S := S + HLp + '.';
  STR(DT.Month,Hlp);
  IF DT.Month < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp + '.';
  STR(DT.Year,Hlp);
  S := S + COPY(Hlp,3,2) + ' ';
  STR(DT.Hour,Hlp);
  IF DT.Hour < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp + ':';
  STR(DT.Min,Hlp);
  IF DT.Min < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp + ' ';
  STR(Idx.LifeTime,Hlp);
  FOR i := 0 TO 2 DO IF LENGTH(Hlp) = i THEN Hlp := ' ' + Hlp;
  S := S + Hlp;
  STR(Idx.Groesse,Hlp);
  FOR i := 0 TO 6 DO IF LENGTH(Hlp) = i THEN Hlp := ' ' + Hlp;
  S := S + Hlp + ' Bytes';
  BuildHeader := S;
END;

{Trgt eine BID in die BID-Liste ein}
PROCEDURE AddBIDFile(BID: str12;rubrik:str8;pi:word;pc:longint);
VAR data:TBidHashRec;
BEGIN
  data.rubrik:=rubrik;
  data.idx_file_pos:=pi;
  data.check_file_pos:=pc;
  BidHash^.InsertData(bid,data);
END;

FUNCTION FastSFPartner(Call: str6): str6;
VAR SFFile: FILE OF Stn_Rec;
    SFDS: Stn_Rec;
    i,k: BYTE;
    hlp: Stn_Best_Rec;
BEGIN
  Call := Gross(Call);

   ASSIGN(SFFile,BOXPATH+'info.stn');
  {$I-}
  RESET(SFFile);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    FastSFPartner := '';
    Exit;
  END;

  FastSFPartner := '';
  WHILE NOT EOF(SFFile) AND (SFDS.Call <> Call) DO BEGIN
    READ(SFFile,SFDS);
    IF SFDS.Call = Call THEN BEGIN

      FOR i := 1 TO 2 DO BEGIN
        FOR k := i+1 TO 3 DO BEGIN
          IF SFDS.Best[i].Time > SFDS.Best[k].Time THEN BEGIN
            hlp := SFDS.Best[i];
            SFDS.Best[i] := SFDS.Best[k];
            SFDS.Best[k] := hlp;
          END;
        END;
      END;

      FastSFPartner := SFDS.Best[1].From;
    END;
  END;
  CLOSE(SFFile);
END;




{TRUE, wenn das bergebene Call in BOX.SF steht}
FUNCTION SF_User(Call: str6): BOOLEAN;
VAR Found: BOOLEAN;
    tmp: pBoxSF;
BEGIN
  Found := FALSE;
  tmp := BoxSFRoot;
  WHILE (tmp<>NIL) AND NOT Found DO BEGIN
    IF tmp^.Call=Call THEN Found := TRUE
                      ELSE tmp := tmp^.next;
  END;
  SF_User := Found;
END;


FUNCTION SFHeaderText(RX_Date: LONGINT; SendInfo: BOOLEAN; BID: str12; PW: BOOLEAN): STRING;
VAR S: STRING;
    Hlp: STRING[5];
    DT: DateTime;
    aword: WORD;
BEGIN

  UnpackTime(RX_Date,DT);

  STR(DT.Year,Hlp);
  S := 'R:' + COPY(Hlp,3,2);

  STR(DT.Month,Hlp);
  IF DT.Month < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp;
  STR(DT.Day,Hlp);
  IF DT.Day < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp + '/';

  STR(DT.Hour,Hlp);
  IF DT.Hour < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp;
  STR(DT.Min,Hlp);
  IF DT.Min < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp + 'z @:';

  S := S + CutSSID(BoxCall) + OwnBoxData^.Hierach;
  S := S + ' [' + OwnBoxData^.SFInfo+'] mct'+Version+' $:'+BID;
(* IF SendInfo THEN
    S:=S+' $'+BID; *)
  SFHeaderText := S;
END;



FUNCTION Hierachie(Call: str6): STRING;
VAR RouterFile: FILE OF Stn_Rec;
    Router: Stn_Rec;
    Found: BOOLEAN;
BEGIN
  Hierachie := '';
  IF Call = CutSSID(BoxCall) THEN BEGIN
    Hierachie := OwnBoxData^.Hierach;
    Exit;
  END;

   ASSIGN(RouterFile,BoxPath+'info.stn');
  {$I-}
  RESET(RouterFile);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    Hierachie := '';
    Exit;
  END;

  Found := FALSE;
  WHILE NOT EOF(RouterFile) AND NOT Found DO BEGIN
    READ(RouterFile,Router);
    IF Router.Call = Call THEN BEGIN
      Hierachie := Router.HPATH;
      Found := TRUE;
    END;
  END;
  CLOSE(RouterFile);
  IF NOT Found THEN Hierachie := '';

END;

(*
FUNCTION Unix2Pack(Unix: LONGINT): LONGINT;
VAR DT: DateTime;
    Day,Month,Year,Hour,Min,Sec: BYTE;
    lint: LONGINT;
BEGIN
  decode_ixtime(Unix,day,month,year,hour,min,sec);
  DT.Day := Day;
  DT.Month := Month;
  DT.Year := Year+1900;
  DT.Hour := Hour;
  DT.Min := min;
  DT.Sec := sec;
  PackTime(DT,lint);
  Unix2Pack := lint;
END;



FUNCTION Pack2Unix(Pack: LONGINT): LONGINT;
VAR DT: DateTime;
    Day,Month,Year,Hour,Min,Sec: BYTE;
BEGIN
  UnpackTime(Pack,DT);
  Day := DT.Day;
  Month := DT.Month;
  Year := DT.Year-1900;
  Hour := DT.Hour;
  Min := DT.Min;
  Sec := DT.Sec;

  Pack2Unix := calc_ixtime(day,month,year,hour,min,sec);
END;
  *)

{Routine-Info-Record sortieren (Die schnellsten 3 Wege)}
PROCEDURE SortBest(VAR RoutingInfos: Stn_Rec);
VAR i,k: WORD;
    help: Stn_Best_Rec;
BEGIN
  FOR i := 1 TO 2 DO BEGIN
    FOR k := i+1 TO 3 DO BEGIN
      IF RoutingInfos.Best[i].Time > RoutingInfos.Best[k].Time THEN BEGIN
        help := RoutingInfos.Best[i];
        RoutingInfos.Best[i] := RoutingInfos.Best[k];
        RoutingInfos.Best[k] := help;
      END;
    END;
  END;
END;


{Testet eine R: - Zeile und schreibt die Infos da draus in INFO.STN
 (Das File fr den Autorouter)}
PROCEDURE CheckForAutorouter(ch: BYTE; S: STRING;VAR Auswert: BOOLEAN; VAR SFPartner,RXFrom: str6;VAR deleteIt:BOOLEAN);
VAR RX: DateTime;
    code: WORD;
    Hierach,Info: STRING;
    Call: STRING[6];
    AktDel,SavedTime,NowTime,ReadTime: LONGINT;
    RouteFile: FILE OF Stn_Rec;
    Route: Stn_Rec;
    Found,dummy: BOOLEAN;
    i,n: BYTE;
BEGIN
  DeleteIt:=FALSE;
  IF Auswert THEN BEGIN
    IF (COPY(S,1,2)='R:') AND (S[9]='/') THEN BEGIN
      Hierach := '';
      Info := '';

      {Aktuelles Datum und Zeit nach NowTime}
      NowTime := CurrIxTime;
      UnPackTime(Unix2Pack(NowTime),DT);


      {Datum & Zeit nach schreiben}
      VAL('19'+COPY(S,3,2),DT.Year,code);
      VAL(COPY(S,5,2),DT.Month,code);
      VAL(COPY(S,7,2),DT.Day,code);
      VAL(COPY(S,10,2),DT.Hour,code);
      VAL(COPY(S,12,2),DT.Min,code);
      DT.Sec := 0;
      ReadTime := calc_ixtime(DT.Day,DT.Month,DT.Year-1900,DT.Hour,DT.Min,DT.Sec);


      S := COPY(S,POS(' ',S)+1,255);
      IF POS('@',S) > 0 THEN S := COPY(S,POS('@',S)+1,255);
      IF COPY(S,1,1)=':' THEN S := COPY(S,2,255);


      {Gucken, ob von Call eine Hierachie angegeben ist}
      IF (POS('.',S) > 0) AND ((POS('.',S)<POS(' ',S)) OR (POS(' ',S)=0)) THEN BEGIN
        Call := COPY(S,1,POS('.',S)-1);
        Hierach := COPY(S,POS('.',S),255);
        IF POS(' ',Hierach) > 0 THEN Hierach := COPY(Hierach,1,POS(' ',Hierach)-1);
      END
      ELSE BEGIN
        IF POS(' ',S) > 0 THEN BEGIN
          Call := COPY(S,1,POS(' ',S)-1);
          Hierach := '';
          S := COPY(S,POS(' ',S)+1,255);
        END
        ELSE BEGIN
          Call := S;
          Hierach := '';
          S := '';
        END;
      END;

      IF POS(' ',S)>0 THEN Info := COPY(S,POS(' ',S)+1,255);
      (* soooooooo, ich habe was gegen CB-Boxen in den R-Lines -> loeschen *)
      IF (NOT Rufz(call)) OR (NOT CheckCall(call)) THEN
      BEGIN
        DeleteIt:=TRUE;
        EXIT;
      END;
      {So, jetzt ist der vorgegebene String fertig zerlegt. Die Variable
       S kann fr andere Dinge benutzt werden}

      IF SFPartner = '' THEN SFPartner := CutSSID(KS[ch]^.Call);
      {Das eigene Call nicht in den Autorouter aufnehmen, iad jan 98}
      IF cutssid(call)=cutssid(boxcall) THEN exit;
      {Daten-File des Autorouters ffnen und nach dem Call der aktuellen
       R-Zeile suchen}
      ASSIGN(RouteFile,BoxPath+'info.stn');
      {$I-}
      RESET(RouteFile);
      {$I+}
      IF IOResult = 0 THEN BEGIN
        Found := FALSE;
        WHILE NOT EOF(RouteFile) AND NOT Found DO BEGIN
          READ(RouteFile,Route);
          IF Route.Call = Call THEN BEGIN
            Found := TRUE;
            IF Pack2Unix(Route.LastTX) < ReadTime THEN BEGIN
              Route.LastTX := Unix2Pack(ReadTime);
              Route.HPath := Hierach;
              IF Info <> '' THEN Route.Desc := Info;
            END;
            Route.MSGCt := Route.MSGCt + 1;
            SortBest(Route);

            AktDel := NowTime - ReadTime;
            IF AktDel<0 THEN AktDel := 7200;


            {*************************************************************}
            {***         Zeiten im Autorouter aktualisieren            ***}
            {*************************************************************}


            {Gucken, ob das Boxcall, das grade bearbeitet wird, schon im
             Zeiten-Array steht.}
            dummy := FALSE;
            FOR i := 1 TO 3 DO IF Route.Best[i].From=SFPartner THEN dummy := TRUE;

            IF dummy THEN BEGIN
              {Rufzeichen gibt's schon im Array}

              {An welcher Stelle im Array?}
              n := 0;
              FOR i := 1 TO 3 DO IF Route.Best[i].From=SFPartner THEN n := i;

              {Test, ob die neue Zeit des Rufzeichens krzer war als die
               eingetragene}
              IF AktDel < Route.Best[n].Time THEN BEGIN
                {Ja, war krzer - neue Zeit eintragen}
                Route.Best[n].Time := AktDel;
              END;

            END
            ELSE BEGIN
              {Rufzeichen ist noch nicht im Array enthalten}
              IF AktDel < Route.Best[3].Time THEN BEGIN
                Route.Best[3].Time := AktDel;
                Route.Best[3].From := SFPartner;
              END;

            END;

            {Test, ob eine neuste schnellste Zeit eingetragen wurde.
             Wenn nicht -> schnellste Zeit altern lassen}
            IF AktDel > Route.Best[1].Time THEN
                 inc(Route.Best[1].Time,AutorouterAlternUm);

            {Array neu sortieren}
            SortBest(Route);


            (*
            IF AktDel < Route.Best[1].Time THEN BEGIN
              {NEUE BESTZEIT}
              IF (Route.Best[1].From = SFPartner) THEN BEGIN
                Route.Best[1].Time := AktDel;
              END
              ELSE BEGIN
                IF Route.Best[2].From = SFPartner THEN BEGIN
                  Route.Best[2].Time := AktDel;
                END
                ELSE BEGIN
                  IF Route.Best[3].From = SFPartner THEN BEGIN
                    Route.Best[3].Time := AktDel;
                  END
                  ELSE BEGIN
                    Route.Best[3] := Route.Best[2];
                    Route.Best[2] := Route.Best[1];
                    Route.Best[1].From := SFPartner;
                    Route.Best[1].Time := AktDel;
                  END;
                END;
              END;
              SortBest(Route);
            END
            ELSE BEGIN
              IF AktDel < Route.Best[2].Time THEN BEGIN
                {Immerhin noch 2. platz}
                IF (Route.Best[1].From = SFPartner) THEN BEGIN
                  {Nix machen, weil die schnellste Zeit schon mit dem eigenen
                   Call besetzt ist}
                END
                ELSE BEGIN
                  IF Route.Best[2].From = SFPartner THEN BEGIN
                    {Die zweitschnellste Zeit ist die eigene - Speichern}
                    Route.Best[2].Time := AktDel;
                  END
                  ELSE BEGIN
                    IF Route.Best[3].From = SFPartner THEN BEGIN
                      Route.Best[3].Time := AktDel;
                    END
                    ELSE BEGIN
                      Route.Best[3] := Route.Best[2];
                      Route.Best[2].From := SFPartner;
                      Route.Best[2].Time := AktDel;
                    END;
                  END;
                END;
                SortBest(Route);

              END
              ELSE BEGIN
                IF AktDel < Route.Best[3].Time THEN BEGIN
                  {Naja, noch 3. Platz}
                  IF (Route.Best[1].From = SFPartner) THEN BEGIN
                    {Nix machen - die schnellste Zeit ist schon die eigene,
                     wiso sollte die 3. schnellste Zeit auch gespeichert
                     werden?}
                  END
                  ELSE BEGIN
                    IF Route.Best[2].From = SFPartner THEN BEGIN
                      {Nicht speichern, die zweitschnellste Zeit ist
                       schon die eigene, sonst einen kommentar 'rauf}
                    END
                    ELSE BEGIN
                      IF Route.Best[3].From = SFPartner THEN BEGIN
                        {die drittschnellste Zeit ist die eigene -> speichern}
                        Route.Best[3].Time := AktDel;
                      END
                      ELSE BEGIN
                        {Die drittschnellste Zeit einfach berschreiben}
                        Route.Best[3].From := SFPartner;
                        Route.Best[3].Time := AktDel;
                      END;
                    END;
                  END;
                  SortBest(Route);
                END
                ELSE BEGIN
                  {Trostpreis  :-)   Schnellste Zeit altern lassen und
                   nochmal sortieren}

                   {10 min altern lassen}
                   Route.Best[1].Time := Route.Best[1].Time + 600;
                   SortBest(Route);
                END;
              END;
            END;

            *)

            Route.RXFrom := RXFrom;
            RXFrom := Call;

            SEEK(RouteFile,FILEPOS(RouteFile)-1);
            WRITE(RouteFile,Route);

          END
        END;
        IF NOT Found THEN BEGIN
          Route.Call := Call;
          Route.HPATH := Hierach;
          Route.RXFrom := RXFrom;
          RXFrom := Call;
          Route.Desc := Info;
          PackTime(DT,Route.LastTX);
          Route.Best[1].From := SFPartner;
          Route.Best[1].Time := NowTime - ReadTime;
          Route.Best[2].From := '';
          Route.Best[2].Time := 999999999;
          Route.Best[3].From := '';
          Route.Best[3].Time := 999999999;
          Route.MSGCt := 1;

          SEEK(RouteFile,FILESIZE(RouteFile));
          WRITE(RouteFile,Route);
        END;
        CLOSE(RouteFile);
      END
      ELSE BEGIN
        Route.Call := Call;
        Route.HPATH := Hierach;
        Route.RXFrom := RXFrom;
        RXFrom := Call;
        Route.Desc := Info;
        PackTime(DT,Route.LastTX);
        Route.Best[1].From := SFPartner;
        Route.Best[1].Time := NowTime - ReadTime;
        Route.Best[2].From := '';
        Route.Best[2].Time := 999999999;
        Route.Best[3].From := '';
        Route.Best[3].Time := 999999999;
        Route.MSGCt := 1;

        REWRITE(RouteFile);
        WRITE(RouteFile,Route);
        CLOSE(RouteFile);
      END;

    END
    ELSE Auswert := FALSE;
  END;
END;
 


FUNCTION Pack2STRDate(Pack: LONGINT): STRING;
VAR DT: DateTime;
    S: STRING[8];
    Hlp: STRING[4];
BEGIN
  UnpackTime(Pack,DT);
  STR(DT.Day,S);
  IF DT.Day < 10 THEN S := '0' + S;
  STR(DT.Month,Hlp);
  IF DT.Month < 10 THEN Hlp := '0' + Hlp;
  S := S + '.' + Hlp + '.';
  STR(DT.Year,Hlp);
  S := S + COPY(Hlp,3,2);
  Pack2STRDate := S;
END;


FUNCTION Pack2STRTime(Pack: LONGINT): STRING;
VAR DT: DateTime;
    S: STRING[8];
    Hlp: STRING[4];
BEGIN
  UnpackTime(Pack,DT);
  STR(DT.Hour,S);
  IF DT.Hour < 10 THEN S := '0' + S;
  STR(DT.Min,Hlp);
  IF DT.Min < 10 THEN Hlp := '0' + Hlp;
  S := S + ':' + Hlp + ':';
  STR(DT.Sec,Hlp);
  IF DT.Sec < 10 THEN Hlp := '0' + Hlp;
  S := S + Hlp;
  Pack2STRTime := S;
END;




FUNCTION TimeLong(sec: LONGINT): STRING;
VAR S,Hlp: STRING;
    rest,min,hour,days: LONGINT;
BEGIN
  rest := sec;

  sec := rest MOD 60;
  rest := rest DIV 60;
  min := rest MOD 60;
  rest := rest DIV 60;
  hour := rest MOD 60;
  rest := rest DIV 60;
  days := rest;

  STR(days,S);
  STR(hour,Hlp);
  S := S + 'd ' + Hlp + 'h ';
  STR(min,Hlp);
  S := S + Hlp + 'm ';
  STR(sec,Hlp);
  S := S + Hlp + 's';
  TimeLong := S;
END;


FUNCTION IsInBadCalls(Call: str6): BOOLEAN;
VAR f: Text;
    Found: BOOLEAN;
    S: STRING;
BEGIN
  ASSIGN(f,BoxPath+'badcalls');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult <> 0 THEN BEGIN
    IsInBadCalls := FALSE;
    Exit;
  END;

  Found := FALSE;
  WHILE NOT EOF(f) DO BEGIN
    READLN(f,S);
    S := Gross(S);
    IF S = Call THEN Found := TRUE;
  END;
  CLOSE(f);
  IsInBadCalls := Found;
END;


{CheckSumme fr F6FBB}
FUNCTION CheckSum(S: STRING; Sum: BYTE): BYTE;
VAR i: BYTE;
BEGIN
  FOR i := 1 TO LENGTH(S) DO BEGIN
    Sum := (Sum + Ord(S[i])) MOD 256;
  END;
  CheckSum := Sum;
END;


{Die Mail, die im Record VERWALT steht, wird ans Check-File gehngt
 Nr ist die Nummer, in der die Mail im Status-File steht}
PROCEDURE AddCheckFile(Verwalt: Verwalt_Rec; Nr: WORD; Hold, SysOp_only: BOOLEAN;var pos_in_check:LONGINT);
VAR CheckFile: FILE OF CheckRec;
    Check: CheckRec;
BEGIN
  pos_in_check:=0;
  IF NOT Rufz(Verwalt.Rubrik) AND ((LENGTH(Verwalt.Rubrik)>1) OR SysOp_only) THEN BEGIN
     ASSIGN(CheckFile,BOXPATH+'check.box');
    {$I-}
    RESET(CheckFile);
    {$I+}
    IF IOResult = 0 THEN SEEK(CheckFile,FILESIZE(CheckFile))
                    ELSE REWRITE(CheckFile);
    Check.Von := Verwalt.Absender;
    Check.An := Verwalt.Rubrik;
    Check.Nr := Nr;
    Check.RX_Zeit := Verwalt.RX_Datum;
    Check.MBX := Verwalt.MBX;
    Check.Bytes := Verwalt.Groesse;
    Check.LT := Verwalt.Lifetime;
    Check.Titel := Verwalt.Titel;
    Check.Flags := 0;
    IF Verwalt.Flags AND VERWALT_DEL>0 THEN Check.Flags := Check.Flags OR CHECK_DEL; {Del-Flag := TRUE}
    IF Hold THEN Check.Flags := Check.Flags OR CHECK_HOLD;
    IF SysOp_Only THEN Check.Flags := Check.Flags OR CHECK_SYSOP;
    Check.BID := Verwalt.BID;
    pos_in_check:=FilePos(CheckFile)+1;
    WRITE(CheckFile,Check);
    CLOSE(CheckFile);
  END;
END;



PROCEDURE DelCheckFile(BID: str12);
VAR CheckFile: FILE OF CheckRec;
    Check: CheckRec;
    bidinfo:TBidHashRec;
BEGIN
   ASSIGN(CheckFile,BOXPATH+'check.box');
  {$I-}
  RESET(CheckFile);
  {$I+}
  IF IOResult = 0 THEN BEGIN
    IF (BidHash^.GetData(bid,@bidinfo)) AND (bidinfo.check_file_pos>0) THEN
    BEGIN
      SEEK(CheckFile,bidinfo.check_file_pos-1);
      {Del-Flag auf TRUE setzen (Siehe BOXVARS.PAS)}
      Check.Flags := Check.Flags OR CHECK_DEL;
      WRITE(CheckFile,Check);
    END;
    CLOSE(CheckFile);
  END;
END;


{Aktuelle Zeit als Packed-Time}
FUNCTION AktLongTime: LONGINT;
BEGIN
  Aktlongtime:=Unix2Pack(CurrIxTime);
END;



{MYBBS-Forwarding in die S&F-Datei eintragen}
PROCEDURE SendM_Mail(Call, BBS: str6);
VAR Info: Verwalt_Rec;
    S: STRING;
    jetzt: LONGINT;
    DT: DateTime;
    aword: WORD;
BEGIN

  IF LENGTH(OwnBoxData^.M_E_MBX)>0 THEN BEGIN


    
    {Aktuelle Zeit nach DT}
    Jetzt:=CurrIxTime;
    UnPackTime(Unix2Pack(Jetzt),DT);
    {Eingelesene Zeit in eine Unix-Zeit wandeln und als String nach S}
    STR(Jetzt,S);


    Info.Titel := BBS+' '+S;
    Info.Absender := Call;
    Info.Rubrik := 'M';
    Info.MBX := OwnBoxData^.M_E_MBX;
    Info.FileName := '';
    PackTime(DT,Info.Rx_Datum);
    Info.BID := Neu_BID;
    Info.Groesse := 0;
    Info.Lifetime := OwnBoxData^.M_E_LT;
    {Flags auf FALSE setzen. Siehe BOXVARS.PAS}
    Info.Flags := 0;

    AddSFListe(CutSSID(BoxCall),Info,'M',TRUE,'',FALSE,FALSE);
    AddBIDFile(Info.BID,'M',0,0);
  END;
END;


{TRUE, wenn das angegebene Call in TCPIP.BOX vorkommt.}
FUNCTION TCPIP_BOX(Call: str6; VAR Strg: STRING): BOOLEAN;
VAR f: Text;
    St: STRING;
    OK: BOOLEAN;
BEGIN
  Strg := '';
   ASSIGN(f,BoxPath+'tcpip.box');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    TCPIP_BOX := FALSE;
    Exit;
  END;

  OK := FALSE;
  TCPIP_BOX := FALSE;
  WHILE NOT EOF(f) AND NOT OK DO BEGIN
    READLN(f,St);
    IF St[1] <> '#' THEN BEGIN
      IF POS(' ',St) > 0 THEN BEGIN
        IF Gross(LTRIM(RTRIM(COPY(St,1,POS(' ',St)-1))))=Gross(Call) THEN OK := TRUE
      END
      ELSE BEGIN
        IF Gross(St)=Gross(Call) THEN OK := TRUE;
      END;

      IF OK THEN BEGIN
        IF POS(' ',St) > 0 THEN Strg := COPY(St,1,POS(' ',St)+1);
        TCPIP_BOX := TRUE;
      END;
    END;
  END;
  CLOSE(f);
END;


PROCEDURE BenachrichtigeUser(Call: str6;ch: BYTE);
VAR i: WORD;
BEGIN
  FOR i := 0 TO 255 DO BEGIN
    IF (KS[i] <> NIL) AND (i<>ch) THEN BEGIN
      IF (KS[i]^.status=50) AND (Call=CutSSID(KS[i]^.Call))
         AND (KS[i]^.BoxData^.Status=0) THEN BEGIN
        PutData(i,#13+SysText(i,80));
        {62 = Achtung, Soeben traf eine Nachricht fr Sie ein:}
        List(i,'L '+CutSSID(Call)+#13,FALSE);
        PutData(i,BoxPrompt(i));
      END;
    END;
  END;
END;


PROCEDURE ProtoEingabe(c: BYTE; S: STRING);
BEGIN
  WRITELN(KS[c]^.BoxData^.ProtoFile,S);
END;


PROCEDURE AktSetAusgeb(ch: BYTE; SetInfo: BYTE);
VAR S,An,Aus: STRING[10];
BEGIN

  {Texte fr AN und AUS in der jeweiligen Landessprache}
  An := SysText(ch,1);
  Aus := SysText(ch,2);

  PutData(ch,#13#13+SysText(ch,81)+#13);
  {81 = Aktuelle Parameter-Einstellungen}

  IF SetInfo AND SET_Bytes>0 THEN S := An
                             ELSE S := Aus;
  PutData(ch,SysText(ch,82)+' ('+S+')'+#13);
  {82 = (B)ytes ausgeben .....................}

  IF SetInfo AND SET_Datum>0 THEN S := An
                             ELSE S := Aus;
  PutData(ch,SysText(ch,83)+' ('+S+')'+#13);
  {83 = (D)atum ausgeben .....................}

  IF SetInfo AND SET_R_Vollst>0 THEN S := An
                                ELSE S := Aus;
  PutData(ch,SysText(ch,84)+' ('+S+')'+#13);
  {84 = (H)eader (R: - Zeilen) vollstndig ...}

  IF SetInfo AND SET_Lifetime>0 THEN S := An
                                ELSE S := Aus;
  PutData(ch,SysText(ch,85)+' ('+S+')'+#13);
  {85 = (L)ifetimes ausgeben .................}

  IF SetInfo AND SET_R_Kurz>0 THEN S := An
                              ELSE S := Aus;
  PutData(ch,SysText(ch,86)+' ('+S+')'+#13);
  {86 = Header (p)acken (Kurzform) ...........}

  IF SetInfo AND SET_Read>0 THEN S := An
                            ELSE S := Aus;
  PutData(ch,SysText(ch,87)+' ('+S+')'+#13);
  {87 = (R)ead-Zeile ausgeben ................}

  IF SetInfo AND SET_Sender>0 THEN S := An
                              ELSE S := Aus;
  PutData(ch,SysText(ch,88)+' ('+S+')'+#13);
  {88 = (S)ender-Zeile ausgeben ..............}

  IF SetInfo AND SET_Uhrzeit>0 THEN S := An
                               ELSE S := Aus;
  PutData(ch,SysText(ch,89)+' ('+S+')'+#13);
  {89 = Uhrzei(T) ausgeben ...................}

  STR(GetReadLockInfo(CutSSID(KS[ch]^.Call)),S);
  PutData(ch,#13+'Readlock:  '+S+#13);
  PutData(ch,'  0 = '+SysText(ch,91)+#13);     {91 = Alle Mails}
  PutData(ch,'  1 = '+SysText(ch,92)+#13);     {92 = Nur gelesene Mails}
  PutData(ch,'  2 = '+SysText(ch,93)+#13);     {93 = Keine Mails}
  PutData(ch,#13);

END;


PROCEDURE SetOptionsDialog(ch: BYTE; S: STRING);
CONST Prompt = '(B,D,H,L,P,R,S,T,0,1,2,Q=Quit) =>';
VAR SetParams: BYTE;
BEGIN
  GetSetInfos(CutSSID(KS[ch]^.Call),SetParams);

  IF LENGTH(S)=0 THEN S[1] := ' ';
  S := LTRIM(RTRIM(S));
  S[1] := UpCase(S[1]);
  CASE S[1] OF
    'B': BEGIN
           IF SetParams AND SET_Bytes>0 THEN SetParams := SetParams AND $FF-SET_Bytes
                                        ELSE SetParams := SetParams OR SET_Bytes;
           AktSetAusgeb(ch,SetParams);
           PutData(ch,Prompt);
           PutSetInfos(CutSSID(KS[ch]^.Call),SetParams);
         END;
    'D': BEGIN
           IF SetParams AND SET_Datum>0 THEN SetParams := SetParams AND $FF-SET_Datum
                                        ELSE SetParams := SetParams OR SET_Datum;
           AktSetAusgeb(ch,SetParams);
           PutData(ch,Prompt);
           PutSetInfos(CutSSID(KS[ch]^.Call),SetParams);
         END;
    'H': BEGIN
           IF SetParams AND SET_R_Vollst>0 THEN SetParams := SetParams AND $FF-SET_R_Vollst
                                           ELSE SetParams := SetParams OR SET_R_Vollst;
           IF (SetParams AND SET_R_Kurz>0) AND (SetParams AND SET_R_Vollst>0) THEN SetParams := SetParams AND $FF-SET_R_Kurz;
           AktSetAusgeb(ch,SetParams);
           PutData(ch,Prompt);
           PutSetInfos(CutSSID(KS[ch]^.Call),SetParams);
         END;
    'L': BEGIN
           IF SetParams AND SET_Lifetime>0 THEN SetParams := SetParams AND $FF-SET_Lifetime
                                           ELSE SetParams := SetParams OR SET_Lifetime;
           AktSetAusgeb(ch,SetParams);
           PutData(ch,Prompt);
           PutSetInfos(CutSSID(KS[ch]^.Call),SetParams);
         END;
    'P': BEGIN
           IF SetParams AND SET_R_Kurz>0 THEN SetParams := SetParams AND $FF-SET_R_Kurz
                                         ELSE SetParams := SetParams OR SET_R_Kurz;
           IF (SetParams AND SET_R_Kurz>0) AND (SetParams AND SET_R_Vollst>0) THEN SetParams := SetParams AND $FF-SET_R_Vollst;
           AktSetAusgeb(ch,SetParams);
           PutData(ch,Prompt);
           PutSetInfos(CutSSID(KS[ch]^.Call),SetParams);
         END;
    'R': BEGIN
           IF SetParams AND SET_Read>0 THEN SetParams := SetParams AND $FF-SET_Read
                                       ELSE SetParams := SetParams OR SET_Read;
           AktSetAusgeb(ch,SetParams);
           PutData(ch,Prompt);
           PutSetInfos(CutSSID(KS[ch]^.Call),SetParams);
         END;
    'S': BEGIN
           IF SetParams AND SET_Sender>0 THEN SetParams := SetParams AND $FF-SET_Sender
                                         ELSE SetParams := SetParams OR SET_Sender;
           AktSetAusgeb(ch,SetParams);
           PutData(ch,Prompt);
           PutSetInfos(CutSSID(KS[ch]^.Call),SetParams);
         END;
    'T': BEGIN
           IF SetParams AND SET_Uhrzeit>0 THEN SetParams := SetParams AND $FF-SET_Uhrzeit
                                          ELSE SetParams := SetParams OR SET_Uhrzeit;
           AktSetAusgeb(ch,SetParams);
           PutData(ch,Prompt);
           PutSetInfos(CutSSID(KS[ch]^.Call),SetParams);
         END;
    '0': BEGIN
           SetReadLock(CutSSID(KS[ch]^.Call), 0);
           AktSetAusgeb(ch,SetParams);
           PutData(ch,Prompt);
         END;
    '1': BEGIN
           SetReadLock(CutSSID(KS[ch]^.Call), 1);
           AktSetAusgeb(ch,SetParams);
           PutData(ch,Prompt);
         END;
    '2': BEGIN
           SetReadLock(CutSSID(KS[ch]^.Call), 2);
           AktSetAusgeb(ch,SetParams);
           PutData(ch,Prompt);
         END;
    'Q': BEGIN
           KS[ch]^.BoxData^.status := 0;
           PutData(ch,#13#13);
         END;
    ELSE BEGIN
      PutData(ch,SysText(ch,7)+#13);    {Falscher Parameter}
      PutData(ch,Prompt);
    END;
  END;
END;




FUNCTION SizeHeader(FileName: STRING): WORD;
VAR f: Text;
    Found: BOOLEAN;
    S: STRING;
    Size: WORD;
BEGIN
  ASSIGN(f,BoxPath+FileName);
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    SizeHeader := 0;
    Exit;
  END;

  Found := FALSE;
  Size := 0;
  WHILE NOT EOF(f) AND NOT found DO BEGIN
    READLN(f,S);
    Size := Size + LENGTH(S)+2;        {Lnge des eingelesenen Strings + CRLF}
    IF S='NNNN' THEN Found := TRUE;
  END;
  CLOSE(f);

  IF NOT Found THEN SizeHeader := 0
               ELSE SizeHeader := Size;

END;



FUNCTION FileDa(DateiName: STRING): BOOLEAN;
VAR f: File;
BEGIN
  ASSIGN(f,DateiName);
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult=0 THEN BEGIN
    CLOSE(f);
    FileDa := TRUE;
  END
  ELSE FileDa := FALSE;
END;




FUNCTION FindUniqueImportFilename: STRING;
VAR S,Hlp: STRING;
    DT: DateTime;
    aword: WORD;
    Lfd: WORD;
    i: BYTE;
BEGIN
  GetDate(DT.Year,DT.Month,DT.Day,aword);
  GetTime(DT.Hour,DT.Min,DT.Sec,aword);

  STR(DT.Month,Hlp);
  FOR i := 0 TO 1 DO IF LENGTH(Hlp)=i THEN Hlp := '0' + Hlp;
  STR(DT.Day,S);
  FOR i := 0 TO 1 DO IF LENGTH(S)=i THEN S := '0' + S;
  S := S + Hlp;

  STR(DT.Hour,Hlp);
  FOR i := 0 TO 1 DO IF LENGTH(Hlp)=i THEN Hlp := '0' + Hlp;
  S := S + Hlp;
  STR(DT.Min,Hlp);
  FOR i := 0 TO 1 DO IF LENGTH(Hlp)=i THEN Hlp := '0' + Hlp;
  S := S + Hlp;

  Lfd := 0;
  REPEAT
    STR(Lfd,Hlp);
    FOR i := 0 TO 2 DO IF LENGTH(Hlp)=i THEN Hlp := '0' + Hlp;

    Hlp := S+'.'+Hlp;
    inc(Lfd);
  UNTIL NOT FileDa(BoxPath+'import'+PATH_SEP+Hlp);
  FindUniqueImportFilename := Hlp;
END;


FUNCTION IsZahl(S: STRING): BOOLEAN;
VAR i: BYTE;
BEGIN
  IsZahl := TRUE;
  FOR i := 1 TO LENGTH(S) DO BEGIN
    IF NOT (S[i] IN ['0'..'9','-']) THEN IsZahl := FALSE;
  END;
END;


PROCEDURE DelSpaces(VAR S: STRING);
VAR i: BYTE;
BEGIN
  WHILE POS(' ',S)>0 DO DELETE(S,POS(' ',S),1);
END;



FUNCTION TransferMail(RubName: str8): str8;
VAR f: Text;
    S: STRING;
    OK: BOOLEAN;
BEGIN
  ASSIGN(f,BoxPath+'TRANSFER');
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult<>0 THEN
  BEGIN
    TRANSFERMAIL:=RubName;
    Exit;
  END;
  OK := FALSE;
  WHILE NOT EOF(f) AND NOT OK DO BEGIN
    READLN(f,S);
    S := Gross(S);
    IF COPY(S,1,POS(' ',S)-1)=RubName THEN BEGIN
      RubName := COPY(S,POS(' ',S)+1,255);
      OK := TRUE;
    END;
  END;
  CLOSE(f);

  TransferMail := RubName;
END;


{Sendet ein TExtfile 1:1 aus}
PROCEDURE SendTextFile(ch: BYTE; FileName: STRING);
VAR f: Text;
    S: STRING;
BEGIN
  ASSIGN(f,FileNAme);
  {$I-}
  RESET(f);
  {$I+}
  IF IOResult=0 THEN BEGIN
    WHILE NOT EOF(f) DO BEGIN
      READLN(f,S);
      PutData(ch,S+#13);
    END;
    CLOSE(f);
  END;
END;



PROCEDURE PutCallToReadLine(ch: BYTE; FileName: STRING; Call: STRING);
VAR f: File;
    Hlp: ARRAY[1..255] OF CHAR;
    Help,S: STRING;
BEGIN
  IF KS[ch]^.Lev < 10 THEN BEGIN
    ASSIGN(f,FileName);
    {$I-}
    RESET(f,1);
    {$I+}
    IF IOResult=0 THEN BEGIN
      BLOCKREAD(f,Hlp,255);

      S := '';
      FOR i := 1 TO 255 DO BEGIN
        S[i] := Hlp[i];
      END;
      S[0] := #255;
      S := LTRIM(RTRIM(S));

      IF LENGTH(S)>0 THEN Help := S + ' ' + Call
                     ELSE Help := Call;
      IF LENGTH(Help)<=255 THEN BEGIN
        {OK, Call passt noch 'rein}
        SEEK(f,0);
        FOR i := 1 TO LENGTH(Help) DO Hlp[i] := Help[i];
        FOR i := LENGTH(Help)+1 TO 255 DO Hlp[i] := #32;
        BLOCKWRITE(f,Hlp,255);
      END;
      CLOSE(f);
    END;
  END;
END;


PROCEDURE SendReadLine(ch: BYTE; VAR LEN: LONGINT; FileName: STRING);
VAR S,Help: STRING;
    f: FILE;
    Hlp: ARRAY[1..255] OF CHAR;
    i: BYTE;
    Result: WORD;
BEGIN

  ASSIGN(f,FileName);
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult=0 THEN BEGIN
    BLOCKREAD(f,Hlp,255,Result);
    CLOSE(f);
    S := '';
    FOR i := 1 TO 255 DO BEGIN
      S[i] := Hlp[i];
    END;
    S[0] := #255;
    S := LTRIM(RTRIM(S));
    IF LENGTH(S)=0 THEN Exit;

    WHILE LENGTH(S)>0 DO BEGIN
      Help := COPY(S,1,70);
      IF LENGTH(Help)=70 THEN WHILE S[LENGTH(Help)]<>#32 DO DELETE(Help,LENGTH(Help),1);
      IF LENGTH(Help)=0 THEN Help := COPY(S,1,70);
      S := COPY(S,LENGTH(Help)+1,255);
      Help := 'Read: '+Help;
      PutData(ch,Help+#13);
      LEN := LEN + LENGTH(Help);
    END;
  END;
END;


{Umbauen eines Pascal-Strings in ein Array (fr BLOCKWRITE)}
PROCEDURE Strg2Arr255(VAR Arr255: tArr255; S: STRING; VAR Len: BYTE);
VAR i: BYTE;
BEGIN
  Len := Ord(S[0]);
  FOR i := 1 TO Len DO Arr255[i] := S[i];
END;


{CRLF (return) an ein Array hngen}
PROCEDURE AddCRLF(VAR Arr255: tArr255; VAR Len: BYTE);
BEGIN
  inc(Len);
  Arr255[Len] := CRLF[1];
  inc(Len);
  Arr255[Len] := CRLF[2];
END;


{Ersetzt INFOTEXT...}
FUNCTION SysText(ch: BYTE; TextNr: BYTE): STRING;
TYPE t2Bytes = ARRAY[1..2] OF BYTE;
     tArr255 = ARRAY[1..255] OF CHAR;
VAR S: STRING;
    f: File;
    Offset: WORD;
    Len: BYTE;
    Result: WORD;
    i: BYTE;
    Arr255: tArr255;
    _2Bytes: t2Bytes;
BEGIN
  ASSIGN(f,BoxPath+PATH_SEP+'msg'+PATH_SEP+'messages.'+klein(KS[ch]^.BoxData^.Spk));
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    SysText := 'Fehler beim ffnen des Language-Files!'+#13+'Evtl. die Sprache neu setzen...';
    Exit;
  END;

  {Eigentlichen Offset aus dem File holen}
  Offset := (TextNr*2) + 1;
  SEEK(f,Offset);
  BLOCKREAD(f,_2Bytes,2);

  {Eigentlichen Offset des Textes berechnen}
  Offset := _2Bytes[1]*256 + _2Bytes[2];

  SEEK(f,Offset);
  BLOCKREAD(f,Len,1,Result);
  BLOCKREAD(f,Arr255,Len,Result);

  S[0] := Char(Len);
  FOR i := 1 TO Len DO S[i] := Arr255[i];

  SysText := S;
  CLOSE(f);
END;



{Ersetzt INFOTEXT...}
FUNCTION SysTextWithSpk(lan: str3; TextNr: BYTE): STRING;
TYPE t2Bytes = ARRAY[1..2] OF BYTE;
     tArr255 = ARRAY[1..255] OF CHAR;
VAR S: STRING;
    f: File;
    Offset: WORD;
    Len: BYTE;
    Result: WORD;
    i: BYTE;
    Arr255: tArr255;
    _2Bytes: t2Bytes;
BEGIN
  ASSIGN(f,BoxPath+PATH_SEP+'msd'+PATH_SEP+'messages.'+klein(lan));
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult<>0 THEN BEGIN
    SysTextWithSpk := 'Fehler beim ffnen des Language-Files!'+#13+'Evtl. die Sprache neu setzen...';
    Exit;
  END;

  {Eigentlichen Offset aus dem File holen}
  Offset := (TextNr*2) + 1;
  SEEK(f,Offset);
  BLOCKREAD(f,_2Bytes,2);

  {Eigentlichen Offset des Textes berechnen}
  Offset := _2Bytes[1]*256 + _2Bytes[2];

  SEEK(f,Offset);
  BLOCKREAD(f,Len,1,Result);
  BLOCKREAD(f,Arr255,Len,Result);

  S[0] := Char(Len);
  FOR i := 1 TO Len DO S[i] := Arr255[i];

  SysTextWithSpk := S;
  CLOSE(f);
END;

FUNCTION BID_Da(BID: str12): BOOLEAN;
VAR data: TBIDHASHRec;
BEGIN
  Bid_DA:=BidHash^.GetData(BID,@data);
END;


{TRUE, wenn eine Datei <Call>.PWD im BOX-Dir vorhanden ist. (Passwort-
 geschtztes S&F}
FUNCTION SF_Passwort(Call: str6): BOOLEAN;
VAR SR: SearchRec;
    Offset: WORD;
BEGIN
  {
  FindFirst(BoxPath+klein(Call)+'.pwd',$20,SR);
  SF_Passwort := doserror=0;}
  SF_Passwort:=(fileda(boxpath+klein(call)+'.pwd') {OR fileda(boxpath+klein(call)+'.pwb')});
END;


{Aktuelle Systemzeit einlesen. Dann das Passwort berechnen, abspeichern
 und die Systemzeit in den entsprechenden String umwandeln.}
FUNCTION PasswdTime_CalcPW(ch: BYTE): STRING;
VAR f: File;
    S,Hlp: STRING;
    DT: DateTime;
    aWord,Offset,Result: WORD;
    tmp: ARRAY[1..1620] OF CHAR;
BEGIN
  PasswdTime_CalcPW := '';
  ASSIGN(f,BoxPath+CutSSID(KS[ch]^.Call)+'.pwd');
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult=0 THEN BEGIN
    {Zeit holen}
    GetDate(DT.Year,DT.Month,DT.Day,aWord);
    GetTime(DT.Hour,DT.Min,DT.Sec,aWord);

    {Den Offset berechnen. DieBox-Verfahren
      Zitat DieBox-Doku:

          Man addiert auf den Minutenanteil des Logindatums den Tag des Lo-
          gindatums drauf. Wird dabei diese Summe grsser als 59, so zieht
          man 60 ab. Dieses Ergebnis wird mit 27 multipliziert. Darauf ad-
          diert man dann den Stundenanteil des Logindatums. Die so ermittel-
          te Zahl gibt den Offset vom Fileanfang der Datei PWLIST.TXT . Die
          jetzt folgenden 4 Zeichen in der Datei PWLIST.TXT ergeben das
          Passwort.

    }
    Offset := DT.Min+DT.Day;
    IF Offset>59 THEN dec(Offset,60);
    Offset := (Offset * 27) + DT.Hour;
(*  Gendert, Jun '96 iad - *)
    SEEK(f,Offset);
{    BLOCKREAD(f,tmp,Offset-1,Result);}
     IF NOT EOF(f) THEN BEGIN
      BLOCKREAD(f,tmp,4,Result);
      IF Result=4 THEN BEGIN
        {Ergebnis des Passworts kommt nach SF_PW_What}
        KS[ch]^.BoxData^.SF_PW_What[0] := Chr(4);
        FOR aWord := 1 TO 4 DO KS[ch]^.BoxData^.SF_PW_What[aWord] := tmp[aWord];

        STR(DT.Day,S);
        IF LENGTH(S)=1 THEN S := '0' + S;
        STR(DT.Month,Hlp);
        IF LENGTH(Hlp)=1 THEN Hlp := '0' + Hlp;
        S := S + Hlp;
        STR(DT.Year,Hlp);
        S := S + COPY(Hlp,3,2);
        STR(DT.Hour,Hlp);
        IF LENGTH(Hlp)=1 THEN Hlp := '0' + Hlp;
        S := S + Hlp;
        STR(DT.Min,Hlp);
        IF LENGTH(Hlp)=1 THEN Hlp := '0' + Hlp;
        S := S + Hlp;

        {Datum bergeben}
        PasswdTime_CalcPW := S;

      END;
    END;
    CLOSE(f);
  END;
END;



{S&F-Passwort berechnen. Zahl steht in Hlp}
FUNCTION CalcPassword_SF(ch: BYTE; Time: STRING): STRING;
VAR Min,Day,Hour: BYTE;
    code,Result,Offset: WORD;
    f: File;
    tmp: ARRAY[1..1620] OF CHAR;
    Hlp: STRING;
    i: BYTE;
BEGIN
  CalcPassword_SF := 'XXXX';
  VAL(COPY(Time,1,2),Day,code);
  IF code<>0 THEN Exit;
  VAL(COPY(Time,7,2),Hour,code);
  IF code<>0 THEN Exit;
  VAL(COPY(Time,9,2),Min,code);
  IF code<>0 THEN Exit;

  ASSIGN(f,BoxPath+CutSSID(KS[ch]^.Call)+'.PWD');
  {$I-}
  RESET(f,1);
  {$I+}
  IF IOResult<>0 THEN Exit;

  {Offset berechnen

      Zitat DieBox-Doku:

          Man addiert auf den Minutenanteil des Logindatums den Tag des Lo-
          gindatums drauf. Wird dabei diese Summe grsser als 59, so zieht
          man 60 ab. Dieses Ergebnis wird mit 27 multipliziert. Darauf ad-
          diert man dann den Stundenanteil des Logindatums. Die so ermittel-
          te Zahl gibt den Offset vom Fileanfang der Datei PWLIST.TXT . Die
          jetzt folgenden 4 Zeichen in der Datei PWLIST.TXT ergeben das
          Passwort.

  }
  Offset := Min+Day;
  IF Offset>59 THEN dec(Offset,60);
  Offset := (Offset * 27) + Hour;

  SEEK(f,Offset);
{  BLOCKREAD(f,tmp,Offset-1,Result);}
  IF NOT EOF(f) THEN BEGIN
    BLOCKREAD(f,tmp,4,Result);
    IF Result=4 THEN BEGIN
      Hlp[0] := Chr(4);
      FOR i := 1 TO 4 DO Hlp[i] := tmp[i];
      CalcPassword_SF := Hlp;
    END;
  END;
  CLOSE(f);
END;


{Zerflckt eine Zeile wie   'MCUT 1-4' oder 'MCUT 1' oder '1' oder '1-'
 oder so und schreibt die Ergebnisse in die Variablen.
 Rckgabe: Errorcodes.
    0: Alles OK
}
FUNCTION GetFileParams(S: STRING; AktRub: str8; VAR Von,Bis: WORD; VAR Rubrik: str8): BYTE;
VAR Hlp: STRING;
    tmp,code,code2: WORD;
BEGIN
  S := LTRIM(RTRIM(OnlyOneSpace(S)));

  {Gucken, ob Leerzeichen vor oder nach '-' steht}
  WHILE POS('- ',S)>0 DO DELETE(S,POS('- ',S)+1,1);
  WHILE POS(' -',S)>0 DO DELETE(S,POS(' -',S),1);

  {Is eine Rubrik mit angegeben?}
  IF POS(' ',S)>0 THEN BEGIN
    Rubrik := COPY(S,1,POS(' ',S)-1);
    S := COPY(S,POS(' ',S)+1,255);
  END
  ELSE BEGIN
    VAL(COPY(S,1,POS('-',S)-1),tmp,code);
    VAL(COPY(S,POS('-',S)+1,255),tmp,code2);
    IF (code>0) OR (code2>0) THEN BEGIN
      Rubrik := S;
      Von := 1;
      Bis := 65535;
      GetFileParams := 0;
      Exit;
    END;
    Rubrik := AktRub;
  END;

  {Bereich}
  IF S[1]='-' THEN BEGIN
    Von := 1;
    VAL(COPY(S,2,255),Bis,code);
    IF code<>0 THEN BEGIN
      GetFileParams := 1;
      Exit;
    END;
  END
  ELSE IF S[LENGTH(S)]='-' THEN BEGIN
    Bis := 65535;
    VAL(COPY(S,1,LENGTH(S)-1),Von,code);
    IF code<>0 THEN BEGIN
      GetFileParams := 2;
      Exit;
    END;
  END
  ELSE IF POS('-',S)>0 THEN BEGIN
    VAL(COPY(S,1,POS('-',S)-1),Von,code);
    IF code<>0 THEN BEGIN
      GetFileParams := 3;
      Exit;
    END;

    VAL(COPY(S,POS('-',S)+1,255),Bis,code);
    IF code<>0 THEN BEGIN
      GetFileParams := 4;
      Exit;
    END;
  END
  ELSE BEGIN
    VAL(S,Von,code);
    IF code<>0 THEN BEGIN
      GetFileParams := 5;
      Exit;
    END;
    Bis := Von;
  END;
  GetFileParams := 0;
END;


{Lscht bei dem File mit der bergebenen BID das Hold-Flag}
PROCEDURE DelHoldFlag_CheckFile(BID: str12);
VAR CheckFile: FILE OF CheckRec;
    Check: CheckRec;
BEGIN
   ASSIGN(CheckFile,BOXPATH+'check.box');
  {$I-}
  RESET(CheckFile);
  {$I+}
  IF IOResult = 0 THEN BEGIN
    WHILE NOT EOF(CheckFile) DO BEGIN
      READ(CheckFile,Check);
      IF Gross(Check.BID) = Gross(BID) THEN BEGIN
        SEEK(CheckFile,FILEPOS(CheckFile)-1);
        {Del-Flag auf TRUE setzen (Siehe BOXVARS.PAS)}
        Check.Flags := Check.Flags AND $FFFF - CHECK_HOLD;
        WRITE(CheckFile,Check);
      END;
    END;
    CLOSE(CheckFile);
  END;
END;



{Lscht das Hold-Flag bei allen Mails mit der angegebenen BID in SFLISTE}
PROCEDURE DelHoldFlag_SFLISTE(BID: str12);
VAR SFFile: FILE OF SF_File_Rec;
    SF: SF_File_Rec;
BEGIN
  ASSIGN(SFFile,BoxPath+'sfliste');
  {$I-}
  RESET(SFFile);
  {$I+}
  IF IOResult = 0 THEN BEGIN
    WHILE NOT EOF(SFFile) DO BEGIN
      READ(SFFile,SF);
      IF BID = SF.BID THEN BEGIN
        SEEK(SFFile,FILEPOS(SFFile)-1);
        SF.Flags := SF.Flags AND $FFFF - SFLISTE_HOLD;
        WRITE(SFFile,SF);
      END;
    END;
    CLOSE(SFFile);
  END;
END;


FUNCTION SendToSFPartner(Boxcall: str8): str8;
VAR tmp: pBoxSF;
    Negative: BOOLEAN;
    S,Hlp: STRING;
BEGIN
  SendToSFPartner := '';

  tmp := BoxSFRoot;
  WHILE tmp<>NIL DO BEGIN

    Negative := FALSE;
    S := tmp^.WhatToForward;

    REPEAT
      {Zeile zerflcken}
      IF POS(' ',S)>0 THEN BEGIN
        Hlp := COPY(S,1,POS(' ',S)-1);
        S := COPY(S,POS(' ',S)+1,255);
      END
      ELSE BEGIN
        Hlp := S;
        S := '';
      END;

      IF BoxCall=tmp^.Call THEN BEGIN
        SendToSFPartner := tmp^.Call;
        Exit;
      END;

      CASE Hlp[1] OF
        '@': IF (COPY(Hlp,2,255)=BoxCall) AND NOT Negative THEN BEGIN
               SendToSFPartner := COPY(Hlp,2,255);
               Exit;
             END;
        '|': Negative := NOT Negative;
      END;
    UNTIL S='';
    tmp := tmp^.next;
  END;

  SendToSFPartner := FastSFPartner(BoxCall);
END;


{Fllt den String mit leerzeichen bis zur lnge count auf}
FUNCTION FillStr(count: BYTE; S: STRING): STRING;
VAR i: BYTE;
BEGIN
  S := COPY(S,1,count);
  FOR i := 0 TO count-1 DO IF i = LENGTH(S) THEN S := S + ' ';
  FillStr := S;
END;


{Sucht das letzte Vorkommen von Zeichen im String}
FUNCTION Last(Zeichen: CHAR; S: STRING): BYTE;
VAR i: BYTE;
BEGIN
  i := LENGTH(S);
  WHILE (i>0) AND (S[i]<>Zeichen) DO dec(i);
  IF i>0 THEN Last := i
         ELSE Last := LENGTH(S);
END;


{Sucht die im Speicher aus BOX.SF ausgelesene SID fr Call}
FUNCTION What_SID(Call: str6): BYTE;
VAR tmp: pBoxSF;
BEGIN
  tmp := BoxSFRoot;
  What_SID := 1;
  WHILE (tmp<>NIL) DO BEGIN
    IF tmp^.Call = Call THEN BEGIN
      What_SID := tmp^.SID;
      Exit;
    END;
    tmp := tmp^.next;
  END;
END;


END.
