(****************************************************************************)
(* Primitiv-Texteditor fr MCUT.                                            *)
(*                                                                          *)
(* Die Unit darf als Overlay deklariert werden.                             *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(* IAD, feb 96                                                              *)
(****************************************************************************)
UNIT editor;

INTERFACE

USES IADVAR;

  PROCEDURE initEdit(name:STRING);
  PROCEDURE KillEdit;
  PROCEDURE EditHandleKey;
  PROCEDURE EditLadenDlg;
  PROCEDURE EditLadenDlg_Auswert;
  PROCEDURE EditSaveAsDlg_Auswert;
  PROCEDURE EditKillDlg_Auswert;
  
  PROCEDURE DrawEditor;
  PROCEDURE EditSetCurs;
  PROCEDURE StartEditor;

  PROCEDURE Load(name:STRING;QuoteStr:STRING10);
  {$IFDEF BOX}
  PROCEDURE EditPostDlg_Auswert;
  {$ENDIF}
CONST
  title:string[80]='';
  absender:string[10]='';
  empfaenger:string[10]='';
  verteiler:string[10]='';
  Aktiv:BOOLEAN=FALSE;

IMPLEMENTATION

USES
     {$IFDEF BOX}
     BOXUTIL,BOXMAIN,
     {$ENDIF}
     SCREEN,VIDEO,INPUT,CRT,TOOLBOX,KEYMAKRO,
   {$IFNDEF FPK}MEMORY,{$ENDIF} DOS;

TYPE
   pEditBuf=^TEditBuf;
   STR128=STRING[128];
   tEditBuf=ARRAY[0..3000] OF ^STR128;

CONST
  pEditor:BYTE=3;
  fEditor:BYTE=7;
  EditWinSize:BYTE=16;
  WordWrap:BYTE=72;
  editversion='1.03';
  x_offset:BYTE=0;
  y_offset:WORD=1;

VAR
  EditBuf:pEditBuf;
  Abs_x,Abs_y,hoehe,breite:BYTE;
  Zeile,Spalte,ZeilenAnz:INTEGER;
  LastConsState:BYTE;
  changed:BOOLEAN;
  filename:STRING;


{$IFDEF BOX}

PROCEDURE EditPostDlg;
BEGIN
  Which_Dialog:=22;
  IF Absender='' THEN absender:=cutssid(mycall);
  DlgStr(20,2,8,@absender);
  DlgLabel(2,2,18,'Sender');
  DlgStr(20,3,8,@empfaenger);
  DlgLabel(2,3,18,'Board/Reciepent');
  DlgText(29,3,'@');
  DlgStr(31,3,8,@verteiler);
  DlgStr(2,5,40,@title);
  DlgLabel(2,4,20,'Subject');
  DlgCheck(2,6,20,'Add PGP signature',@SIGN_MAIL);
  IF PGP_USER_NAME='' THEN
     PGP_USER_NAME:=klein(cutssid(mycall));
  DlgStr(22,7,20,@PGP_USER_NAME);
  DlgLabel(2,7,20,'PGP username:');
  DlgTitle(' Post Mail/Article ');
  DlgInit(10,10,3);
END;

PROCEDURE EditPostDlg_Auswert;
VAR f,f2:text;W:WORD;S:STRING;
LABEL spagetti;
BEGIN
  Which_Dialog:=0;
  IF DLgResult=0 THEN exit;
  IF SIGN_MAIL THEN
  BEGIN
    ASSIGN(f,temppath+'PGP.TMP');
    REWRITE(f);
    FOR W:=1 TO ZeilenAnz DO
      WriteLn(f,EditBuf^[W]^);
    CLOSE(f);
    S:=' -sta '+temppath+'PGP.tmp'+' -u '+PGP_USER_NAME;
    ClrScr;
     {$IFNDEF LINUX}
    SetMemTop(HeapPtr);
    SwapVectors;
    EXEC(GETENV('PGPPATH')+'PGP.EXE',S);
    SwapVectors;
    SetMemTop(HeapEnd);
     {$ENDIF}
    IF IORESULt<>0 THEN WRITE(#7);
    Redrawscreen;
  END;
  ASSIGN(f,boxpath+'IMPORT\'+finduniqueimportfilename);
  {$I-}
  REWRITE(f);
  IF IORESULT<>0 THEN
  BEGIN
    PopUp('I/O Error');
    exit;
  END;
  WriteLn(f,'S '+gross(empfaenger),' @ ',gross(verteiler),' < ',gross(absender));
  WriteLn(f,title);
  WriteLn(f);
  WriteLn(f,'From : ',gross(absender),' @ ',gross(cutssid(boxcall)));
  WriteLn(f,'To   : ',gross(empfaenger),' @ ',gross(verteiler));
  WriteLn(f);
  IF SIGN_MAIL THEN
  BEGIN
    ASSIGN(f2,temppath+'pgp.asc');
    RESET(f2);
    IF IORESULT<>0 THEN
    BEGIN
      FOR W:=1 TO ZeilenAnz DO
        WriteLn(f,EditBuf^[W]^);
      GOTO Spagetti;
    END;
    WHILE NOT EOF(f2) DO
    BEGIN
      READLN(f2,s);
      WRITELN(f,s);
    END;
    CLOSE(f2);
    ERASE(F2);
  END ELSE
  BEGIN
    FOR W:=1 TO ZeilenAnz DO
      WriteLn(f,EditBuf^[W]^);
  END;
 Spagetti:
  IF IORESULT<>0 THEN;
  CLOSE(F);
  IF IORESULT<>0 THEN;
  PopUp(' On the way ');
  changed:=FALSE;
  Box_NewMail;
  {$I+}
END;


{$ENDIF}

PROCEDURE EditSetCurs;
VAR a,b:BYTE;
BEGIN
   A:=spalte-x_offset-1;
   B:=zeile+abs_y-Y_OFFSET-1;
{$IFNDEF FPK}
   ASM
     MOV ah,2
     MOV bh,0
     MOV dl,a
     MOV dh,b
     INT $10
   END; 
 {$ELSE}
   XGotoXy(spalte-x_offset,zeile+abs_y-Y_OFFSET);
 {$ENDIF}
END;

FUNCTION LADJ(S:STRING;len:BYTE):STRING;
BEGIN
   IF BYTE(S[0])>len THEN LADJ:=COPY(s,1,len) ELSE
  LADJ:=S+StringD(' ',len-byte(S[0]));
END;
FUNCTION RADJ(S:STRING;len:BYTE):STRING;
BEGIN
  IF BYTE(S[0])>len THEN RADJ:=COPY(s,BYTE(S[0])-len,255) ELSE
  RADJ:=StringD(' ',len-byte(S[0]))+S;
END;

PROCEDURE WriteStatusLine;
VAR S:STRING;
    s1,s2:STRING[10];
BEGIN
  S:=#0+char(yellow+blue*16)+'MCTEdit '+editversion+'  ';
  IF Changed THEN
   S:=S+#0+char(green+red*16) ELSE S:=S+#0+char(red+green*16);
  IF FileName='' THEN
    S:=S+LADJ('<noname>',12)  ELSE
    S:=S+RADJ(filename,12);
  IF Changed THEN
    S:=S+' !' ELSE S:=S+'  ';
  S:=S+#0+char(7+blue*16);
  STR(Zeile,s1);
  STR(Spalte,s2);
  S:=S+LADJ(' R:'+s1+'/C:'+s2,12);
  IF ins_mode THEN S:=S+'INSERT ' ELSE
    S:=S+'OVERWR ';
  STR(WordWrap,s1);
  S:=S+LADJ('Wrap: '+s1,10);
  S:=S+RADJ(' F1=Help',79-Length(S));
  WriteAttribString(1,pEditor-1,s,112);
END;


PROCEDURE DrawLine(y:WORD);
BEGIN
  
  IF y<=ZeilenAnz THEN
  BEGIN
    IF EditBuf^[y]^[0]=#0 THEN
      WriteAttribString(abs_x,abs_y+(y-Y_OFFSET),' ',fEditor)
    ELSE
      WriteAttribString(abs_x,abs_y+(y-Y_OFFSET),COPY(EditBuf^[y]^,x_offset+1,80),fEditor)
  END
  ELSE IF y=SUCC(ZeilenAnz) THEN
    WriteAttribString(abs_x,abs_y+(y-Y_OFFSET),'[EOF]',fEditor) ELSE
  WriteAttribString(abs_x,abs_y+(y-Y_OFFSET),' ',fEditor);
  IF consoleState=4 THEN
    DlgDraw;
END;


PROCEDURE DrawEditor;
VAR B:WORD;
BEGIN
  FOR B:=y_offset TO y_offset+EditWinSIze DO
     DrawLine(b);
END;

PROCEDURE Adjust;
BEGIN
  IF (Zeile<Y_OFFSET) THEN Y_OFFSET:=Zeile;
  IF (Zeile-Y_OFFSET)>EditWinSize THEN
    Y_OFFSET:=Zeile-EditWinSize;
  IF spalte-x_offset>79 THEN x_offset:=spalte-79;
  IF (spalte<=x_offset) AND (x_offset>0) THEN dec(x_offset);
  DrawEditor;
END;


PROCEDURE Load(name:STRING;QuoteStr:STRING10);
VAR F:text;
    S:STRING;
BEGIN
  InitEdit(name);
  IF name='' THEN
  BEGIN
    DrawEditor;
    exit;
  END;
  ASSIGN(f,name);
  {$I-}
  RESET(f);
  {$I+}
  IF IORESULT<>0 THEN
  BEGIN
    PopUp('File not found');
    exit;
  END;
  FileName:=name;
  Zeile:=0;
  WHILE NOT EOF(f) DO
  BEGIN
    READLN(f,s);
    INC(Zeile);
    IF Zeile>ZeilenAnz THEN
    BEGIN
      IF (Maxavail<15000) OR (Zeile=2900) THEN
      BEGIN
        PopUP('out of memory, do not save!');
        Changed:=TRUE;
        exit;
      END ELSE
      BEGIN
        INC(ZeilenAnz);
        NEW(EditBuf^[ZeilenAnz]);
      END;
    END;
    EditBuf^[Zeile]^:=QuoteStr+S;
  END;
  CLOSE(F);
  Zeile:=1;Spalte:=1;
  Y_OFFSET:=1;
  X_OFFSET:=0;
  Adjust;
  WriteStatusLine;
END;

PROCEDURE EditHelpDlg;
BEGIN
  Which_Dialog:=0;
  DlgOkButton(30,12,1,' OK ');
  DlgText(2,2,'Use Cursors, PgUp/PgDn to move in text.');
  DlgText(2,3,'INS toggles insert-mode');
  DlgText(2,4,'F2 to save');
  DlgText(2,5,'F3 to load');
  DlgText(2,6,'F4 to close MCTEdit');
  DlgText(2,7,'F5 to mail/post text over S&F');
  DlgText(2,8,'F10 to suspend and return to terminal');
  DlgText(2,10,'MCTEdit '+editversion+' (c) 1996-97 DG4IAD');
  DlgTitle(' MCTEdit '+editversion+' Help');
  DlgInit(15,Peditor,1);
END;


PROCEDURE SaveAs(name:STRING);
VAR f:text;W:WORD;
BEGIN
  ASSIGN(f,name);
  {$I-}
  REWRITE(f);
  IF IORESULT<>0 THEN
  BEGIN
    PopUp('I/O Error');
    exit;
  END;
  FOR W:=1 TO ZeilenAnz DO
    WriteLn(f,EditBuf^[W]^);
  CLOSE(F);
  changed:=FALSE;
  {$I+}
END;

PROCEDURE EndeEditor;
BEGIN
  ConsoleState:=LastConsState;
  RedrawScreen;
END;

PROCEDURE InitEdit(name:string);
BEGIN
  IF Aktiv THEN exit;
  NEW(EditBuf);
  Abs_x:=1;
  Breite:=80;
  Zeile:=1;
  Spalte:=1;
  ZeilenAnz:=1;
  X_OFFSET:=0;
  Y_OFFSET:=1;
  aktiv:=TRUE;
  Peditor:=2;
  Editwinsize:=_zeilen-1;
  (*EditWinSize:=QsoWinSize;*)
  Abs_y:=pEditor;
  Hoehe:=EditWinSize;
  New(EditBuf^[ZeilenAnz]);
  EditBuf^[ZeilenAnz]^[0]:=#0;
  LastConsState:=ConsoleState;
  ConsoleState:=1;
  Changed:=FALSE;
  FileName:='';
  IF name<>'' THEN load(name,'');
  EditSetCurs;
  WriteStatusLine;
END;


PROCEDURE EditKillDlg;
BEGIN
   Which_Dialog:=20;
   DlgOkButton(2,3,1,' YES ');
   DlgAbortButton(7,3,' CANCEL ');
   DlgText(2,2,' Loose Changes ?');
   DlgTitle('  exit MCTEdit? ');
   DlgInit(30,pEditor+2,2);
END;

PROCEDURE EditKillDlg_Auswert;
BEGIN
  Which_dialog:=0;
  IF dlgresult=0 THEN exit;
  KillEdit;
END;


PROCEDURE KillEdit;
VAR zaehl:WORD;
BEGIN
  IF NOT Aktiv THEN exit;
  FOR Zaehl:=1 to ZeilenAnz DO
    DISPOSE(EditBuf^[Zaehl]);
  DISPOSE(EditBuf);
  ConsoleState:=LastConsState;
  Aktiv:=FALSE;
  RedrawScreen;
END;


PROCEDURE EditLadenDlg;
BEGIN
  Which_Dialog:=18;
  DlgData[1]:='';
  DlgStr(2,3,40,@dlgdata[1]);
  DlgLabel(2,2,20,'filename    :');
  DlgAbortButton(32,5,'ABORT');
  DlgOkButton(38,5,1,' OK ');
  DlgTitle(' edit file ');
  DlgInit(10,10,1);
END;

PROCEDURE EditLadenDlg_Auswert;
BEGIN
  Which_Dialog:=0;
  If DlgResult=1 THEN
    Load(dlgData[1],'');
END;

PROCEDURE EditSaveAsDlg;
BEGIN
  Which_Dialog:=19;
  DlgData[1]:='';
  DlgStr(2,3,40,@filename);
  DlgLabel(2,2,20,'filename    :');
  DlgAbortButton(32,5,'ABORT');
  DlgOkButton(38,5,1,' OK ');
  DlgTitle(' Save As ');
  DlgInit(10,10,1);
END;

PROCEDURE EditSaveAsDlg_Auswert;
BEGIN
  Which_Dialog:=0;
  IF filename='' THEN EditSaveAsDlg;
  SaveAs(filename);
END;


PROCEDURE EditSendMessageDlg;
BEGIN
END;


PROCEDURE StartEditor;
BEGIN
  IF aktiv THEN
  BEGIN
    LastConsState:=ConsoleState;
    ConsoleState:=1;
    Draweditor;
  END
  ELSE
    EditLadenDlg;
END;



PROCEDURE EditHandleKey;
VAR taste:CHAR;Zaehl:WORD;B:BYTE;
    HilfStr:STRING;am_ende:BOOLEAN;
BEGIN
  Taste:=XReadKey;
  CASE taste OF
     #8:{Backspace}
        IF Spalte>1 THEN
        BEGIN
          DEC(Spalte);
          Delete(EditBuf^[Zeile]^,Spalte,1);
          DrawLine(zeile);
          changed:=TRUE;
        END ELSE
        IF Zeile>1 THEN
        BEGIN
         Spalte:=Length(Editbuf^[pred(Zeile)]^)+1;
         EditBuf^[pred(Zeile)]^:=EditBuf^[pred(zeile)]^+EditBuf^[zeile]^;
         FOR Zaehl:=Zeile TO PRED(ZeilenAnz) DO
            EditBuf^[Zaehl]^:=EditBuf^[Succ(Zaehl)]^;
         DISPOSE(EditBuf^[ZeilenAnz]);
         DEC(ZeilenAnz);
         DEC(Zeile);
         changed:=TRUE;
         (* Spalte:=LENGTH(EditBuf^[Zeile]^)+1; *)
         Adjust;
        END;
     #25:{Control-Y}
        IF Zeile<Zeilenanz THEN
        BEGIN
         FOR Zaehl:=Zeile TO PRED(ZeilenAnz) DO
            EditBuf^[Zaehl]^:=EditBuf^[Succ(Zaehl)]^;
         DISPOSE(EditBuf^[ZeilenAnz]);
         DEC(ZeilenAnz);
         IF Zeile>ZeilenAnz THEN DEC(Zeile);
         changed:=TRUE;
         Spalte:=1;
         Adjust;
        END ELSE
        IF Zeile=Zeilenanz THEN
        BEGIN
          spalte:=1;
          EditBuf^[zeile]^:='';
          DrawLine(Zeile);
          changed:=TRUE;
          Adjust;
        END;
     #13:{Return}
        BEGIN
          INC(Zeile);
          IF MaxAvail>10000 THEN
          BEGIN
            INC(ZeilenAnz);
            NEW(EditBuf^[ZeilenAnz]);
            FOR Zaehl:=PRED(ZeilenAnz) DOWNTO Zeile DO
              EditBuf^[SUCC(Zaehl)]^:=EditBuf^[Zaehl]^;
            EditBuf^[Zeile]^:=COPY(editBuf^[PRED(Zeile)]^,spalte,255);
            EditBuf^[pred(zeile)]^[0]:=char(pred(spalte));
          END ELSE 
          BEGIN
             Dec(Zeile);
             PopUp('MEMORY!!!');
             exit;
          END;   
          Spalte:=1;
          Adjust;
          changed:=TRUE;
        END;
#1..#7,
#9..#12,
#14..#24,
#26,#29..#255:
            BEGIN
              changed:=TRUE;
              IF ins_mode THEN
              BEGIN
                Insert(taste,EditBuf^[Zeile]^,Spalte);
                inc(Spalte);
                DrawLine(Zeile);
              END
              ELSE
              BEGIN
                EditBuf^[Zeile]^[Spalte]:=taste;
                IF Spalte>Length(EditBuf^[Zeile]^) THEN
                  Spalte:=Length(EditBuf^[Zeile]^);
                inc(Spalte);
                DrawLine(Zeile);
              END;
              IF (length(EditBuf^[Zeile]^)>74) {and (EditBuf^[Zeile]^[length(EditBuf^[Zeile]^)]<>' ')} THEN
              BEGIN
                B:=length(EditBuf^[Zeile]^);
                am_ende:=(spalte>=B);
                WHILE (EditBuf^[Zeile]^[b]<>' ') and (B>1) DO DEC(B);
                IF B>1 THEN
                BEGIN
                  HilfStr:=Copy(EditBuf^[Zeile]^,b+1,255);
                  delete(EditBuf^[Zeile]^,b,255);
                  INC(Zeile);
                  IF Zeile>ZeilenAnz THEN
                  BEGIN 
                    IF MaxAvail>10000 THEN
                    BEGIN
                      INC(ZeilenAnz);
                      NEW(EditBuf^[ZeilenAnz]);
                     (* FOR Zaehl:=PRED(ZeilenAnz) DOWNTO Zeile DO
                        EditBuf^[SUCC(Zaehl)]^:=EditBuf^[Zaehl]^;
                      EditBuf^[Zeile]^:='';     *)
                    END ELSE EXIT;
                    EditBuf^[Zeile]^:=HilfStr;
                  END ELSE
                  IF (EditBuf^[Zeile]<>NIL)  THEN
                  BEGIN 
                    IF  ((length(EditBuf^[Zeile]^)+length(HilfStr))<74) THEN
                    BEGIN
                       EditBuf^[Zeile]^:=HilfStr+' '+EditBuf^[Zeile]^ ;
                    END ELSE
                    BEGIN
                      IF MaxAvail>10000 THEN
                      BEGIN
                        INC(ZeilenAnz);
                        NEW(EditBuf^[ZeilenAnz]);
                        FOR Zaehl:=PRED(ZeilenAnz) DOWNTO Zeile DO
                          EditBuf^[SUCC(Zaehl)]^:=EditBuf^[Zaehl]^;
                        EditBuf^[Zeile]^:='';
                      END;
                      EditBuf^[Zeile]^:=HilfStr;
                    END;  
                  END ELSE
                  BEGIN
                    IF MaxAvail>10000 THEN
                    BEGIN
                      INC(ZeilenAnz);
                      NEW(EditBuf^[ZeilenAnz]);
                      FOR Zaehl:=PRED(ZeilenAnz) DOWNTO Zeile DO
                        EditBuf^[SUCC(Zaehl)]^:=EditBuf^[Zaehl]^;
                      EditBuf^[Zeile]^:='';
                    END;
                    EditBuf^[Zeile]^:=HilfStr;
                  END;
                  IF am_ende THEN
                    Spalte:=length(hilfstr)+1 ELSE
                  BEGIN
                    DEC(Zeile);
                      (* Spalte:=length(EditBuf^[Zeile]^)+1;*)
                  END;  
                END;
              END;
              IF length(EditBuf^[Zeile]^)=80 THEN
              BEGIN
                Spalte:=1;
                INC(Zeile);
                IF MaxAvail>10000 THEN
                BEGIN
                  INC(ZeilenAnz);
                  NEW(EditBuf^[ZeilenAnz]);
                  FOR Zaehl:=PRED(ZeilenAnz) DOWNTO Zeile DO
                    EditBuf^[SUCC(Zaehl)]^:=EditBuf^[Zaehl]^;
                  EditBuf^[Zeile]^:='';
                END;
              END;
              Adjust;
           END;
     #0:BEGIN
          CASE Xreadkey OF
            #77:{Pfeil rechts}
                BEGIN
                  IF Spalte<length(EditBuf^[Zeile]^)+1 THEN INC(Spalte);
                  IF spalte-x_offset>79 THEN inc(x_offset);
                  adjust;
                END;
            #75:
            {Pfeil links}
                BEGIN
                  IF Spalte>1 THEN DEC(Spalte);
                  IF (spalte<=x_offset) AND (x_offset>0) THEN dec(x_offset);
                  adjust;
                END;
            #71:{POS1}
                 BEGIN
                   Spalte:=1;
                   x_offset:=0;
                   adjust;
                 END;
            #79:{END}
                 BEGIN
                  Spalte:=Length(EditBuf^[Zeile]^)+1;
                  IF spalte-x_offset>79 THEN x_offset:=spalte-79;
                  adjust;
                 END;
            #80:{pfeil unten}
                BEGIN
                  IF Zeile<ZeilenAnz THEN inc(Zeile);
                  IF Spalte>(Length(EditBuf^[Zeile]^)+1) THEN
                    Spalte:=length(EditBuf^[Zeile]^)+1;
                  Adjust;
                END;
            #72:{pfeil oben}
                BEGIN
                  IF Zeile>1 THEN
                    DEC(Zeile);
                  IF Spalte>(Length(EditBuf^[Zeile]^)+1) THEN
                    Spalte:=length(EditBuf^[Zeile]^)+1;
                  Adjust;
                END;
            #73:{pgup}
                BEGIN
                  IF Hoehe<Zeile THEN
                    DEC(Zeile,Hoehe)
                  ELSE
                    Zeile:=1;
                  Adjust;
                END;
            #81:{pgDn}
                BEGIN
                  IF (Zeile+Hoehe)>ZeilenAnz THEN
                    Zeile:=ZeilenAnz
                  ELSE
                    INC(Zeile,Hoehe);
                  Adjust;
                END;
            #82:{insert}
                BEGIN
                  ins_mode:=NOT ins_mode;
		  {$IFNDEF linux}
                  IF ins_mode THEN Cursor(2) ELSE
                   Cursor(1);
		  {$ENDIF} 
                END;
            #83:{del}
                BEGIN
                  Delete(EditBuf^[Zeile]^,Spalte,1);
                  drawline(zeile);
                  changed:=TRUE;
                END;
            #115:{strg-rechts};
            #116:{STRG-links};
            #59:{F1-Hilfe}
                EditHelpDlg;
            #60:{F2-Speichern...}
                EditSaveAsDlg;
            #61:{F3-Laden....}
                EditLadenDlg;
            #62,#45:BEGIN {Beenden...}
                  IF NOT Changed THEN
                    KillEdit
                  ELSE EditKillDlg;
                END;
            {$IFDEF BOX}
            #63:EditPostDlg;
            {$ENDIF}
            #68:{Suspendieren...}
                EndeEditor;
          END;
       END;
  END; { case }
  IF ConsoleState=CONS_EDIT THEN
     WriteStatusLine;
END;

BEGIN
  aktiv:=FALSE;
END.


