(****************************************************************************)
(* Primitiv-Texteditor fr MCUT.                                            *)
(*                                                                          *)
(* Die Unit darf als Overlay deklariert werden.                             *)
(*                                                                          *)
(* Diese Unit ist Teil des MCUT-Sourcecodes, alle Rechte liegen bei         *)
(* DG4IAD und DG6VJ                                                         *)
(*                                                                          *)
(* IAD, feb 96                                                              *)
(****************************************************************************)
UNIT editor;

INTERFACE

  PROCEDURE initEdit(name:STRING);
  PROCEDURE KillEdit;
  PROCEDURE EditHandleKey;
  PROCEDURE EditLadenDlg;
  PROCEDURE EditLadenDlg_Auswert;
  PROCEDURE EditSaveAsDlg_Auswert;
  PROCEDURE EditKillDlg_Auswert;
  PROCEDURE DrawEditor;
  PROCEDURE EditSetCurs;

IMPLEMENTATION
USES IADVAR,SCREEN,VIDEO,INPUT,CRT,TOOLBOX,KEYMAKRO;

TYPE
   pEditBuf=^TEditBuf;
   pString=^STRING;
   STR128=STRING[128];
   tEditBuf=ARRAY[0..3000] OF ^STR128;

CONST
  pEditor=3;
  fEditor=7;
  EditWinSize=15;
  WordWrap:BYTE=72;
  editversion='0.1';

VAR
  EditBuf:pEditBuf;
  Abs_x,Abs_y,hoehe,breite,x_offset:BYTE;
  Zeile,Spalte,ZeilenAnz:INTEGER;
  Aktiv:BOOLEAN;
  LastConsState:BYTE;
  changed:BOOLEAN;
  filename:STRING;
  FirstLine:INTEGER;


PROCEDURE FreeStr(VAR pstr:pSTRING);
BEGIN
    IF (byte(pstr^[0])>0) AND (byte(pstr^[0])<40) THEN
       FreeMem(pstr,41)
    ELSE
      IF (byte(pstr^[0])>=40) AND (byte(pstr^[0])<80) THEN
        FreeMem(pstr,81)
      ELSE
        IF (byte(pstr^[0])>=80) AND (byte(pstr^[0])<120) THEN
          FreeMem(pstr,121)
        ELSE
          IF (byte(pstr^[0])>=120) AND (byte(pstr^[0])<160) THEN
            FreeMem(pstr,161)
          ELSE
            IF (byte(pstr^[0])>=160) AND (byte(pstr^[0])<200) THEN
              FreeMem(pstr,201)
            ELSE
              IF (byte(pstr^[0])>=200) THEN
                FreeMem(pstr,255);
END;

FUNCTION StrMem(pstr:pSTRING;newsize:BYTE):pSTRING;
VAR newstr:pSTRING;
BEGIN
  IF pStr<>NIL THEN
  IF ((INTEGER(newsize)-BYTE(pstr^[0]))<0) AND
     ((INTEGER(newsize)-BYTE(pstr^[0]))>-40) THEN
  BEGIN
    StrMem:=pStr;
    exit;
  END;
  IF (newsize>0) AND (newsize<40) THEN
     GetMem(newstr,41)
  ELSE
    IF (newsize>=40) AND (newsize<80) THEN
      GetMem(newstr,81)
    ELSE
      IF (newsize>=80) AND (newsize<120) THEN
        GetMem(newstr,121)
      ELSE
        IF (newsize>=120) AND (newsize<160) THEN
          GetMem(newstr,161)
        ELSE
          IF (newsize>=160) AND (newsize<200) THEN
            GetMem(newstr,201)
          ELSE
            IF (newsize>=200) THEN
              GetMem(newstr,255);
  NewStr^[0]:=#0;
  IF pstr<>NIL THEN
  BEGIN
    MOVE(pstr^,newstr^,length(pstr^)+1);
    FreeSTr(pstr);
  END;
  StrMem:=NewStr;
END;

PROCEDURE EditSetCurs;
BEGIN
   GotoXy(spalte-x_offset,zeile+abs_y-firstline);
END;

FUNCTION LADJ(S:STRING;len:BYTE):STRING;
BEGIN
   IF BYTE(S[0])>len THEN LADJ:=COPY(s,1,len) ELSE
  LADJ:=S+StringD(' ',len-byte(S[0]));
END;
FUNCTION RADJ(S:STRING;len:BYTE):STRING;
BEGIN
  IF BYTE(S[0])>len THEN RADJ:=COPY(s,BYTE(S[0])-len,255) ELSE
  RADJ:=StringD(' ',len-byte(S[0]))+S;
END;

PROCEDURE WriteStatusLine;
VAR S:STRING;
    s1,s2:STRING[10];
BEGIN
  S:=#0+char(yellow+blue*16)+'MCTEdit '+editversion+'! ';
  IF Changed THEN
   S:=S+#0+char(7) ELSE S:=S+#0+char(red+green*16);
  IF FileName='' THEN
    S:=S+LADJ('<noname>',12)  ELSE
    S:=S+RADJ(filename,12);
  IF Changed THEN
    S:=S+' !' ELSE S:=S+'  ';
  S:=S+#0+char(7+blue*16);
  STR(Zeile,s1);
  STR(Spalte,s2);
  S:=S+LADJ(' R:'+s1+'/C:'+s2,12);
  IF ins_mode THEN S:=S+'INSERT ' ELSE
    S:=S+'OVERWR ';
  STR(WordWrap,s1);
  S:=S+LADJ('Wrap: '+s1,10);
  S:=S+RADJ(' F1=Help',79-Length(S));
  WriteAttribString(1,pEditor-1,s,112);
END;


PROCEDURE DrawLine(y:WORD);
BEGIN
  IF y<=ZeilenAnz THEN
  BEGIN
    IF EditBuf^[y]^[0]=#0 THEN
      WriteAttribString(abs_x,abs_y+(y-Firstline),' ',fEditor)
    ELSE
      WriteAttribString(abs_x,abs_y+(y-Firstline),COPY(EditBuf^[y]^,x_offset,79),fEditor)
  END
  ELSE IF y=SUCC(ZeilenAnz) THEN
    WriteAttribString(abs_x,abs_y+(y-Firstline),'[EOF]',fEditor) ELSE
  WriteAttribString(abs_x,abs_y+(y-Firstline),' ',fEditor);
  IF consoleState=4 THEN
    DlgDraw;
END;


PROCEDURE DrawEditor;
VAR B:WORD;
BEGIN
  FOR B:=FirstLine TO firstline+EditWinSIze DO
     DrawLine(b);
END;

PROCEDURE Load(name:STRING);
VAR F:text;
    S:STRING;
BEGIN
  InitEdit('');
  IF name='' THEN
  BEGIN
    DrawEditor;
    exit;
  END;
  ASSIGN(f,name);
  {$I-}
  RESET(f);
  {$I+}
  IF IORESULT<>0 THEN
  BEGIN
    PopUp('File not found');
    exit;
  END;
  FileName:=name;
  Zeile:=0;
  WHILE NOT EOF(f) DO
  BEGIN
    READLN(f,s);
    INC(Zeile);
    IF Zeile>ZeilenAnz THEN
    BEGIN
      IF Maxavail<5000 THEN
      BEGIN
        PopUP('out of memory, do not save!');
        Changed:=TRUE;
        exit;
      END ELSE
      BEGIN
        INC(ZeilenAnz);
        (*
        NEW(EditBuf^[ZeilenAnz]);
        *)
        EditBuf^[ZeilenAnz]:=StrMem(NIL,Length(S));
      END;
    END
    ELSE
      EditBuf^[ZeilenAnz]:=StrMem(EditBuf^[ZeilenAnz],Length(S));;
    EditBuf^[Zeile]^:=S;
  END;
  CLOSE(F);
  Zeile:=1;Spalte:=1;
  FirstLine:=1;
  DrawEditor;
  WriteStatusLine;
END;

PROCEDURE EditHelpDlg;
BEGIN
  Which_Dialog:=0;
  DlgOkButton(30,15,1,' OK ');
  DlgText(2,2,'Use Cursors, PgUp/PgDn to move in text.');
  DlgText(2,3,'INS toggles insert-mode');
  DlgText(2,4,'F2 to save');
  DlgText(2,5,'F3 to load');
  DlgText(2,6,'F4 to close MCEdit');
  DlgText(2,7,'F10 to suspend and return to terminal');
  DlgText(2,13,'MCTEdit '+editversion+' (c) 1996 DG4IAD');
  DlgTitle(' MCTEdit '+editversion+' Help');
  DlgInit(15,Peditor,1);
END;


PROCEDURE SaveAs(name:STRING);
VAR f:text;W:WORD;
BEGIN
  ASSIGN(f,name);
  {$I-}
  REWRITE(f);
  IF IORESULT<>0 THEN
  BEGIN
    PopUp('I/O Error');
    exit;
  END;
  FOR W:=1 TO ZeilenAnz DO
    Write(f,EditBuf^[W]^);
  CLOSE(F);
  {$I+}
END;

PROCEDURE EndeEditor;
BEGIN
  ConsoleState:=LastConsState;
  RedrawScreen;
END;

PROCEDURE InitEdit(name:string);
BEGIN
  IF Aktiv THEN exit;
  NEW(EditBuf);
  Abs_x:=1;
  x_offset:=0;
  Abs_y:=pEditor;
  Hoehe:=EditWinSize;
  Breite:=80;
  Zeile:=1;
  Spalte:=1;
  ZeilenAnz:=1;
  Firstline:=1;
  aktiv:=TRUE;
  EditBuf^[ZeilenAnz]:=StrMem(NIL,1);
  EditBuf^[ZeilenAnz]^[0]:=#0;
  LastConsState:=ConsoleState;
  ConsoleState:=1;
  Changed:=FALSE;
  FileName:='';
  IF name<>'' THEN load(name);
  WriteStatusLine;
END;


PROCEDURE EditKillDlg;
BEGIN
   Which_Dialog:=20;
   DlgOkButton(2,3,1,' YES ');
   DlgAbortButton(2,7,' CANCEL ');
   DlgText(2,2,' Loose Changes ?');
   DlgTitle('  exit MCTEdit? ');
   DlgInit(30,pEditor+2,2);
END;

PROCEDURE EditKillDlg_Auswert;
BEGIN
  Which_dialog:=0;
  KillEdit;
END;


PROCEDURE KillEdit;
VAR zaehl:WORD;
BEGIN
  IF NOT Aktiv THEN exit;
  FOR Zaehl:=1 to ZeilenAnz DO
    FreeStr(EditBuf^[Zaehl]);
  DISPOSE(EditBuf);
  ConsoleState:=LastConsState;
  Aktiv:=FALSE;
  RedrawScreen;
END;


PROCEDURE EditLadenDlg;
BEGIN
  Which_Dialog:=18;
  DlgData[1]:='';
  DlgStr(2,3,40,@dlgdata[1]);
  DlgLabel(2,2,20,'filename    :');
  DlgAbortButton(32,5,'ABORT');
  DlgOkButton(38,5,1,' OK ');
  DlgTitle(' edit file ');
  DlgInit(10,10,1);
END;

PROCEDURE EditLadenDlg_Auswert;
BEGIN
  Which_Dialog:=0;
  Load(dlgData[1]);
END;

PROCEDURE EditSaveAsDlg;
BEGIN
  Which_Dialog:=19;
  DlgData[1]:='';
  DlgStr(2,3,40,@filename);
  DlgLabel(2,2,20,'filename    :');
  DlgAbortButton(32,5,'ABORT');
  DlgOkButton(38,5,1,' OK ');
  DlgTitle(' Save As ');
  DlgInit(10,10,1);
END;

PROCEDURE EditSaveAsDlg_Auswert;
BEGIN
  Which_Dialog:=0;
  IF filename='' THEN EditSaveAsDlg;
  SaveAs(filename);
END;


PROCEDURE Adjust;
BEGIN
  IF Zeile<1 THEN Zeile:=1;
  IF (Zeile<Firstline) THEN
  BEGIN
    FirstLine:=Zeile;
  END ELSE
  IF (Zeile-Firstline)>=EditWinSize THEN
  BEGIN
    FirstLine:=Zeile-EditWinSize;
  END;
  DrawEditor;
END;

PROCEDURE EditHandleKey;
VAR taste:CHAR;Zaehl:WORD;B:BYTE;
    HilfStr:STRING;
BEGIN
  Taste:=XReadKey;
  CASE taste OF
     #8:{Backspace}
        IF Spalte>1 THEN
        BEGIN
          DEC(Spalte);
          Delete(EditBuf^[Zeile]^,Spalte,1);
          DrawLine(zeile);
          changed:=TRUE;
        END ELSE
        IF Zeile>1 THEN
        BEGIN
         EditBuf^[pred(Zeile)]^:=EditBuf^[pred(zeile)]^+EditBuf^[zeile]^;
         FOR Zaehl:=Zeile TO PRED(ZeilenAnz) DO
            EditBuf^[Zaehl]^:=EditBuf^[Succ(Zaehl)]^;
         DISPOSE(EditBuf^[ZeilenAnz]);
         DEC(ZeilenAnz);
         DEC(Zeile);
         changed:=TRUE;
         Spalte:=LENGTH(EditBuf^[Zeile]^);
         Adjust;
        END;
     #25:{Control-Y}
        IF Zeile>1 THEN
        BEGIN
         FOR Zaehl:=Zeile TO PRED(ZeilenAnz) DO
            EditBuf^[Zaehl]^:=EditBuf^[Succ(Zaehl)]^;
         DISPOSE(EditBuf^[ZeilenAnz]);
         DEC(ZeilenAnz);
         DEC(Zeile);
         changed:=TRUE;
         Spalte:=LENGTH(EditBuf^[Zeile]^);
         Adjust;
        END;
     #13:{Return}
        BEGIN
          INC(Zeile);
          IF MaxAvail>10000 THEN
          BEGIN
            INC(ZeilenAnz);
            NEW(EditBuf^[ZeilenAnz]);
            FOR Zaehl:=PRED(ZeilenAnz) DOWNTO Zeile DO
              EditBuf^[SUCC(Zaehl)]^:=EditBuf^[Zaehl]^;
            EditBuf^[Zeile]^:=COPY(editBuf^[PRED(Zeile)]^,spalte,255);
            EditBuf^[pred(zeile)]^[0]:=char(pred(spalte));
          END;
          Spalte:=1;
          Adjust;
          changed:=TRUE;
        END;
     #1..#255:
            BEGIN
              changed:=TRUE;
              IF ins_mode THEN
              BEGIN
                Insert(taste,EditBuf^[Zeile]^,Spalte);
                inc(Spalte);
                DrawLine(Zeile);
              END
              ELSE
              BEGIN
                EditBuf^[Zeile]^[Spalte]:=taste;
                IF Spalte>Length(EditBuf^[Zeile]^) THEN
                  Spalte:=Length(EditBuf^[Zeile]^);
                inc(Spalte);
                DrawLine(Zeile);
              END;
              IF (length(EditBuf^[Zeile]^)>74) and (EditBuf^[Zeile]^[length(EditBuf^[Zeile]^)]<>' ') THEN
              BEGIN
                B:=length(EditBuf^[Zeile]^);
                WHILE (EditBuf^[Zeile]^[b]<>' ') and (B>1) DO DEC(B);
                IF B>1 THEN
                BEGIN
                  HilfStr:=Copy(EditBuf^[Zeile]^,b+1,255);
                  delete(EditBuf^[Zeile]^,b,255);
                  INC(Zeile);
                  IF MaxAvail>10000 THEN
                  BEGIN
                    INC(ZeilenAnz);
                    NEW(EditBuf^[ZeilenAnz]);
                    FOR Zaehl:=PRED(ZeilenAnz) DOWNTO Zeile DO
                      EditBuf^[SUCC(Zaehl)]^:=EditBuf^[Zaehl]^;
                    EditBuf^[Zeile]^:='';
                  END;
                  EditBuf^[Zeile]^:=HilfStr;
                  Spalte:=length(hilfstr)+1;
                END;
                Adjust;
              END;
              IF length(EditBuf^[Zeile]^)=80 THEN
              BEGIN
                Spalte:=1;
                INC(Zeile);
                IF MaxAvail>10000 THEN
                BEGIN
                  INC(ZeilenAnz);
                  NEW(EditBuf^[ZeilenAnz]);
                  FOR Zaehl:=Zeile TO PRED(ZeilenAnz) DO
                    EditBuf^[SUCC(Zaehl)]^:=EditBuf^[Zaehl]^;
                  EditBuf^[Zeile]^:='';
                END;
                Adjust;
              END;
           END;
     #0:BEGIN
          CASE Xreadkey OF
            #77:{Pfeil rechts}
                BEGIN
                  IF Spalte<length(EditBuf^[Zeile]^)+1 THEN INC(Spalte);
                  IF spalte-x_offset>79 THEN inc(x_offset);
                END;
            #75:
            {Pfeil links}
                BEGIN
                  IF Spalte>1 THEN DEC(Spalte);
                  IF spalte-x_offset<1 THEN dec(x_offset);
                END;
            #71:{POS1}
                  Spalte:=1;
            #79:{END}
                  Spalte:=Length(EditBuf^[Zeile]^)+1;
            #80:{pfeil unten}
                BEGIN
                  IF Zeile<ZeilenAnz THEN inc(Zeile);
                  IF Spalte>(Length(EditBuf^[Zeile]^)+1) THEN
                    Spalte:=length(EditBuf^[Zeile]^)+1;
                  Adjust;
                END;
            #72:{pfeil oben}
                BEGIN
                  IF Zeile>1 THEN
                    DEC(Zeile);
                  IF Spalte>(Length(EditBuf^[Zeile]^)+1) THEN
                    Spalte:=length(EditBuf^[Zeile]^)+1;
                  Adjust;
                END;
            #73:{pgup}
                BEGIN
                  IF Hoehe>Zeile THEN
                    DEC(Zeile,Hoehe)
                  ELSE
                    Zeile:=0;
                  Adjust;
                END;
            #81:{pgDn}
                BEGIN
                  IF (Zeile+Hoehe)>ZeilenAnz THEN
                    Zeile:=ZeilenAnz
                  ELSE
                    INC(Zeile,Hoehe);
                  Adjust;
                END;
            #82:{insert}
                BEGIN
                  ins_mode:=NOT ins_mode;
                  IF ins_mode THEN Cursor(2) ELSE
                   Cursor(1);
                END;
            #83:{del}
                BEGIN
                  Delete(EditBuf^[Zeile]^,Spalte,1);
                  drawline(zeile);
                  changed:=TRUE;
                END;
            #115:{strg-rechts};
            #116:{STRG-links};
            #59:{F1-Hilfe}
                EditHelpDlg;
            #60:{F2-Speichern...}
                EditSaveAsDlg;
            #61:{F3-Laden....}
                EditLadenDlg;
            #62,#45:BEGIN {Beenden...}
                  IF NOT Changed THEN
                    KillEdit
                  ELSE EditKillDlg;
                END;
            #68:{Suspendieren...}
                EndeEditor;
          END;
       END;
  END;
  WriteStatusLine;
END;

BEGIN
  aktiv:=FALSE;
END.


