UNIT KEYMAKRO;
INTERFACE

TYPE PKMac=^TKMac;
     TKMac=RECORD
       S:STRING;
       asc,code:CHAR;
       N:PKMac;
     END;

CONST
  status:BYTE=0;
  makro:STRING='';
  kmacroot:PKMac=NIL;



FUNCTION XReadKey:CHAR;
FUNCTION XKeyPressed:BOOLEAN;
PROCEDURE Aufnehmen;
FUNCTION StopAufnahme:STRING;
PROCEDURE Abspielen(S:STRING);
PROCEDURE SaveKeyMakro;
PROCEDURE ReadMakros;
PROCEDURE WriteMakros;
FUNCTION KMacScan(c:char):BOOLEAN;
FUNCTION KMacAscii(c:char):BOOLEAN;
IMPLEMENTATION

USES CRT,VIDEO,SCREEN,TOOLBOX,IADVAR,MYSTRING;

PROCEDURE SaveKeyMakro;
VAR S:STRING;
    code,asc:CHAR;
    p,p2:PkMac;
BEGIN
  S:=StopAufnahme;
  WriteAttribString(1,pStatus1,'Press Hotkey for Makro... ESC=Abort.',fstatusoben);
  Sound(1000);delay(25); Sound(600);delay(100); sound(800); delay(75); nosound;
  asc:=readkey;
  IF asc=#27 THEN exit;
  code:=#0;
  IF asc=#0 THEN
    code:=readkey;
  p:=kmacroot;
  p2:=p;
  WHILE p<>NIL DO
  BEGIN
    IF (p^.asc=asc) AND (p^.code=code) THEN
    BEGIN
      IF S='' THEN
      BEGIN
        IF p=kmacroot THEN
          kmacroot:=p^.n
        ELSE
          p2^.n:=p^.n;
        dispose(p);
        exit;
      END ELSE
      p^.s:=s;
      exit;
    END;
    p2:=p;
    p:=p^.n;
  END;
  p:=kmacroot;
  NEW(kmacroot);
  kmacroot^.asc:=asc;
  kmacroot^.code:=code;
  kmacroot^.s:=s;
  kmacroot^.n:=p;
  redrawscreen;
END;

PROCEDURE WriteMakros;
VAR code,asc:CHAR;
    p:PkMac;
    f:text;B:BYTE;
    len:BYTE;
BEGIN
  p:=kmacroot;
  IF kmacroot=NIL THEN exit;
  ASSIGN(f,qrvpath+'KMAC.MCT');
  {$I-}
  REWRITE(f);
  IF IORESULT<>0 THEN exit;
  len:=0;
  WHILE p<>NIL DO
  BEGIN
    WRITELN(f,'***','$'+xhex(byte(p^.asc)):5,'$'+xhex(byte(p^.code)):5,' : ');
    FOR B:=1 to length(p^.s) DO
    BEGIN
      WRITE(f,'$'+xhex(byte(p^.s[b]))+' ':5);
      len:=len+5;
      IF len>70 THEN
      BEGIN
        WRITELN(f);
        len:=0;
      END;
    END;
    WRITELN(f);
    WRITELN(f,'!!!');
    p:=p^.n;
    len:=0;
  END;
  CLOSE(f);
END;

PROCEDURE ReadMakros;
VAR code,asc:CHAR;
    s,s2,macro:STRING;
    p,p2:PkMac;
    f:text;B:BYTE;
    state:BYTE;
    err:INTEGER;
BEGIN
  ASSIGN(f,qrvpath+'KMAC.MCT');
  {$I-}
  RESET(f);
  IF IORESULT<>0 THEN exit;
  state:=0;
  WHILE NOT EOF(f) DO
  BEGIN
    READLN(f,s);
    S:=LTRIM(S)+' ';
    IF s<>' ' THEN
    CASE state OF
      0:IF COPY(s,1,3)='***' THEN
        BEGIN
          S:=LTRIM(COPY(s,4,10));
          FIND(S,' ',l,r);
          Val(rtrim(l),byte(asc),err);
          Val(ltrim(rtrim(r)),byte(code),err);
          macro:='';
          state:=1;
        END;
      1:IF COPY(s,1,3)='!!!' THEN
        BEGIN
          IF kmacroot=NIL THEN
          BEGIN
            new(kmacroot);
            p:=kmacroot;
          END ELSE
          BEGIN
            new(p^.n);
            p:=p^.n;
          END;
          p^.n:=NIL;
          p^.asc:=asc;
          p^.code:=code;
          p^.s:=macro;
          state:=0;
        END ELSE
          WHILE FIND(S,' ',S2,S) DO
          BEGIN
            inc(byte(macro[0]));
	     B:=byte(macro[length(macro)]);
	     Val(s2,B,err);
            S:=LTRIM(S);
          END;
    END;
  END;
  CLOSE(f);
END;


FUNCTION XREADKEY:CHAR;
VAR ch:CHAR;
BEGIN
  IF (makro='') AND (status=2) THEN
  BEGIN
    status:=0;
  END;
  LastKeyPressed:=CurrIxTime;
  IF CRTSaveAktiv THEN
  BEGIN
    CRTSaveAktiv:=FALSE;
    ReDrawScreen;
  END;
  IF Status=0 THEN
    XReadKey:=ReadKey ELSE
  IF STATUS=1 THEN
  BEGIN
    ch:=READKEY;
    IF (Makro[length(makro)]=#0) OR (length(makro)<253) THEN
      Makro:=makro+ch;
    XReadKey:=CH;
  END ELSE
  BEGIN
    XREADKEY:=Makro[1];
    Delete(makro,1,1);
  END;
END;
        
FUNCTION XKeyPressed:BOOLEAN;
BEGIN
  IF (Status<2) OR (makro='') THEN
    XKeyPressed:=KeyPressed
  ELSE
    XkeyPressed:=TRUE
END;

PROCEDURE Aufnehmen;
BEGIN
  IF status>0 THEN exit;
  Sound(1000);delay(100); Sound(600);delay(75); sound(800); delay(25); nosound;
  Makro:='';
  Status:=1;
END;

FUNCTION StopAufnahme:STRING;
BEGIN
  IF Status<>1 THEN exit;
  StopAufnahme:=Makro;
  Status:=0;
END;

PROCEDURE Abspielen(S :STRING) ;
BEGIN
  IF Status>0 THEN exit;
  Makro:=S;
  Status:=2;
END;

FUNCTION KMacAscii(c:char):BOOLEAN;
VAR  p:PkMac;
BEGIN
  KMacAscii:=FALSE;
  IF Status>0 THEN exit;
  p:=kmacroot;
  WHILE p<>NIL DO
  BEGIN
    IF (p^.asc=c) AND (p^.code=#0) THEN
    BEGIN
      Abspielen(p^.S);
      KMacAscii:=TRUE;
      exit;
    END;
    p:=p^.n;
  END;
END;

FUNCTION KMacScan(c:char):BOOLEAN;
VAR  p:PkMac;
BEGIN
  KMacScan:=FALSE;
  IF status>0 THEN exit;
  p:=kmacroot;
  WHILE p<>NIL DO
  BEGIN
    IF (p^.asc=#0) AND (p^.code=c) THEN
    BEGIN
      Abspielen(p^.S);
      KMacScan:=TRUE;
      exit;
    END;
    p:=p^.n;
  END;
END;


END.